/**
 * Copyright (c) 2021 OceanBase
 * OceanBase CE is licensed under Mulan PubL v2.
 * You can use this software according to the terms and conditions of the Mulan PubL v2.
 * You may obtain a copy of Mulan PubL v2 at:
 *          http://license.coscl.org.cn/MulanPubL-2.0
 * THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OF ANY KIND,
 * EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO NON-INFRINGEMENT,
 * MERCHANTABILITY OR FIT FOR A PARTICULAR PURPOSE.
 * See the Mulan PubL v2 for more details.
 */

#ifdef CTX_ITEM_DEF
CTX_ITEM_DEF(DEFAULT_CTX_ID)
CTX_ITEM_DEF(MEMSTORE_CTX_ID)
CTX_ITEM_DEF(COMPILE_CTX_ID)
CTX_ITEM_DEF(EXECUTE_CTX_ID)
CTX_ITEM_DEF(HASHJOIN_CTX_ID)
CTX_ITEM_DEF(SORT_CTX_ID)
CTX_ITEM_DEF(TRANS_CTX_MGR_ID)
CTX_ITEM_DEF(ELECTION_CTX_ID)
CTX_ITEM_DEF(MEMSTORE_OBJECT_CTX_ID)
CTX_ITEM_DEF(PARTITION_CTX_ID)
CTX_ITEM_DEF(SSSTORE_CTX_ID)
CTX_ITEM_DEF(SSTABLE_CTX_ID)
CTX_ITEM_DEF(PARTITION_STORAGE_CTX_ID)
CTX_ITEM_DEF(PARTITION_CTX_MGR_CTX_ID)
CTX_ITEM_DEF(STORAGE_LONG_TERM_META_CTX_ID)
CTX_ITEM_DEF(STORAGE_SHORT_TERM_META_CTX_ID)
CTX_ITEM_DEF(PARTITION_LOG_SERVICE_CTX_ID)
CTX_ITEM_DEF(REPLAY_STATUS_CTX_ID)
CTX_ITEM_DEF(TRANS_PART_CTX_ID)
CTX_ITEM_DEF(TRANS_COORD_CTX_ID)
CTX_ITEM_DEF(TRANS_SCHE_CTX_ID)
CTX_ITEM_DEF(OB_TRANS_LOCAL_TASK_ID)
CTX_ITEM_DEF(PLAN_CACHE_CTX_ID)
CTX_ITEM_DEF(REQ_MANAGER_CTX_ID)
CTX_ITEM_DEF(WORK_AREA)
CTX_ITEM_DEF(GLIBC)
CTX_ITEM_DEF(LOG_INDEX_CTX_ID)
CTX_ITEM_DEF(CO_STACK)
CTX_ITEM_DEF(LIBEASY)
CTX_ITEM_DEF(QUERY_EXEC_CTX_ID)
CTX_ITEM_DEF(LOGGER_CTX_ID)
CTX_ITEM_DEF(MAX_CTX_ID)
#endif

// mod_id has been unified into a string, try not to add mod_id,
// These mods are still retained here because they are more sensitive to the accuracy of statistical values
// Can't easily bypass
#ifdef MOD_ITEM_DEF
MOD_ITEM_DEF(OB_MOD_DO_NOT_USE_ME)
MOD_ITEM_DEF(TEST1)
MOD_ITEM_DEF(TEST2)
MOD_ITEM_DEF(TEST3)
MOD_ITEM_DEF(OB_PARTITION_MIGRATE)
MOD_ITEM_DEF(OB_ASYNC_EXTERNAL_SORTER)
MOD_ITEM_DEF(OB_COMMON_ARRAY)
MOD_ITEM_DEF(OB_SORT_TEMP_MACRO_READER)
MOD_ITEM_DEF(OB_SORT_TEMP_MACRO_WRITER)
MOD_ITEM_DEF(OB_SQL_AGGR_FUNC_ROW)
MOD_ITEM_DEF(OB_KVSTORE_CACHE)
MOD_ITEM_DEF(OB_KVSTORE_CACHE_MB)
MOD_ITEM_DEF(OB_SQL_PLAN_CACHE)
MOD_ITEM_DEF(OB_SQL_PHY_PLAN)
MOD_ITEM_DEF(OB_SQL_PHY_PL_OBJ)
MOD_ITEM_DEF(OB_MEMSTORE)
MOD_ITEM_DEF(OB_MOD_END)
#endif

// Label does not need to be defined here, just pass char * directly in alloc,
// It is reserved here to be compatible with the existing code of the upper layer
#ifdef LABEL_ITEM_DEF
LABEL_ITEM_DEF(OB_MOD_DO_NOT_USE_ME, ModDoNotUseMe)

LABEL_ITEM_DEF(OB_MOD_ALLOCATOR_START, ModAllocatStart)
LABEL_ITEM_DEF(OB_ALLOC_CHUNK, AllocChunk)
LABEL_ITEM_DEF(OB_ALLOC_BLOCK, AllocBlock)
LABEL_ITEM_DEF(OB_ALLOC_OBJECT, AllocObject)
LABEL_ITEM_DEF(OB_TENANT_CTX_ALLOCATOR, TenantCtxAlloca)
LABEL_ITEM_DEF(OB_TENANT_MUTIL_ALLOCATOR, TenantMutilAllo)
LABEL_ITEM_DEF(OB_MEM_META, MemMeta)
LABEL_ITEM_DEF(OB_MOD_ALLOCATOR_END, ModAllocatEnd)

LABEL_ITEM_DEF(OB_MEMORY_STAT, MemoryStat)

// debug
LABEL_ITEM_DEF(OB_COMMON_ARRAY_OB_STMT, CommArraObStmt)
LABEL_ITEM_DEF(OB_COMMON_ARRAY_OB_SELECT_STMT, CommArrObSeleSt)
LABEL_ITEM_DEF(OB_COMMON_ARRAY_OB_LOG_TABLE_SCAN, ComArrObLogTabS)
LABEL_ITEM_DEF(OB_COMMON_ARRAY_OB_LOG_PLAN, CommArrObLogPla)
LABEL_ITEM_DEF(OB_COMMON_ARRAY_OB_CANDIDATE_PLAN, CommArrObCandPl)
LABEL_ITEM_DEF(OB_COMMON_ARRAY_OB_ALL_CANDIDATE_PLAN, ComArrObAllCanP)
LABEL_ITEM_DEF(OB_COMMON_ARRAY_OB_JOIN_ORDER, CommArrObJoinOr)
LABEL_ITEM_DEF(OB_COMMON_ARRAY_OB_LOGICAL_OPER, CommArrObLogiOp)
LABEL_ITEM_DEF(OB_COMMON_ARRAY_OB_LOGICAL_JOIN_OPER, ComArrObLogJoiO)
LABEL_ITEM_DEF(OB_SE_ARRAY_OB_SHOW_CREATE_DATABASE_KEY_RANGES, SeArObShCrDaKeR)
LABEL_ITEM_DEF(OB_PAGE_ARENA_QUERY_RANGE, PageArenQuerRan)
LABEL_ITEM_DEF(OB_CON_FIFO_ALLOC, ConFifoAlloc)
LABEL_ITEM_DEF(OB_FIFO_ALLOC, FifoAlloc)
LABEL_ITEM_DEF(OB_VT_ALL_CONCUR_OBJ_POOL, VtAllConcObjPoo)
LABEL_ITEM_DEF(OB_SE_ARRAY_OB_SHOW_CREATE_TABLEGROUP_KEY_RANGES, SeArObShCrTaKeR)

// end debug
/// definemoduleshere
// commonmodules
LABEL_ITEM_DEF(OB_OBJ_FREELISTS, ObjFreelists)
LABEL_ITEM_DEF(OB_COMMON_NETWORK, CommonNetwork)
LABEL_ITEM_DEF(OB_THREAD_BUFFER, ThreadBuffer)
LABEL_ITEM_DEF(OB_VARCACHE, Varcache)
LABEL_ITEM_DEF(OB_KVSTORE_CACHE, KvstoreCache)
LABEL_ITEM_DEF(OB_KVSTORE_CACHE_ITERATOR, KvstorCacheIter)
LABEL_ITEM_DEF(OB_DIAGNOSE_INFO, DiagnoseInfo)
LABEL_ITEM_DEF(OB_SESSION_STAT, SessionStat)
LABEL_ITEM_DEF(OB_WAIT_QUEUE, WaitQueue)
LABEL_ITEM_DEF(OB_TENANT_INFO, TenantInfo)
LABEL_ITEM_DEF(OB_TSI_FACTORY, TsiFactory)
LABEL_ITEM_DEF(OB_THREAD_OBJPOOL, ThreadObjpool)
LABEL_ITEM_DEF(OB_ROW_COMPACTION, RowCompaction)
LABEL_ITEM_DEF(OB_COMMON_COMPACTOR, CommonCompactor)
LABEL_ITEM_DEF(OB_SQL_RPC_SCAN, SqlRpcScan)
LABEL_ITEM_DEF(OB_SQL_RPC_GET, SqlRpcGet)
LABEL_ITEM_DEF(OB_COMMON_ARRAY, CommonArray)
LABEL_ITEM_DEF(OB_MYSQL_REQUEST_RECORD, MysqlRequesReco)
LABEL_ITEM_DEF(OB_MYSQL_MULTI_PACKETS, MysqlMultiPacke)
LABEL_ITEM_DEF(OB_SE_ARRAY, SeArray)
LABEL_ITEM_DEF(OB_C_ARRAY, CArray)
LABEL_ITEM_DEF(OB_2D_ARRAY, 2dArray)
LABEL_ITEM_DEF(OB_LIGHTY_QUEUE, LightyQueue)
LABEL_ITEM_DEF(OB_SEQ_QUEUE, SeqQueue)
LABEL_ITEM_DEF(OB_SEQ_CONTAINER, SeqContainer)
LABEL_ITEM_DEF(OB_RECENT_CACHE, RecentCache)
LABEL_ITEM_DEF(OB_FILE_DIRECTOR_UTIL, FileDirectUtil)
LABEL_ITEM_DEF(OB_FETCH_RUNABLE, FetchRunable)
LABEL_ITEM_DEF(OB_GET_PARAM, GetParam)
LABEL_ITEM_DEF(OB_SCAN_PARAM, ScanParam)
LABEL_ITEM_DEF(OB_MUTATOR, Mutator)
LABEL_ITEM_DEF(OB_SCANNER, Scanner)
LABEL_ITEM_DEF(OB_NEW_SCANNER, NewScanner)
LABEL_ITEM_DEF(OB_MS_EVENT_SCANNER, MsEventScanner)
LABEL_ITEM_DEF(OB_MS_BF_SCAN_SCANNER, MsBfScanScanner)
LABEL_ITEM_DEF(OB_MS_BF_GET_SCANNER, MsBfGetScanner)
LABEL_ITEM_DEF(OB_BUFFER, Buffer)
LABEL_ITEM_DEF(OB_THREAD_STORE, ThreadStore)
LABEL_ITEM_DEF(OB_LOG_WRITER, LogWriter)
LABEL_ITEM_DEF(OB_LOG_READER, LogReader)
LABEL_ITEM_DEF(OB_REGEX, Regex)
LABEL_ITEM_DEF(OB_SLAB, Slab)
LABEL_ITEM_DEF(OB_SLAVE_MGR, SlaveMgr)
LABEL_ITEM_DEF(OB_THREAD_MEM_POOL, ThreadMemPool)
LABEL_ITEM_DEF(OB_HASH_BUCKET, HashBucket)
LABEL_ITEM_DEF(OB_HASH_NODE, HashNode)
LABEL_ITEM_DEF(OB_PAGE_ARENA, PageArena)
LABEL_ITEM_DEF(OB_NB_ACCESSOR, NbAccessor)
LABEL_ITEM_DEF(OB_STRING_BUF, StringBuf)
LABEL_ITEM_DEF(OB_SCHEMA, Schema)
LABEL_ITEM_DEF(OB_SCHEMA_SYS_SCHEMA, SchemaSysSchema)
LABEL_ITEM_DEF(OB_SCHEMA_TENANT_SYS_SCHEMA, ScheTenaSysSche)
LABEL_ITEM_DEF(OB_SCHEMA_ROW_KEY, SchemaRowKey)
LABEL_ITEM_DEF(OB_SCHEMA_PRIV_TENANT_INFO, SchePrivTenaInf)
LABEL_ITEM_DEF(OB_SCHEMA_PRIV_NAME_MAP, SchePrivNameMap)
LABEL_ITEM_DEF(OB_SCHEMA_PRIV_USER_INFO, SchePrivUserInf)
LABEL_ITEM_DEF(OB_SCHEMA_PRIV_DB_PRIVS, SchePrivDbPrivs)
LABEL_ITEM_DEF(OB_SCHEMA_PRIV_TABLE_PRIVS, SchePrivTablPri)
LABEL_ITEM_DEF(OB_SCHEMA_PRIV_TABLE_PRIV_MAP, SchePriTabPriMa)
LABEL_ITEM_DEF(OB_SCHEMA_PRIV_LOCAL_ALLOCATOR, SchePrivLocaAll)
LABEL_ITEM_DEF(OB_SCHEMA_PRIV_SYS_PRIVS, SchePrivSysPriv)
LABEL_ITEM_DEF(OB_SCHEMA_PRIV_OBJ_PRIVS, SchePrivObjPriv)
LABEL_ITEM_DEF(OB_SCHEMA_PRIV_OBJ_PRIV_MAP, SchePriObjPriMa)
LABEL_ITEM_DEF(OB_SCHEMA_OPERATOR_SET_WITH_ALLOC, ScheOpeSetWitAl)
LABEL_ITEM_DEF(OB_SCHEMA_TABLE_INFOS, SchemaTableInfo)
LABEL_ITEM_DEF(OB_SCHEMA_INDEX_TABLE_INFOS, ScheIndeTablInf)
LABEL_ITEM_DEF(OB_SCHEMA_DATABASE_INFOS, SchemaDatabInfo)
LABEL_ITEM_DEF(OB_SCHEMA_TABLEGROUP_INFOS, SchemaTableInfo)
LABEL_ITEM_DEF(OB_SCHEMA_MAP, SchemaMap)
LABEL_ITEM_DEF(OB_SCHEMA_MAP_GUARD, SchemaMapGuard)
LABEL_ITEM_DEF(OB_SCHEMA_MVSS_TABLE_INFO_VEC, ScheMvsTabInfVe)
LABEL_ITEM_DEF(OB_SCHEMA_TENANT_NAME_MAP, ScheTenaNameMap)
LABEL_ITEM_DEF(OB_SCHEMA_USER_NAME_MAP, ScheUserNameMap)
LABEL_ITEM_DEF(OB_SCHEMA_TABLE_ID_MAP, ScheTablIdMap)
LABEL_ITEM_DEF(OB_SCHEMA_TABLE_NAME_MAP, ScheTablNameMap)
LABEL_ITEM_DEF(OB_SCHEMA_INDEX_ID_MAP, ScheIndeIdMap)
LABEL_ITEM_DEF(OB_SCHEMA_INDEX_NAME_MAP, ScheIndeNameMap)
LABEL_ITEM_DEF(OB_SCHEMA_FOREIGN_KEY_NAME_MAP, ScheForKeyNamMa)
LABEL_ITEM_DEF(OB_SCHEMA_CONSTRAINT_NAME_MAP, ScheConsNameMap)
LABEL_ITEM_DEF(OB_SCHEMA_TABLEGROUP_NAME_MAP, ScheTablNameMap)
LABEL_ITEM_DEF(OB_SCHEMA_DATABASE_NAME_MAP, ScheDataNameMap)
LABEL_ITEM_DEF(OB_SCHEMA_CACHE_SYS_CACHE_VALUE, ScheCacSysCacVa)
LABEL_ITEM_DEF(OB_SCHEMA_TENANT_NAME_CASE_MODE_MAP, SchTenNamCasMoM)
LABEL_ITEM_DEF(OB_SCHEMA_TENANT_NAME_SCHEMA_MAP, ScheTenNamSchMa)
LABEL_ITEM_DEF(OB_SCHEMA_TENANT_INFO_VEC, ScheTenaInfoVec)
LABEL_ITEM_DEF(OB_SCHEMA_USER_INFO_VEC, ScheUserInfoVec)
LABEL_ITEM_DEF(OB_SCHEMA_DB_INFO_VEC, ScheDbInfoVec)
LABEL_ITEM_DEF(OB_SCHEMA_TABLEG_INFO_VEC, ScheTablInfoVec)
LABEL_ITEM_DEF(OB_SCHEMA_TABLE_INFO_VEC, ScheTablInfoVec)
LABEL_ITEM_DEF(OB_SCHEMA_INDEX_INFO_VEC, ScheIndeInfoVec)
LABEL_ITEM_DEF(OB_SCHEMA_AUX_VP_INFO_VEC, ScheAuxVpInfoVe)
LABEL_ITEM_DEF(OB_SCHEMA_AUX_VP_NAME_VEC, ScheAuxVpNameVe)
LABEL_ITEM_DEF(OB_SCHEMA_NAME, SchemaName)
LABEL_ITEM_DEF(OB_SCHEMA_PRIV, SchemaPriv)
LABEL_ITEM_DEF(OB_SCHEMA_ID_VERSIONS, SchemaIdVersion)
LABEL_ITEM_DEF(OB_SCHEMA_CACHE_SYS_CACHE_MAP, ScheCacSysCacMa)
LABEL_ITEM_DEF(OB_SCHEMA_GETTER_GUARD, SchemaGetteGuar)
LABEL_ITEM_DEF(OB_SCHEMA_MGR, SchemaMgr)
LABEL_ITEM_DEF(OB_SCHEMA_MGR_FOR_ROLLBACK, ScheMgrForRollb)
LABEL_ITEM_DEF(OB_SCHEMA_UPDATE_INFO, SchemaUpdatInfo)
LABEL_ITEM_DEF(OB_SCHEMA_MANAGER_LOCAL_ALLOCATOR, ScheManaLocaAll)
LABEL_ITEM_DEF(OB_SCHEMA_OB_SCHEMA_ARENA, ScheObSchemAren)
LABEL_ITEM_DEF(OB_SCHEMA_SERVICE, SchemaService)
LABEL_ITEM_DEF(OB_SCHEMA_MAX_USED_TABLE_ID_MAP, SchMaxUseTabIdM)
LABEL_ITEM_DEF(OB_SCHEMA_OUTLINE_INFO_VECTOR, ScheOutlInfoVec)
LABEL_ITEM_DEF(OB_SCHEMA_OUTLINE_ID_MAP, ScheOutlIdMap)
LABEL_ITEM_DEF(OB_SCHEMA_OUTLINE_NAME_MAP, ScheOutlNameMap)
LABEL_ITEM_DEF(OB_SCHEMA_OUTLINE_SQL_MAP, ScheOutlSqlMap)
LABEL_ITEM_DEF(OB_SCHEMA_OUTLINE_LOCAL_ALLOCATOR, ScheOutlLocaAll)
LABEL_ITEM_DEF(OB_SCHEMA_OUTLINE_PARAM, SchemaOutliPara)
LABEL_ITEM_DEF(OB_SCHEMA_PLAN_BASELINE_INFO_VECTOR, SchePlaBasInfVe)
LABEL_ITEM_DEF(OB_SCHEMA_PLAN_BASELINE_INFO_MAP, SchePlaBasInfMa)
LABEL_ITEM_DEF(OB_SCHEMA_PLAN_BASELINE_INFO_MAP_NODE, SchPlaBasInfMaN)
LABEL_ITEM_DEF(OB_SCHEMA_ROUTINE_INFO_VECTOR, ScheRoutInfoVec)
LABEL_ITEM_DEF(OB_SCHEMA_ROUTINE_ID_MAP, ScheRoutIdMap)
LABEL_ITEM_DEF(OB_SCHEMA_ROUTINE_NAME_MAP, ScheRoutNameMap)
LABEL_ITEM_DEF(OB_SCHEMA_ROUTINE_SQL_MAP, ScheRoutSqlMap)
LABEL_ITEM_DEF(OB_SCHEMA_ROUTINE_LOCAL_ALLOCATOR, ScheRoutLocaAll)
LABEL_ITEM_DEF(OB_SCHEMA_ROUTINE_PARAM, SchemaRoutiPara)
LABEL_ITEM_DEF(OB_SCHEMA_PACKAGE_INFO_VECTOR, SchePackInfoVec)
LABEL_ITEM_DEF(OB_SCHEMA_PACKAGE_ID_MAP, SchePackIdMap)
LABEL_ITEM_DEF(OB_SCHEMA_PACKAGE_NAME_MAP, SchePackNameMap)
LABEL_ITEM_DEF(OB_SCHEMA_TRIGGER_INFO_VECTOR, ScheTrigInfoVec)
LABEL_ITEM_DEF(OB_SCHEMA_TRIGGER_ID_MAP, ScheTrigIdMap)
LABEL_ITEM_DEF(OB_SCHEMA_TRIGGER_NAME_MAP, ScheTrigNameMap)
LABEL_ITEM_DEF(OB_SCHEMA_UDT_INFO_VECTOR, ScheUdtInfoVect)
LABEL_ITEM_DEF(OB_SCHEMA_UDT_ID_MAP, ScheUdtIdMap)
LABEL_ITEM_DEF(OB_SCHEMA_UDT_NAME_MAP, ScheUdtNameMap)
LABEL_ITEM_DEF(OB_SCHEMA_RPC_BUF, SchemaRpcBuf)
LABEL_ITEM_DEF(OB_SCHEMA_SYNONYM, SchemaSynonym)
LABEL_ITEM_DEF(OB_SCHEMA_UDF, SchemaUdf)
LABEL_ITEM_DEF(OB_SCHEMA_SYS_VARIABLE, SchemaSysVariab)
LABEL_ITEM_DEF(OB_SCHEMA_SEQUENCE, SchemaSequence)
LABEL_ITEM_DEF(OB_SCHEMA_RG_INFO_VEC, ScheRgInfoVec)
LABEL_ITEM_DEF(OB_SCHEMA_RG_ID_MAP, ScheRgIdMap)
LABEL_ITEM_DEF(OB_ROW_ITER_ADAPTOR, RowIterAdaptor)
LABEL_ITEM_DEF(OB_WAITABLE_POOL, WaitablePool)
LABEL_ITEM_DEF(OB_ASYNC_FILE_APPENDER, AsyncFileAppend)
LABEL_ITEM_DEF(OB_PLAN_EXECUTE, PlanExecute)
LABEL_ITEM_DEF(OB_MODULE_PAGE_ALLOCATOR, ModulePageAlloc)
LABEL_ITEM_DEF(OB_FIXED_SIZE_BLOCK_ALLOCATOR, FixeSizeBlocAll)
LABEL_ITEM_DEF(OB_PACKET_LIGHTY_QUEUE, PacketLightQueu)
LABEL_ITEM_DEF(OB_RESULT_SET, ResultSet)
LABEL_ITEM_DEF(OB_FIRST_TABLET_META, FirstTabletMeta)
LABEL_ITEM_DEF(OB_FILE_CLIENT, FileClient)
LABEL_ITEM_DEF(OB_OLD_GROUPBY, OldGroupby)
LABEL_ITEM_DEF(OB_MEM_BUFFER, MemBuffer)
LABEL_ITEM_DEF(OB_USER_INFO_KEY, UserInfoKey)
LABEL_ITEM_DEF(OB_PERM_INFO, PermInfo)
LABEL_ITEM_DEF(OB_SKEY_INFO_KEY, SkeyInfoKey)
LABEL_ITEM_DEF(OB_FIXED_QUEUE, FixedQueue)
LABEL_ITEM_DEF(OB_PACKET_QUEUE, PacketQueue)
LABEL_ITEM_DEF(OB_POOL, Pool)
LABEL_ITEM_DEF(OB_BLOOM_FILTER, BloomFilter)
LABEL_ITEM_DEF(COMPACT_ROW, CompactRow)
LABEL_ITEM_DEF(SPOP_QUEUE, SpopQueue)
LABEL_ITEM_DEF(BUCKET_LOCK, BucketLock)
LABEL_ITEM_DEF(ID_MAP, IdMap)
LABEL_ITEM_DEF(LIB_OBSQL, LibObsql)
LABEL_ITEM_DEF(LIB_MYSQL_COMPRESS, LibMysqlCompres)
LABEL_ITEM_DEF(LIB_MULTI_PACKETS, LibMultiPackets)
LABEL_ITEM_DEF(BLOCK_ALLOC, BlockAlloc)
LABEL_ITEM_DEF(VECTOR, Vector)
LABEL_ITEM_DEF(TEST, Test)
LABEL_ITEM_DEF(TEST_SERVICE, TestService)
LABEL_ITEM_DEF(OB_OSS, Oss)
LABEL_ITEM_DEF(QUERY_RESULT_READER, QueryResultRead)
LABEL_ITEM_DEF(MYSQL_CLIENT_CACHE, MysqlClientCach)
LABEL_ITEM_DEF(SQL_CLIENT_READ_RESULT, SqlClienReadRes)
LABEL_ITEM_DEF(TICKET_QUEUE, TicketQueue)
LABEL_ITEM_DEF(ACK_QUEUE, AckQueue)
LABEL_ITEM_DEF(BALANCE_FILTER, BalanceFilter)
LABEL_ITEM_DEF(TSI_BLOCK_ALLOC, TsiBlockAlloc)
LABEL_ITEM_DEF(JSON_PARSER, JsonParser)
LABEL_ITEM_DEF(OB_CELL_CHECKER, CellChecker)
LABEL_ITEM_DEF(OB_HASH_BUCKET_CONF_CONTAINER, HashBuckConfCon)
LABEL_ITEM_DEF(OB_HASH_BUCKET_SQL_COLUMN_MAP, HashBucSqlColMa)
LABEL_ITEM_DEF(OB_HASH_BUCKET_TASK_MAP, HashBuckTaskMap)
LABEL_ITEM_DEF(OB_HASH_BUCKET_LRU_CACHE, HashBuckLruCach)
LABEL_ITEM_DEF(OB_HASH_BUCKET_THREAD_LOCAL_INFO, HashBucThrLocIn)
LABEL_ITEM_DEF(OB_HASH_BUCKET_NEXT_WAIT_MAP, HashBucNexWaiMa)
LABEL_ITEM_DEF(OB_HASH_BUCKET_PRIVILEGE, HashBucketPrivi)
LABEL_ITEM_DEF(OB_HASH_BUCKET_SHRINK_CONTAINER, HashBuckShriCon)
LABEL_ITEM_DEF(OB_HASH_BUCKET_MESSAGE_POOL, HashBuckMessPoo)
LABEL_ITEM_DEF(OB_HASH_NODE_CONF_CONTAINER, HashNodeConfCon)
LABEL_ITEM_DEF(OB_HASH_NODE_SQL_COLUMN_MAP, HashNodSqlColMa)
LABEL_ITEM_DEF(OB_HASH_NODE_TASK_MAP, HashNodeTaskMap)
LABEL_ITEM_DEF(OB_HASH_NODE_LRU_CACHE, HashNodeLruCach)
LABEL_ITEM_DEF(OB_HASH_NODE_THREAD_LOCAL_INFO, HashNodThrLocIn)
LABEL_ITEM_DEF(OB_HASH_NODE_NEXT_WAIT_MAP, HashNodNexWaiMa)
LABEL_ITEM_DEF(OB_HASH_NODE_PRIVILEGE, HashNodePrivile)
LABEL_ITEM_DEF(OB_HASH_NODE_SHRINK_CONTAINER, HashNodeShriCon)
LABEL_ITEM_DEF(OB_HASH_NODE_MESSAGE_POOL, HashNodeMessPoo)
LABEL_ITEM_DEF(OB_RPC_ROOT_TABLE, RpcRootTable)
LABEL_ITEM_DEF(OB_SQL_STRING, SqlString)
LABEL_ITEM_DEF(OB_INNER_SQL_CONN_POOL, InneSqlConnPool)
LABEL_ITEM_DEF(OB_JSON_PARSER, JsonParser)
LABEL_ITEM_DEF(OB_LINEAR_HASH_MAP, LinearHashMap)
LABEL_ITEM_DEF(OB_CONCURRENCY_OBJ_POOL, ConcurObjPool)
LABEL_ITEM_DEF(OB_AUTOINCREMENT, Autoincrement)
LABEL_ITEM_DEF(OB_AUTOINCREMENT_PART_MAP, AutoinPartMap)
LABEL_ITEM_DEF(OB_CORE_TABLE_PROXY, CoreTableProxy)
LABEL_ITEM_DEF(OB_BIT_MAP, BitMap)
LABEL_ITEM_DEF(OB_BIT_SET, BitSet)
LABEL_ITEM_DEF(OB_HASH_BUCKET_GLOBAL_STATUS_MAP, HashBucGloStaMa)
LABEL_ITEM_DEF(OB_HASH_BUCKET_SESSION_STATUS_MAP, HashBucSesStaMa)
LABEL_ITEM_DEF(OB_COMMON_SYS_VAR_FAC, CommSysVarFac)
LABEL_ITEM_DEF(OB_COMMON_SYS_VAR_DEFAULT_VALUE, CommSysVarDefVa)
LABEL_ITEM_DEF(OB_ASYNC_EXTERNAL_SORTER, AsyncExternSort)
LABEL_ITEM_DEF(OB_CORE_LOCAL_STORAGE, CoreLocalStorag)
LABEL_ITEM_DEF(OB_SMALL_OBJ_POOL, SmallObjPool)
LABEL_ITEM_DEF(OB_EXT_MS_QUEUE, ExtMsQueue)
LABEL_ITEM_DEF(OB_EXT_MS_QUEUE_QITEM, ExtMsQueueQitem)
LABEL_ITEM_DEF(OB_PARTITION_TABLE_TASK, PartitTableTask)
LABEL_ITEM_DEF(OB_TEMP_VARIABLES, TempVariables)
LABEL_ITEM_DEF(OB_EXTERNAL_SORTER, ExternalSorter)
LABEL_ITEM_DEF(OB_OBJ_STORE, ObjStore)
LABEL_ITEM_DEF(OB_ARENA_HASH_JOIN, ArenaHashJoin)
LABEL_ITEM_DEF(OB_SCHEDULER, Scheduler)
LABEL_ITEM_DEF(OB_HASH_BUCKET_DAG_MAP, HashBuckDagMap)
LABEL_ITEM_DEF(OB_LINK_STACK, LinkStack)
LABEL_ITEM_DEF(OB_SERVER_LOCALITY_CACHE, ServerLocalCach)
LABEL_ITEM_DEF(OB_SERVER_CID_MAP, ServerCidMap)
LABEL_ITEM_DEF(OB_SERVER_REGION_MAP, ServerRegioMap)
LABEL_ITEM_DEF(OB_SERVER_IDC_MAP, ServerIdcMap)
LABEL_ITEM_DEF(OB_IO_CONTROL, IoControl)
LABEL_ITEM_DEF(OB_IO_CACHE_BLOCK, IoCacheBlock)
LABEL_ITEM_DEF(OB_IO_QUEUE, IoQueue)
LABEL_ITEM_DEF(OB_IO_MAP, IoMap)
LABEL_ITEM_DEF(OB_COMPRESSOR, Compressor)
LABEL_ITEM_DEF(OB_KVSTORE_CACHE_WASH_STRUCT, KvstCachWashStr)
LABEL_ITEM_DEF(OB_KVSTORE_CACHE_MB, KvstorCacheMb)
LABEL_ITEM_DEF(OB_SERVER_OBJECT_POOL, ServerObjecPool)
LABEL_ITEM_DEF(OB_CACHE_LINE_SEGREGATED_ARRAY, CachLineSegrArr)
LABEL_ITEM_DEF(OB_MACRO_BLOCK_CHECKER, MacroBlockCheck)
LABEL_ITEM_DEF(OB_STREAM_COMPRESSOR, StreamCompresso)
LABEL_ITEM_DEF(OB_REQ_DESERIALIZATION, ReqDeserializat)
LABEL_ITEM_DEF(OB_NUMBER, Number)
LABEL_ITEM_DEF(OB_PAGE_MANAGER, PageManager)
LABEL_ITEM_DEF(OB_SCHEMA_PROFILE, SchemaProfile)

// obproxy
LABEL_ITEM_DEF(OB_PROXY_SESSION, ProxySession)
LABEL_ITEM_DEF(OB_PROXY_DEFAULT_SYS_VARIABLE, ProxDefaSysVari)
LABEL_ITEM_DEF(OB_PROXY_SQL_PARSE, ProxySqlParse)
LABEL_ITEM_DEF(OB_PROXY_STAT, ProxyStat)
LABEL_ITEM_DEF(OB_PROXY_COMMON_DQ, ProxyCommonDq)
LABEL_ITEM_DEF(OB_PROXY_UTILS, ProxyUtils)
LABEL_ITEM_DEF(OB_PROXY_RESULTSET_FETCHER, ProxyResultFetc)
LABEL_ITEM_DEF(OB_PROXY_FILE, ProxyFile)
LABEL_ITEM_DEF(OB_PROXY_TABLE_ENTRY_MAP, ProxTablEntrMap)
LABEL_ITEM_DEF(OB_PROXY_CONGESTION_ENTRY_MAP, ProxCongEntrMap)
LABEL_ITEM_DEF(OB_PROXY_PRINTF, ProxyPrintf)
LABEL_ITEM_DEF(SHARE_CS_FEEDBACKS, ShareCsFeedback)

// mergeservermodules
LABEL_ITEM_DEF(OB_MS_CELL_ARRAY, MsCellArray)
LABEL_ITEM_DEF(OB_MS_LOCATION_CACHE, MsLocatioCache)
LABEL_ITEM_DEF(OB_MS_BTREE, MsBtree)
LABEL_ITEM_DEF(OB_MS_RPC, MsRpc)
LABEL_ITEM_DEF(OB_MS_JOIN_CACHE, MsJoinCache)
LABEL_ITEM_DEF(OB_MS_REQUEST_EVENT, MsRequestEvent)
LABEL_ITEM_DEF(OB_MS_RPC_EVENT, MsRpcEvent)
LABEL_ITEM_DEF(OB_MS_GET_EVENT, MsGetEvent)
LABEL_ITEM_DEF(OB_MS_SERVICE_FUNC, MsServiceFunc)
LABEL_ITEM_DEF(OB_MS_FROZEN_DATA_CACHE, MsFrozeDataCach)
LABEL_ITEM_DEF(OB_FROZEN_DATA_KEY_BUF, FrozDataKeyBuf)
LABEL_ITEM_DEF(OB_MS_COMMON, MsCommon)
LABEL_ITEM_DEF(OB_MS_SUB_SCAN_REQUEST, MsSubScanReques)
LABEL_ITEM_DEF(OB_MS_UPDATE_BLOOM_FILTER, MsUpdatBloomFil)
LABEL_ITEM_DEF(OB_MS_SQL_SCAN_REQ_POOL, MsSqlScanReqPoo)
LABEL_ITEM_DEF(OB_MS_SQL_GET_REQ_POOL, MsSqlGetReqPool)
LABEL_ITEM_DEF(OB_HASH_BUCKET_MS_COUNTER, HashBuckMsCount)
LABEL_ITEM_DEF(OB_MS_TABLE_PREFIX_STAT, MsTablePrefiSta)
LABEL_ITEM_DEF(OB_SHARDING_RESULT, ShardingResult)
LABEL_ITEM_DEF(OB_MS_ROOT_TABLE_TEMP, MsRootTableTemp)
LABEL_ITEM_DEF(OB_MS_FETCH_LOCATION, MsFetchLocation)
// hashmap

// updateservermodules
LABEL_ITEM_DEF(OB_UPS_ENGINE, UpsEngine)
LABEL_ITEM_DEF(OB_UPS_MEMTABLE, UpsMemtable)
LABEL_ITEM_DEF(OB_UPS_LOG, UpsLog)
LABEL_ITEM_DEF(OB_UPS_SCHEMA, UpsSchema)
LABEL_ITEM_DEF(OB_UPS_RESOURCE_POOL_NODE, UpsResouPoolNod)
LABEL_ITEM_DEF(OB_UPS_RESOURCE_POOL_ARRAY, UpsResouPoolArr)
LABEL_ITEM_DEF(OB_UPS_PARAM_DATA, UpsParamData)
LABEL_ITEM_DEF(OB_UPS_SESSION_CTX, UpsSessionCtx)
LABEL_ITEM_DEF(OB_UPS_LOG_REPLAY_WORKER, UpsLogReplaWork)
LABEL_ITEM_DEF(OB_UPS_TRANS_EXECUTOR_TASK, UpsTransExecTas)
LABEL_ITEM_DEF(OB_UPS_RESULT, UpsResult)
LABEL_ITEM_DEF(OB_UPS_PHYPLAN_ALLOCATOR, UpsPhyplanAlloc)
LABEL_ITEM_DEF(OB_UPS_QUERY, UpsQuery)
LABEL_ITEM_DEF(OB_UPS_DATA_BLOCK, UpsDataBlock)
LABEL_ITEM_DEF(OB_UPS_SSTABLE_MGR, UpsSstableMgr)
LABEL_ITEM_DEF(OB_UPS_COMMON, UpsCommon)
LABEL_ITEM_DEF(OB_HASH_BUCKET_HASH_ENGINE_MAP, HashBucHasEngMa)
LABEL_ITEM_DEF(OB_HASH_BUCKET_HASH_ENGINE_INDEX_MAP, HasBucHasEngInM)
LABEL_ITEM_DEF(OB_HASH_BUCKET_QUERY_ENGINE, HashBuckQuerEng)
LABEL_ITEM_DEF(OB_HASH_BUCKET_SCHEMA_NAME_MAP, HashBucSchNamMa)
LABEL_ITEM_DEF(OB_HASH_BUCKET_SCHEMA_ID_MAP, HashBucSchIdMap)
LABEL_ITEM_DEF(OB_HASH_BUCKET_SSTABLE_INFO_MAP, HashBucSstInfMa)
LABEL_ITEM_DEF(OB_HASH_BUCKET_STORE_DEV_MAP, HashBucStoDevMa)
LABEL_ITEM_DEF(OB_CAST_TSI_BUFF, CastTsiBuff)

// oceanbase server modules
LABEL_ITEM_DEF(OCEANBASE_SERVER, OceanbasServer)
LABEL_ITEM_DEF(OMT, Omt)
LABEL_ITEM_DEF(OMT_VIRTUAL_TABLE, OmtVirtualTable)
LABEL_ITEM_DEF(OMT_TOKEN_CALCER, OmtTokenCalcer)
LABEL_ITEM_DEF(OMT_NODE_BALANCER, OmtNodeBalancer)
LABEL_ITEM_DEF(OMT_TENANT, OmtTenant)
LABEL_ITEM_DEF(OB_HASH_BUCKET_PT_CHECKER_MAP, HashBucPtChecMa)
LABEL_ITEM_DEF(OB_HASH_BUCKET_TABLE_STATISTICS, HashBuckTablSta)
LABEL_ITEM_DEF(OB_SQL_ARENA, SqlArena)
LABEL_ITEM_DEF(OB_WORKER_EXECUTION, WorkerExecution)
LABEL_ITEM_DEF(OB_DUTY_TASK, DutyTask)

// chunkservermodules
LABEL_ITEM_DEF(OB_CS_SSTABLE_READER, CsSstableReader)
LABEL_ITEM_DEF(OB_CS_TABLET_IMAGE, CsTabletImage)
LABEL_ITEM_DEF(OB_CS_DELETE_TABLET, CsDeleteTablet)
LABEL_ITEM_DEF(OB_CS_COMMIT_LOG, CsCommitLog)
LABEL_ITEM_DEF(OB_CS_IMPORT_SSTABLE, CsImportSstable)
LABEL_ITEM_DEF(OB_CS_SERVICE_FUNC, CsServiceFunc)
LABEL_ITEM_DEF(OB_CS_BUILD_INDEX, CsBuildIndex)
LABEL_ITEM_DEF(OB_CS_MERGER, CsMerger)
LABEL_ITEM_DEF(OB_CS_COMMON, CsCommon)
LABEL_ITEM_DEF(OB_CS_FILE_RECYCLE, CsFileRecycle)
LABEL_ITEM_DEF(OB_CS_BLOOM_FILTER, CsBloomFilter)
LABEL_ITEM_DEF(OB_CS_ROOT_TABLE_TEMP, CsRootTableTemp)
LABEL_ITEM_DEF(OB_CS_MACRO_BLOCK_STATISTICS_BUCKET, CsMacrBlocStaBu)
LABEL_ITEM_DEF(OB_CS_MACRO_BLOCK_STATISTICS_ITEM, CsMacrBlocStaIt)
LABEL_ITEM_DEF(OB_CS_DISK_BALANCE, CsDiskBalance)
LABEL_ITEM_DEF(OB_CS_ROW_READER, CsRowReader)

// sstablemodules
LABEL_ITEM_DEF(OB_SSTABLE, Sstable)
LABEL_ITEM_DEF(OB_SSTABLE_AIO, SstableAio)
LABEL_ITEM_DEF(OB_SSTABLE_AIO_BUFFER_ARRAY, SstaAioBuffeArr)
LABEL_ITEM_DEF(OB_SSTABLE_GET_SCAN, SstablGetScan)
LABEL_ITEM_DEF(OB_SSTABLE_WRITER, SstableWriter)
LABEL_ITEM_DEF(OB_SSTABLE_READER, SstableReader)
LABEL_ITEM_DEF(OB_SSTABLE_GET_PARAM, SstablGetParam)
LABEL_ITEM_DEF(OB_SSTABLE_INDEX, SstableIndex)
LABEL_ITEM_DEF(OB_SSTABLE_SCHEMA, SstableSchema)
LABEL_ITEM_DEF(OB_SSTABLE_BLOCK_FILE, SstablBlockFile)
LABEL_ITEM_DEF(OB_SSTABLE_BLOCK_INDEX, SstablBlockInde)
LABEL_ITEM_DEF(OB_MACRO_BLOCK_META, MacroBlockMeta)
LABEL_ITEM_DEF(OB_MACRO_BLOCK_META_TEMP, MacrBlocMetaTem)
LABEL_ITEM_DEF(OB_HASH_BUCKET_COLUMN_SCHEMA_MAP, HashBucColSchMa)
LABEL_ITEM_DEF(OB_STORE_ROW_GETTER, StoreRowGetter)
LABEL_ITEM_DEF(OB_STORE_ROW_SCANNER, StoreRowScanner)
LABEL_ITEM_DEF(OB_STORE_ROW_EXISTER, StoreRowExister)
LABEL_ITEM_DEF(OB_STORE_ROW_MULTI_SCANNER, StorRowMultiSca)
LABEL_ITEM_DEF(OB_STORE_ROW_MULTI_SCAN_ESTIMATOR, StorRowMulScaEs)
LABEL_ITEM_DEF(OB_SSTABLE_BLOCK_ID_SET, SstaBlocIdSet)
LABEL_ITEM_DEF(OB_SSTABLE_LOB_BLOCK_ID_MAP, SstaLobBloIdMap)
LABEL_ITEM_DEF(OB_SORT_TEMP_MACRO_READER, SortTempMacrRea)
LABEL_ITEM_DEF(OB_SORT_TEMP_MACRO_WRITER, SortTempMacrWri)
LABEL_ITEM_DEF(OB_SSTABLE_HANDLE_MANAGER, SstablHandlMana)
LABEL_ITEM_DEF(OB_BUILD_INDEX_SCHEDULER, BuildIndexSched)
LABEL_ITEM_DEF(OB_LOB_READER, LobReader)
LABEL_ITEM_DEF(OB_LOB_WRITER, LobWriter)
LABEL_ITEM_DEF(OB_BF_DATA_READER, BfDataReader)
LABEL_ITEM_DEF(OB_BF_DATA_WRITER, BfDataWriter)
LABEL_ITEM_DEF(OB_MACRO_BLOCK_META_MAJOR_KEY_MAP, MacBloMetMajKeM)
LABEL_ITEM_DEF(OB_ENCODER_ALLOCATOR, EncoderAllocato)
LABEL_ITEM_DEF(OB_SUPER_BLOCK_BUFFER, SuperBlockBuffe)
LABEL_ITEM_DEF(OB_DECODER_CTX, DecoderCtx)
LABEL_ITEM_DEF(OB_MACRO_BLOCK_WRITE_CTX, MacrBlocWritCtx)
LABEL_ITEM_DEF(OB_META_BLOCK_READER, MetaBlockReader)
LABEL_ITEM_DEF(OB_IO_MASTER, IoMaster)
LABEL_ITEM_DEF(OB_SSTABLE_BLOCK_BIT_MAP, SstaBlocBitMap)
LABEL_ITEM_DEF(OB_SSTABLE_MICRO_BLOCK_ALLOCATOR, SstaMicrBlocAll)
LABEL_ITEM_DEF(OB_STORE_ROW_LOCK_CHECKER, StorRowLockChec)
LABEL_ITEM_DEF(OB_STORE_FILE_SYSTEM, StoreFileSystem)
LABEL_ITEM_DEF(OB_HASH_BUCKET_SVR_META_MGR, HashBucSvrMetMg)
LABEL_ITEM_DEF(OB_HASH_NODE_SVR_META_MGR, HashNodSvrMetMg)
LABEL_ITEM_DEF(OB_TENANT_FILE_MGR, TenantFileMgr)

// obmysqlmodules
LABEL_ITEM_DEF(OB_MYSQL_PACKET, MysqlPacket)
LABEL_ITEM_DEF(OB_DELETE_SESSION_TASK, DeleteSessiTask)

// rootservermodules
LABEL_ITEM_DEF(OB_RS_ROOT_TABLE, RsRootTable)
LABEL_ITEM_DEF(OB_RS_ROOT_TABLE_TEMP, RsRootTableTemp)
LABEL_ITEM_DEF(OB_RS_SYS_LOCATION_CACHE, RsSysLocatiCach)
LABEL_ITEM_DEF(OB_LOCATION_CACHE_QUEUE, LocatiCacheQueu)
LABEL_ITEM_DEF(OB_RS_ROOT_TABLE_CACHE, RsRootTableCach)
LABEL_ITEM_DEF(OB_RS_META_TABLE_CACHE, RsMetaTableCach)
LABEL_ITEM_DEF(OB_RS_TABLET_ITER, RsTabletIter)
LABEL_ITEM_DEF(OB_RS_TABLET_MANAGER, RsTabletManager)
LABEL_ITEM_DEF(OB_RS_SERVER_MANAGER, RsServerManager)
LABEL_ITEM_DEF(OB_RS_SCHEMA_MANAGER, RsSchemaManager)
LABEL_ITEM_DEF(OB_SCHEMA_DEDUP_QUEUE, SchemaDedupQueu)
LABEL_ITEM_DEF(OB_RS_LOG_WORKER, RsLogWorker)
LABEL_ITEM_DEF(OB_RS_CHECK_ALL_SERVER, RsCheckAllServe)
LABEL_ITEM_DEF(OB_RS_TIMER_TASK_MANAGER, RsTimerTaskMana)
LABEL_ITEM_DEF(OB_HASH_BUCKET_BALANCER, HashBucketBalan)
LABEL_ITEM_DEF(OB_HASH_BUCKET_USER_RT_PROXY_MOCK, HasBucUseRtProM)
LABEL_ITEM_DEF(OB_HASH_BUCKET_FIRST_RT_PROXY_MOCK, HasBucFirRtProM)
LABEL_ITEM_DEF(OB_HASH_BUCKET_ALL_ROOT_TABLETS, HashBucAllRooTa)
LABEL_ITEM_DEF(OB_RS_TABLET_LIST, RsTabletList)
LABEL_ITEM_DEF(OB_RS_TABLET_INFO, RsTabletInfo)
LABEL_ITEM_DEF(OB_REBALANCE_TASK_MGR, RebalaTaskMgr)
LABEL_ITEM_DEF(OB_ROOT_TABLE_BUF, RootTableBuf)
LABEL_ITEM_DEF(OB_RS_PARTITION_TABLE_TEMP, RsPartiTableTem)
LABEL_ITEM_DEF(OB_ZONE_TABLE_UPDATER, ZoneTableUpdate)
LABEL_ITEM_DEF(OB_HASH_BUCKET_SERVER_CNT_MAP, HashBucSerCntMa)
LABEL_ITEM_DEF(OB_HASH_BUCKET_SCHEMA_ZONE_MAP, HashBucSchZonMa)
LABEL_ITEM_DEF(OB_HASH_BUCKET_POOL_UNIT_MAP, HashBucPooUniMa)
LABEL_ITEM_DEF(OB_HASH_BUCKET_CONFIG_POOLS_MAP, HashBucConPooMa)
LABEL_ITEM_DEF(OB_HASH_BUCKET_SERVER_REF_COUNT_MAP, HasBucSerRefCoM)
LABEL_ITEM_DEF(OB_HASH_BUCKET_ID_UNIT_MAP, HashBucIdUnitMa)
LABEL_ITEM_DEF(OB_HASH_BUCKET_ID_CONFIG_MAP, HashBucIdConfMa)
LABEL_ITEM_DEF(OB_HASH_BUCKET_NAME_CONFIG_MAP, HashBucNamConMa)
LABEL_ITEM_DEF(OB_HASH_BUCKET_CONFIG_REF_COUNT_MAP, HasBucConRefCoM)
LABEL_ITEM_DEF(OB_HASH_BUCKET_ID_POOL_MAP, HashBucIdPoolMa)
LABEL_ITEM_DEF(OB_HASH_BUCKET_NAME_POOL_MAP, HashBucNamPooMa)
LABEL_ITEM_DEF(OB_HASH_BUCKET_SERVER_UNITLOAD_MAP, HashBucSerUniMa)
LABEL_ITEM_DEF(OB_HASH_BUCKET_TENANT_POOLS_MAP, HashBucTenPooMa)
LABEL_ITEM_DEF(OB_HASH_BUCKET_SERVER_MIGRATE_UNIT_MAP, HasBucSerMigUnM)
LABEL_ITEM_DEF(OB_RS_UNIT_MANAGER, RsUnitManager)
LABEL_ITEM_DEF(OB_HASH_BUCKET_RENAME_TABLE_MAP, HashBucRenTabMa)
LABEL_ITEM_DEF(OB_RS_DEFAULT_VALUE_CASTER, RsDefauValueCas)
LABEL_ITEM_DEF(OB_RS_ASYNC_RPC_PROXY, RsAsyncRpcProxy)
LABEL_ITEM_DEF(OB_RS_EVENT_QUEUE, RsEventQueue)
LABEL_ITEM_DEF(OB_RS_EVENT_TASK, RsEventTask)
LABEL_ITEM_DEF(OB_RS_LEADER_COORDINATOR, RsLeaderCoordin)
LABEL_ITEM_DEF(OB_RS_LEADER_COORDINATOR_PA, RsLeadeCoordPa)
LABEL_ITEM_DEF(OB_RS_PARTITION_BALANCER, RsPartitiBalanc)
LABEL_ITEM_DEF(OB_RS_UNIT_BALANCER, RsUnitBalancer)
LABEL_ITEM_DEF(OB_HASH_BUCKET_PLAN_COLUMN_MAP, HashBucPlaColMa)
LABEL_ITEM_DEF(OB_HASH_BUCKET_TABLEGROUP_MAP, HashBuckTablMap)
LABEL_ITEM_DEF(OB_RS_META_TABLE_MIGRATION, RsMetaTableMigr)
LABEL_ITEM_DEF(OB_HASH_BUCKET_TIME_ZONE_INFO_MAP, HasBucTimZonInM)
LABEL_ITEM_DEF(OB_LOCALITY_CHECK_HELP_MAP, LocaChecHelpMap)
LABEL_ITEM_DEF(OB_RS_SLAVE_FETCH_PRIMARY_DDL, RsSlavFetcPriDd)
LABEL_ITEM_DEF(OB_RS_GTS_MANAGER, RsGtsManager)
LABEL_ITEM_DEF(OB_RS_PARTITION_META_TABLE_MIGRATION, RsPartMetaTabMi)
LABEL_ITEM_DEF(OB_RS_FLASHBACK_INFO, RsFlashbaInfo)
LABEL_ITEM_DEF(OB_SERVER_RECOVERY_MACHINE, ServerRecovMach)
LABEL_ITEM_DEF(OB_REPLICA_CONTROL, ReplicaControl)

// sqlmodules
// compile include parse, resolve, optimize, code generate
LABEL_ITEM_DEF(OB_SQL_COMPILE, SqlCompile)
LABEL_ITEM_DEF(OB_SQL_PARSER, SqlParser)
LABEL_ITEM_DEF(OB_SQL_SESSION_POOL, SqlSessionPool)
LABEL_ITEM_DEF(OB_SQL_SESSION, SqlSession)
LABEL_ITEM_DEF(OB_SQL_SESSION_WARNING_BUFFER, SqlSessiWarnBuf)
LABEL_ITEM_DEF(OB_SQL_SESSION_QUERY_SQL, SqlSessiQuerSql)
LABEL_ITEM_DEF(OB_SQL_ROW_STORE, SqlRowStore)
LABEL_ITEM_DEF(OB_SQL_CHUNK_ROW_STORE, SqlChunkRowStor)
LABEL_ITEM_DEF(OB_SQL_RES_TYPE, SqlResType)
LABEL_ITEM_DEF(OB_SQL_HASH_DIST, SqlHashDist)
LABEL_ITEM_DEF(OB_SQL_HASH_DIST_ROW_STORE, SqlHashDisRowSt)
// LABEL_ITEM_DEF(OB_SQL_OPTIMIZER)
// FIXME  For compatibility, remove OB_SQL_OPT_LOCATION_CACHE after submitting the code
LABEL_ITEM_DEF(OB_SQL_OPT_LOCATION_CACHE, SqlOptLocatCach)
LABEL_ITEM_DEF(OB_SQL_OPTIMIZER_LOCATION_CACHE, SqlOptimLocaCac)
LABEL_ITEM_DEF(OB_SQL_OPTIMIZER_SELECT_REPLICA, SqlOptimSeleRep)
LABEL_ITEM_DEF(OB_SQL_OPTIMIZER_EQUAL_SETS, SqlOptimEquaSet)
LABEL_ITEM_DEF(OB_SQL_EXECUTOR, SqlExecutor)
LABEL_ITEM_DEF(OB_SQL_EXECUTOR_SMALL_INTERM_RESULT_SCANNER, SqlExeSmaIntReS)
LABEL_ITEM_DEF(OB_SQL_EXECUTOR_MERGE_SORT_SCANNER, SqlExecMerSorSc)
LABEL_ITEM_DEF(OB_SQL_EXECUTOR_INTERM_RESULT_ITEM, SqlExecIntResIt)
LABEL_ITEM_DEF(OB_SQL_EXECUTOR_INTERM_RESULT_SCANNER, SqlExecIntResSc)
LABEL_ITEM_DEF(OB_SQL_EXECUTOR_INTERM_RESULT_MAP, SqlExecIntResMa)
LABEL_ITEM_DEF(OB_SQL_EXECUTOR_INTERM_RESULT_EXPIRE_IR, SqlExeIntResExI)
LABEL_ITEM_DEF(OB_SQL_EXECUTOR_SCHEDULER, SqlExecutoSched)
LABEL_ITEM_DEF(OB_SQL_EXECUTOR_TASK_EVENT, SqlExecuTaskEve)
LABEL_ITEM_DEF(OB_SQL_EXECUTOR_TASK_INFO, SqlExecuTaskInf)
LABEL_ITEM_DEF(OB_SQL_EXECUTOR_TASK_PART_KEYS, SqlExecTasParKe)
LABEL_ITEM_DEF(OB_SQL_EXECUTOR_TASK_SPLITER, SqlExecuTaskSpl)
LABEL_ITEM_DEF(OB_SQL_EXECUTOR_BKGD_TASK, SqlExecuBkgdTas)
LABEL_ITEM_DEF(OB_SQL_EXECUTOR_MINI_TASK_MGR, SqlExecMinTasMg)
LABEL_ITEM_DEF(OB_SQL_EXECUTOR_MINI_TASK_EVENT, SqlExecMinTasEv)
LABEL_ITEM_DEF(OB_SQL_SCAN_PARAM, SqlScanParam)
LABEL_ITEM_DEF(OB_SQL_GET_PARAM, SqlGetParam)
LABEL_ITEM_DEF(OB_SQL_DEFAULT_VALUE_CONTEXT, SqlDefauValuCon)
LABEL_ITEM_DEF(OB_SQL_REQUEST, SqlRequest)
LABEL_ITEM_DEF(OB_SQL_TRANSFORMER_PS, SqlTransfoPs)
LABEL_ITEM_DEF(OB_SQL_PS_TRANS, SqlPsTrans)
LABEL_ITEM_DEF(OB_SQL_ARRAY, SqlArray)
LABEL_ITEM_DEF(OB_SQL_EXPR, SqlExpr)
LABEL_ITEM_DEF(OB_SQL_EXPR_ITEM, SqlExprItem)
LABEL_ITEM_DEF(OB_SQL_EXPR_BUF, SqlExprBuf)
LABEL_ITEM_DEF(OB_SQL_EXPR_CALC, SqlExprCalc)
LABEL_ITEM_DEF(OB_SQL_EXPR_OP, SqlExprOp)
LABEL_ITEM_DEF(OB_SQL_EXPR_REPLACE, SqlExprReplace)
LABEL_ITEM_DEF(OB_SQL_STRING_BUF, SqlStringBuf)
LABEL_ITEM_DEF(OB_SQL_AGGR_FUNC, SqlAggrFunc)
LABEL_ITEM_DEF(OB_SQL_AGGR_FUNC_ROW, SqlAggrFuncRow)
LABEL_ITEM_DEF(OB_SQL_AGGR_FUNC_ARR, SqlAggrFuncArr)
LABEL_ITEM_DEF(OB_SQL_AGGR_FUN_GROUP_CONCAT, SqlAggrFunGroCo)
LABEL_ITEM_DEF(OB_SQL_AGGR_CELL_CTX, SqlAggrCellCtx)
LABEL_ITEM_DEF(OB_SQL_INSERT, SqlInsert)
LABEL_ITEM_DEF(OB_SQL_MERGE_JOIN, SqlMergeJoin)
LABEL_ITEM_DEF(OB_SQL_HASH_JOIN, SqlHashJoin)
LABEL_ITEM_DEF(OB_SQL_RESULT_SET, SqlResultSet)
LABEL_ITEM_DEF(OB_SQL_TABLET_CACHE_JOIN, SqlTableCachJoi)
LABEL_ITEM_DEF(OB_SQL_UPDATE, SqlUpdate)
LABEL_ITEM_DEF(OB_SQL_READ_STRATEGY, SqlReadStrategy)
LABEL_ITEM_DEF(OB_SQL_PRIVILEGE, SqlPrivilege)
LABEL_ITEM_DEF(OB_SQL_RPC_SCAN2, SqlRpcScan2)
LABEL_ITEM_DEF(OB_SQL_READ_STATEGY, SqlReadStategy)
LABEL_ITEM_DEF(OB_SQL_TABLE_SCAN_CTX, SqlTableScanCtx)
LABEL_ITEM_DEF(OB_SQL_TABLE_LOOKUP, SqlTableLookup)
LABEL_ITEM_DEF(OB_SQL_SCALAR_AGGR, SqlScalarAggr)
LABEL_ITEM_DEF(OB_SQL_MERGE_GROUPBY, SqlMergeGroupby)
LABEL_ITEM_DEF(OB_SQL_MERGE_UNION, SqlMergeUnion)
LABEL_ITEM_DEF(OB_SQL_PHY_PLAN, SqlPhyPlan)
LABEL_ITEM_DEF(OB_SQL_PHY_PL_OBJ, SqlPhyPlObj)
LABEL_ITEM_DEF(OB_SQL_PHY_PLAN_JOIN_PARAM, SqlPhyPlanJoiPa)
LABEL_ITEM_DEF(OB_SQL_RESULT_SET_DYN, SqlResulSetDyn)
LABEL_ITEM_DEF(OB_SQL_CONNECTION_POOL, SqlConnectPool)
LABEL_ITEM_DEF(OB_SQL_SESSION_HASHMAP, SqlSessionHashm)
LABEL_ITEM_DEF(OB_SQL_SESSION_SBLOCK, SqlSessionSbloc)
LABEL_ITEM_DEF(OB_SQL_SESSION_VAR_MAP, SqlSessiVarMap)
LABEL_ITEM_DEF(OB_SQL_SYS_VAR_CACHE, SqlSysVarCache)
LABEL_ITEM_DEF(OB_SQL_TENANT_SYS_VARS_CACHE, SqlTenaSysVarCa)
LABEL_ITEM_DEF(OB_SQL_QUERY_CACHE, SqlQueryCache)
LABEL_ITEM_DEF(OB_SQL_QUERY_RANGE, SqlQueryRange)
LABEL_ITEM_DEF(OB_SQL_RPC_REQUEST, SqlRpcRequest)
LABEL_ITEM_DEF(OB_SQL_PS_STORE_PHYSICALPLAN, SqlPsStorePhysi)
LABEL_ITEM_DEF(OB_SQL_PS_STORE_OPERATORS, SqlPsStoreOpera)
LABEL_ITEM_DEF(OB_SQL_PS_STORE_ITEM, SqlPsStoreItem)
LABEL_ITEM_DEF(OB_SQL_PHY_PLAN_STRING, SqlPhyPlanStrin)
LABEL_ITEM_DEF(OB_SQL_KEY_PART, SqlKeyPart)
LABEL_ITEM_DEF(OB_SQL_NLJ_CACHE, SqlNljCache)
LABEL_ITEM_DEF(OB_QUERY_RANGE, QueryRange)
LABEL_ITEM_DEF(OB_QUERY_RANGE_CTX, QueryRangeCtx)
LABEL_ITEM_DEF(OB_PS_INFO, PsInfo)
LABEL_ITEM_DEF(OB_VARIABLE_SET, VariableSet)
LABEL_ITEM_DEF(OB_SQL_EXEC_CONTEXT, SqlExecContext)
LABEL_ITEM_DEF(OB_SQL_CONTEXT, SqlContext)
LABEL_ITEM_DEF(OB_SQL_CG, SqlCg)
LABEL_ITEM_DEF(OB_SQL_PREPARED_SQL, SqlPrepareSql)
LABEL_ITEM_DEF(OB_SQL_TABLE_LOCATION, SqlTableLocatio)
LABEL_ITEM_DEF(OB_SQL_SORT_ROW, SqlSortRow)
LABEL_ITEM_DEF(OB_SQL_PLAN_MONITOR, SqlPlanMonitor)
LABEL_ITEM_DEF(OB_SQL_WINDOW_FUNC, SqlWindowFunc)
LABEL_ITEM_DEF(OB_SQL_WINDOW_LOCAL, SqlWindowLocal)
LABEL_ITEM_DEF(OB_SQL_WINDOW_ROW_STORE, SqlWindoRowStor)
LABEL_ITEM_DEF(OB_SQL_HASH_SET, SqlHashSet)

LABEL_ITEM_DEF(OB_SQL_CTE_ROW, SqlCteRow)
LABEL_ITEM_DEF(OB_SQL_UDF, SqlUdf)
LABEL_ITEM_DEF(OB_SQL_SEQUENCE, SqlSequence)

LABEL_ITEM_DEF(OB_SQL_DTL, SqlDtl)
LABEL_ITEM_DEF(OB_SQL_PX, SqlPx)
LABEL_ITEM_DEF(OB_SQL_SQC_HANDLER, SqlSqcHandler)
LABEL_ITEM_DEF(OB_SQL_PX_ASYNC_SQC_RPC, SqlPxAsynSqcRpc)

LABEL_ITEM_DEF(OB_SQL_LOAD_DATA, SqlLoadData)

LABEL_ITEM_DEF(OB_JIT_MALLOC, JitMalloc)

LABEL_ITEM_DEF(OB_PL_FUNCTION, PlFunction)
LABEL_ITEM_DEF(OB_PL_COLLECTION, PlCollection)
LABEL_ITEM_DEF(OB_PL_TEMP, PlTemp)
LABEL_ITEM_DEF(OB_PL, Pl)

LABEL_ITEM_DEF(OB_HASH_BUCKET_SYS_CONF, HashBuckSysConf)
LABEL_ITEM_DEF(OB_HASH_BUCKET_SYS_CONF_MAP, HashBucSysConMa)
LABEL_ITEM_DEF(OB_HASH_BUCKET_ALTER_TABLE_MAP, HashBucAltTabMa)
LABEL_ITEM_DEF(OB_HASH_BUCKET_GROUP_ROWS, HashBuckGrouRow)
LABEL_ITEM_DEF(OB_HASH_BUCKET_DISTINCT_ROWS, HashBuckDistRow)
LABEL_ITEM_DEF(OB_HASH_BUCKET_UNION_ROWS, HashBuckUnioRow)
LABEL_ITEM_DEF(OB_HASH_BUCKET_PLAN_CACHE, HashBuckPlanCac)
LABEL_ITEM_DEF(OB_HASH_BUCKET_PS_CACHE, HashBuckPsCache)
LABEL_ITEM_DEF(OB_HASH_BUCKET_PS_INFO, HashBuckPsInfo)
LABEL_ITEM_DEF(OB_HASH_BUCKET_PS_SESSION_INFO, HashBucPsSessIn)
LABEL_ITEM_DEF(OB_HASH_BUCKET_PS_PCV_SET, HashBucPsPcvSet)
LABEL_ITEM_DEF(OB_HASH_BUCKET_SQL_PARAMETERIZATION, HashBuckSqlPara)
LABEL_ITEM_DEF(OB_HASH_BUCKET_PLAN_STAT, HashBuckPlanSta)
LABEL_ITEM_DEF(OB_HASH_BUCKET_NLJ_CACHE, HashBuckNljCach)
LABEL_ITEM_DEF(OB_HASH_BUCKET_INTERRUPT_CHECKER, HashBuckInteChe)
LABEL_ITEM_DEF(OB_INTERRUPT_CHECKER_NODE, InterrCheckNode)
LABEL_ITEM_DEF(OB_HASH_BUCKET_TENANT_COMPAT_MODE, HashBucTenComMo)
LABEL_ITEM_DEF(OB_HASH_BUCKET_MASTER_KEY, HashBuckMastKey)
LABEL_ITEM_DEF(OB_HASH_PX_BLOOM_FILTER_KEY, HashPxBlooFilKe)
LABEL_ITEM_DEF(OB_HASH_NODE_SYS_CONF, HashNodeSysConf)
LABEL_ITEM_DEF(OB_HASH_NODE_SYS_CONF_MAP, HashNodSysConMa)
LABEL_ITEM_DEF(OB_HASH_NODE_ALTER_TABLE_MAP, HashNodAltTabMa)
LABEL_ITEM_DEF(OB_HASH_NODE_GROUP_ROWS, HashNodeGrouRow)
LABEL_ITEM_DEF(OB_HASH_NODE_DISTINCT_ROWS, HashNodeDistRow)
LABEL_ITEM_DEF(OB_HASH_NODE_UNION_ROWS, HashNodeUnioRow)
LABEL_ITEM_DEF(OB_HASH_NODE_PLAN_CACHE, HashNodePlanCac)
LABEL_ITEM_DEF(OB_HASH_NODE_PS_CACHE, HashNodePsCache)
LABEL_ITEM_DEF(OB_HASH_NODE_PS_INFO, HashNodePsInfo)
LABEL_ITEM_DEF(OB_HASH_NODE_PS_SESSION_INFO, HashNodPsSessIn)
LABEL_ITEM_DEF(OB_HASH_NODE_PS_PCV_SET, HashNodPsPcvSet)
LABEL_ITEM_DEF(OB_HASH_NODE_PLAN_STAT, HashNodePlanSta)
LABEL_ITEM_DEF(OB_HASH_NODE_SQL_PARAMETERIZATION, HashNodeSqlPara)
LABEL_ITEM_DEF(OB_HASH_NODE_NLJ_CACHE, HashNodeNljCach)
LABEL_ITEM_DEF(OB_HASH_NODE_INTERRUPT_CHECKER, HashNodeInteChe)
LABEL_ITEM_DEF(OB_HASH_NODE_TENANT_COMPAT_MODE, HashNodTenComMo)
LABEL_ITEM_DEF(OB_HASH_NODE_MASTER_KEY, HashNodeMastKey)
LABEL_ITEM_DEF(OB_HASH_BUCKET_PX_TRANSIMIT_REPART, HashBucPxTranRe)
LABEL_ITEM_DEF(OB_HASH_NODE_PX_BLOOM_FILTER_KEY, HasNodPxBloFilK)
LABEL_ITEM_DEF(OB_SQL_PARAMETERIZATION, SqlParameteriza)
LABEL_ITEM_DEF(OB_SQL_PLAN_CACHE, SqlPlanCache)
LABEL_ITEM_DEF(OB_SQL_PLAN_CACHE_VALUE, SqlPlanCacheVal)
LABEL_ITEM_DEF(OB_SQL_PLAN_SET, SqlPlanSet)
LABEL_ITEM_DEF(OB_SQL_PART_MGR, SqlPartMgr)
LABEL_ITEM_DEF(OB_SQL_PS_CACHE, SqlPsCache)
LABEL_ITEM_DEF(OB_SQL_PS_SQL_META, SqlPsSqlMeta)
LABEL_ITEM_DEF(OB_SQL_PX_BLOOM_FILTER, SqlPxBloomFilte)
LABEL_ITEM_DEF(OB_PS_SESSION_INFO_ARRAY, PsSessiInfoArra)
LABEL_ITEM_DEF(OB_CONNECT_BY_PUMP, ConnecByPump)

// mpimodules
LABEL_ITEM_DEF(OB_MPI_INTERM_RESULT, MpiIntermResult)
LABEL_ITEM_DEF(OB_MPI, Mpi)
LABEL_ITEM_DEF(OB_HASH_BUCKET_MPI_SUBPLAN_MAP, HashBucMpiSubMa)
LABEL_ITEM_DEF(OB_HASH_BUCKET_IR_MAP, HashBuckIrMap)
LABEL_ITEM_DEF(OB_HASH_BUCKET_MPI_TASK_MAP, HashBucMpiTasMa)
LABEL_ITEM_DEF(OB_HASH_BUCKET_MPI_JOB_MAP, HashBucMpiJobMa)

// liboblog start
LABEL_ITEM_DEF(OB_LOG_BINLOG_RECORD, LogBinlogRecord)
LABEL_ITEM_DEF(OB_LOG_BINLOG_RECORD_POOL, LogBinloRecoPoo)
LABEL_ITEM_DEF(OB_LOG_FETCHER, LogFetcher)
LABEL_ITEM_DEF(OB_LOG_PART_INFO, LogPartInfo)
LABEL_ITEM_DEF(OB_LOG_PART_COMMIT_INFO, LogPartCommiInf)
LABEL_ITEM_DEF(OB_LOG_PART_TRANS_TASK_SMALL, LogPartTraTasSm)
LABEL_ITEM_DEF(OB_LOG_PART_TRANS_TASK_LARGE, LogPartTraTasLa)
LABEL_ITEM_DEF(OB_LOG_PART_TRANS_TASK_POOL, LogPartTraTasPo)
LABEL_ITEM_DEF(OB_LOG_PART_TRANS_TASK_PREALLOC_PAGE, LogParTraTasPrP)
LABEL_ITEM_DEF(OB_LOG_DATABASE_META_MAP, LogDatabMetaMap)
LABEL_ITEM_DEF(OB_LOG_TABLE_META_MAP, LogTableMetaMap)
LABEL_ITEM_DEF(OB_LOG_TABLE_COLUMN_ID_META_MAP, LogTabColIdMetM)
LABEL_ITEM_DEF(OB_LOG_TABLE_COLUMN_INDEX_META_MAP, LogTabColIndMeM)
LABEL_ITEM_DEF(OB_LOG_TABLE_COLUMN_COUNT_META_MAP, LogTabColCouMeM)
LABEL_ITEM_DEF(OB_LOG_META_INFO, LogMetaInfo)
LABEL_ITEM_DEF(OB_LOG_FORMATTER, LogFormatter)
LABEL_ITEM_DEF(OB_LOG_SERVER_PROVIDER, LogServerProvid)
LABEL_ITEM_DEF(OB_LOG_DEP_MAP, LogDepMap)
LABEL_ITEM_DEF(OB_LOG_TRANS_CTX, LogTransCtx)
LABEL_ITEM_DEF(OB_LOG_TENANT_DB_NAME, LogTenanDbName)
LABEL_ITEM_DEF(OB_LOG_TENANT_DB_MAP, LogTenanDbMap)
LABEL_ITEM_DEF(OB_LOG_GLOBAL_NORMAL_INDEX_CACHE, LogGlobNorIndCa)
LABEL_ITEM_DEF(OB_LOG_TABLE_ID_CACHE, LogTableIdCache)
LABEL_ITEM_DEF(OB_LOG_TENANT_STAT_INFO, LogTenanStatInf)
LABEL_ITEM_DEF(OB_LOG_TENANT_STAT_MAP, LogTenanStatMap)
LABEL_ITEM_DEF(OB_LOG_ASYNC_HEARTBEAT_REQ, LogAsyncHearReq)
LABEL_ITEM_DEF(OB_LOG_TEMP_MEMORY, LogTempMemory)
LABEL_ITEM_DEF(OB_LOG_SERVER_FINDER, LogServerFinder)
LABEL_ITEM_DEF(OB_LOG_SERVER_ASSIGNER, LogServerAssign)
LABEL_ITEM_DEF(OB_LOG_OBJ_RETAINER_REF_CNTER_POOL, LogObjRetRefCnP)
LABEL_ITEM_DEF(OB_LOG_START_LOG_ID_LOCATOR, LogStarLogIdLoc)
LABEL_ITEM_DEF(OB_LOG_PARTITION_RECORDS_MAP, LogPartiRecoMap)
LABEL_ITEM_DEF(OB_LOG_MT_QUEUE_MAP, LogMtQueueMap)
LABEL_ITEM_DEF(OB_LOG_PART_FETCH_CTX, LogPartFetchCtx)
LABEL_ITEM_DEF(OB_LOG_PART_FETCH_CTX_MAP, LogPartFetCtxMa)
LABEL_ITEM_DEF(OB_LOG_PART_FETCH_CTX_POOL, LogPartFetCtxPo)
LABEL_ITEM_DEF(OB_LOG_FETCHER_IDLE_POOL, LogFetchIdlePoo)
LABEL_ITEM_DEF(OB_LOG_FETCHER_DEAD_POOL, LogFetchDeadPoo)
LABEL_ITEM_DEF(OB_LOG_FETCHER_SVR_FINDER, LogFetchSvrFind)
LABEL_ITEM_DEF(OB_LOG_MYSQL_CONNECTOR, LogMysqlConnect)
LABEL_ITEM_DEF(OB_LOG_ALL_SERVER_CACHE, LogAllServeCach)
LABEL_ITEM_DEF(OB_LOG_STREAM_WORKER_THREAD, LogStreaWorkThr)
LABEL_ITEM_DEF(OB_LOG_SVR_STREAM_MAP, LogSvrStreaMap)
LABEL_ITEM_DEF(OB_LOG_SVR_STREAM_POOL, LogSvrStreaPool)
LABEL_ITEM_DEF(OB_LOG_FETCH_STREAM_POOL, LogFetchStrePoo)
LABEL_ITEM_DEF(OB_LOG_FETCH_STREAM_PART_TASK_QUEUE, LogFetStrParTaQ)
LABEL_ITEM_DEF(OB_LOG_FETCH_STREAM_PART_TASK_MAP, LogFetStrParTaM)
LABEL_ITEM_DEF(OB_LOG_TIMER, LogTimer)
LABEL_ITEM_DEF(OB_LOG_PART_PROGRESS_CONTROLLER, LogPartProgrCon)
LABEL_ITEM_DEF(OB_LOG_PART_TRANS_RESOLVER, LogPartTransRes)
LABEL_ITEM_DEF(OB_LOG_FETCH_LOG_ARPC_RES_QUEUE, LogFetLogArpReQ)
LABEL_ITEM_DEF(OB_LOG_FETCH_LOG_ARPC_RESULT, LogFetcLogArpRe)
LABEL_ITEM_DEF(OB_LOG_FETCH_LOG_ARPC_REQUEST, LogFetcLogArpRe)
LABEL_ITEM_DEF(OB_LOG_FETCH_LOG_SRPC, LogFetchLogSrpc)
LABEL_ITEM_DEF(OB_LOG_HEARTBEATER, LogHeartbeater)
LABEL_ITEM_DEF(OB_LOG_CONFIG, LogConfig)
LABEL_ITEM_DEF(OB_LOG_SVR_HISTORY, LogSvrHistory)
LABEL_ITEM_DEF(OB_LOG_COMMITTER_CHECKPOINT_QUEUE, LogCommiChecQue)
LABEL_ITEM_DEF(OB_LOG_TAILF_PRINTER, LogTailfPrinter)
LABEL_ITEM_DEF(OB_LOG_DML_PARSER, LogDmlParser)
LABEL_ITEM_DEF(OB_LOG_BATCH_SQL_QUERY, LogBatchSqlQuer)
LABEL_ITEM_DEF(OB_LOG_PART_SVR_LIST, LogPartSvrList)
LABEL_ITEM_DEF(OB_LOG_PART_SVR_LIST_BLACK_LIST, LogParSvrLisBlL)
LABEL_ITEM_DEF(OB_LOG_PART_SVR_LIST_HISTORY_LIST, LogParSvrLisHiL)
LABEL_ITEM_DEF(OB_LOG_HBASE_COLUMN_ID_MAP, LogHbasColIdMap)
LABEL_ITEM_DEF(OB_LOG_TABLE_SCHEMA_META_MAP, LogTablSchMetMa)
LABEL_ITEM_DEF(OB_LOG_TENANT_MAP, LogTenantMap)
LABEL_ITEM_DEF(OB_LOG_TENANT_TASK_QUEUE, LogTenanTaskQue)
LABEL_ITEM_DEF(OB_LOG_CLOG_HISTORY_RECORD_ARRAY, LogClogHisRecAr)
LABEL_ITEM_DEF(OB_LOG_META_RECORD_ARRAY, LogMetaRecorArr)
LABEL_ITEM_DEF(OB_LOG_ALL_SERVER_ARRAY, LogAllServeArra)
// liboblog end

// archive start
LABEL_ITEM_DEF(OB_ARCHIVE_DOWNLOAD_FILE_BUUFER, ArchDownFileBuu)
LABEL_ITEM_DEF(OB_ARCHIVE_PG_MAP, ArchivPgMap)
LABEL_ITEM_DEF(OB_ARCHIVE_TEMP_MEMORY, ArchivTempMemor)
LABEL_ITEM_DEF(OB_ARCHIVE_SEND_TASK, ArchivSendTask)
LABEL_ITEM_DEF(OB_ARCHIVE_CLOG_TASK, ArchivClogTask)
LABEL_ITEM_DEF(OB_ARCHIVE_RESTORE_ENGINE, ArchivRestoEngi)
// archive end

// storagetest
LABEL_ITEM_DEF(OB_ST_WORKER, StWorker)
LABEL_ITEM_DEF(OB_ST_GEN_OPERATOR, StGenOperator)
LABEL_ITEM_DEF(OB_ST_TEMP, StTemp)
LABEL_ITEM_DEF(OB_ST_NOP_POS, StNopPos)
LABEL_ITEM_DEF(OB_ST_FREEZE_LOG_TASK, StFreezLogTask)

// proxy
LABEL_ITEM_DEF(OB_HASH_BUCKET_PROXY_MAP, HashBuckProxMap)
LABEL_ITEM_DEF(OB_HASH_BUCKET_YUNTI_META_MAP, HashBucYunMetMa)
LABEL_ITEM_DEF(OB_LARGE_IO_BUFFER, LargeIoBuffer)

// election
LABEL_ITEM_DEF(OB_ELECTION, Election)
LABEL_ITEM_DEF(OB_ELECTION_GROUP, ElectionGroup)
LABEL_ITEM_DEF(OB_ELECTION_MGR, ElectionMgr)
LABEL_ITEM_DEF(OB_ELECTION_TIMER, ElectionTimer)
LABEL_ITEM_DEF(OB_ELECTION_TIMER_TASK, ElectiTimerTask)
LABEL_ITEM_DEF(OB_ELECTION_HASH_BUCKET, ElectiHashBucke)
LABEL_ITEM_DEF(OB_ELECTION_ASYNC_LOG, ElectiAsyncLog)
LABEL_ITEM_DEF(OB_ELECTION_VIRTAUL_TABLE_ELECTION_INFO, ElecVirTabEleIn)
LABEL_ITEM_DEF(OB_ELECTION_VIRTAUL_TABLE_MEM_STAT, ElecVirTabMemSt)
LABEL_ITEM_DEF(OB_ELECTION_VIRTAUL_TABLE_EVENT_HISTORY, ElecVirTabEveHi)
LABEL_ITEM_DEF(OB_ELECTION_EVENT_QUEUE, ElectiEventQueu)
LABEL_ITEM_DEF(OB_ELECTION_GROUP_HASH_BUCKET, ElecGrouHashBuc)

// memtable
LABEL_ITEM_DEF(OB_CHECKSUM_CHECKER, ChecksumChecker)
LABEL_ITEM_DEF(OB_MEMTABLE_BTREE_MAP, MemtabBtreeMap)
LABEL_ITEM_DEF(OB_MEMTABLE_HASH_MAP, MemtabHashMap)
LABEL_ITEM_DEF(OB_MEMTABLE_COMPACT_WRITER_BUFFER, MemtCompWritBuf)
LABEL_ITEM_DEF(OB_MEMTABLE_OBJECT, MemtableObject)
LABEL_ITEM_DEF(OB_MEMTABLE_QUERY, MemtableQuery)
LABEL_ITEM_DEF(OB_MEMTABLE_CTX_OBJECT, MemtabCtxObject)
LABEL_ITEM_DEF(OB_MEMTABLE_CTX, MemtableCtx)
LABEL_ITEM_DEF(OB_MEMTABLE_CTX_ARENA, MemtabCtxArena)
LABEL_ITEM_DEF(OB_MEMTABLE_CALLBACK, MemtableCallbac)
LABEL_ITEM_DEF(OB_QUERY_ALLOCATOR, QueryAllocator)
LABEL_ITEM_DEF(OB_MEMTABLE_CTX_DYNAMIC, MemtabCtxDynami)
LABEL_ITEM_DEF(OB_MEMTABLE_ROW_TO_TXN_MAP, MemtRowToTxnMap)

// storage
LABEL_ITEM_DEF(OB_PARTITION_MGR, PartitioMgr)
LABEL_ITEM_DEF(OB_PARTITION, Partition)
LABEL_ITEM_DEF(OB_PG_PARTITION_MAP, PgPartitiMap)
LABEL_ITEM_DEF(OB_PG_INDEX_MAP, PgIndexMap)
LABEL_ITEM_DEF(OB_PARTITION_SPLIT, PartitioSplit)
LABEL_ITEM_DEF(OB_PARTITION_META, PartitioMeta)
LABEL_ITEM_DEF(OB_PARTITION_STORAGE, PartitioStorage)
LABEL_ITEM_DEF(OB_PARTITION_SERVICE, PartitioService)
LABEL_ITEM_DEF(OB_PARTITION_CTX_MGR, PartitCtxMgr)
LABEL_ITEM_DEF(OB_PARTITION_TEST, PartitioTest)
LABEL_ITEM_DEF(OB_SSSTORE, Ssstore)
LABEL_ITEM_DEF(OB_BASESTORAGE, Basestorage)
LABEL_ITEM_DEF(OB_MEM_SCAN_ITER, MemScanIter)
LABEL_ITEM_DEF(OB_MEMSTORE_ALLOCATOR, MemstoreAllocat)
LABEL_ITEM_DEF(OB_MEMSTORE, Memstore)
LABEL_ITEM_DEF(OB_TRANS_SERVICE, TransService)
LABEL_ITEM_DEF(OB_CLOG_MGR, ClogMgr)
LABEL_ITEM_DEF(OB_TABLE_SCAN_ITER, TableScanIter)
LABEL_ITEM_DEF(OB_INDEX_MERGE, IndexMerge)
LABEL_ITEM_DEF(OB_PARTITION_MIGRATOR, PartitioMigrato)
LABEL_ITEM_DEF(OB_ROW_PURGER, RowPurger)
LABEL_ITEM_DEF(OB_FREEZE, Freeze)
LABEL_ITEM_DEF(OB_COLUMN_DEFAULT_VALUE, ColumnDefauValu)
LABEL_ITEM_DEF(OB_CALLBACK_TASK, CallbackTask)
LABEL_ITEM_DEF(OB_CHECK2REMOVE, Check2remove)
LABEL_ITEM_DEF(OB_VALUE_ROW_ITER, ValueRowIter)
LABEL_ITEM_DEF(OB_COL_MAP, ColMap)
LABEL_ITEM_DEF(OB_WORK_ROW, WorkRow)
LABEL_ITEM_DEF(OB_PARTITION_ROW_MERGE, PartitRowMerge)
LABEL_ITEM_DEF(OB_PARTITION_SCAN_MERGE, PartitScanMerge)
LABEL_ITEM_DEF(OB_PARTITION_GET_MERGE, PartitGetMerge)
LABEL_ITEM_DEF(OB_PARTITION_SCHEDULER, PartitioSchedul)
LABEL_ITEM_DEF(OB_PADDING_COLUMN, PaddingColumn)
LABEL_ITEM_DEF(OB_SLOG_SCANNER, SlogScanner)
LABEL_ITEM_DEF(OB_SLOG_WRITER, SlogWriter)
LABEL_ITEM_DEF(OB_MICRO_INDEX_TRANSFORMER, MicroIndexTrans)
LABEL_ITEM_DEF(OB_WARM_UP_REQUEST, WarmUpRequest)
LABEL_ITEM_DEF(OB_WARM_UP_SERVICE, WarmUpService)
LABEL_ITEM_DEF(OB_WARM_UP_SERVICE2, WarmUpService2)
LABEL_ITEM_DEF(OB_PARTITION_MIGRATE, PartitioMigrate)
LABEL_ITEM_DEF(OB_PARTITION_MIGRATE_QUEUE, PartitMigraQueu)
LABEL_ITEM_DEF(OB_SYS_TASK_STATUS, SysTaskStatus)
LABEL_ITEM_DEF(OB_SSTABLE_MERGE_INFO, SstablMergeInfo)
LABEL_ITEM_DEF(OB_SSTABLE_MERGE_INFO_MAP, SstaMergInfoMap)
LABEL_ITEM_DEF(OB_PARTITION_MIGRATION_STATUS, PartitMigraStat)
LABEL_ITEM_DEF(OB_MACRO_FILE_HANDLE, MacroFileHandle)
LABEL_ITEM_DEF(OB_MACRO_FILE_MAP, MacroFileMap)
LABEL_ITEM_DEF(OB_MACRO_FILE_MANAGER, MacroFileManage)
LABEL_ITEM_DEF(OB_MACRO_FILE, MacroFile)
LABEL_ITEM_DEF(OB_TMP_FILE_MANAGER, TmpFileManager)
LABEL_ITEM_DEF(OB_TMP_FILE_STORE_MAP, TmpFileStoreMap)
LABEL_ITEM_DEF(OB_TMP_BLOCK_MAP, TmpBlockMap)
LABEL_ITEM_DEF(OB_TMP_BLOCK_MANAGER, TmpBlockManager)
LABEL_ITEM_DEF(OB_TMP_MAP, TmpMap)
LABEL_ITEM_DEF(OB_TMP_PAGE_CACHE, TmpPageCache)
LABEL_ITEM_DEF(OB_TMP_BLOCK_CACHE, TmpBlockCache)
LABEL_ITEM_DEF(OB_SSTABLE_CREATE_INDEX, SstablCreatInde)
LABEL_ITEM_DEF(OB_SSTABLE_LONG_OPS_MONITOR, SstaLongOpsMoni)
LABEL_ITEM_DEF(OB_INTERM_MACRO_MGR, IntermMacroMgr)
LABEL_ITEM_DEF(OB_TABLE_MGR_MAP, TableMgrMap)
LABEL_ITEM_DEF(OB_TABLE_MGR_ALLOCATOR, TableMgrAllocat)
LABEL_ITEM_DEF(OB_TABLE_STORE_MAP, TableStoreMap)
LABEL_ITEM_DEF(OB_TABLE_STORE_STAT_MGR, TablStorStatMgr)
LABEL_ITEM_DEF(OB_PARTITION_STORE_ALLOCATOR, PartitStoreAllo)
LABEL_ITEM_DEF(OB_PARTITION_SPLIT_TASK, PartitSplitTask)
LABEL_ITEM_DEF(OB_GTS_SWITCH_GETTER, GtsSwitchGetter)
LABEL_ITEM_DEF(OB_MS_ROW_ITERATOR, MsRowIterator)
LABEL_ITEM_DEF(OB_SSTABLE_CHECKSUM_CALCULATOR, SstablCheckCalc)
LABEL_ITEM_DEF(OB_REPLAY_STATUS, ReplayStatus)
LABEL_ITEM_DEF(OB_TENANT_PART_CNT_MAP, TenaPartCntMap)
LABEL_ITEM_DEF(OB_PARTITION_STORE, PartitioStore)
LABEL_ITEM_DEF(OB_META_MEMORY_MGR, MetaMemoryMgr)
LABEL_ITEM_DEF(OB_META_MEMORY_BUFFER, MetaMemoryBuffe)
LABEL_ITEM_DEF(OB_SCHEMA_LOG, SchemaLog)
LABEL_ITEM_DEF(OB_SPLIT_LOG_BUF, SplitLogBuf)
LABEL_ITEM_DEF(OB_TENANT_ID_LIST, TenantIdList)
LABEL_ITEM_DEF(OB_FREEZE_INFO_CACHE, FreezeInfoCache)
LABEL_ITEM_DEF(OB_PARTITION_LOG_BUF, PartitLogBuf)
LABEL_ITEM_DEF(OB_BLOCK_INDEX_INTERMEDIATE, BlockIndexInter)
LABEL_ITEM_DEF(OB_CHECKPOINT, Checkpoint)
LABEL_ITEM_DEF(OB_STORAGE_FILE_BLOCK_REF, StorFileBlocRef)
LABEL_ITEM_DEF(OB_BLOCK_MARK_DELETION_MAKER, BlocMarkDeleMak)
LABEL_ITEM_DEF(OB_FAST_MIGRATE_TASK, FastMigratTask)
LABEL_ITEM_DEF(OB_FAST_RECOVER_SPLIT_TASK, FastRecoSpliTas)
LABEL_ITEM_DEF(OB_PG_RECYCLE_NODE, PgRecycleNode)

// replay engine
LABEL_ITEM_DEF(OB_LOG_REPLAY_ENGINE, LogReplayEngine)

// clog
LABEL_ITEM_DEF(OB_LOG_DIRECT_READER_CACHE_ID, LogDireReaCacId)
LABEL_ITEM_DEF(OB_LOG_DIRECT_READER_IO_ID, LogDireReaIoId)
LABEL_ITEM_DEF(OB_LOG_DIRECT_READER_COMPRESS_ID, LogDireReaComId)
LABEL_ITEM_DEF(OB_LOG_DIRECT_READER_ILOG_ID, LogDireReaIloId)
LABEL_ITEM_DEF(OB_LOG_DIRECT_READER_ITER_ID, LogDireReaIteId)
LABEL_ITEM_DEF(OB_INDEX_ITERATOR_ID, IndexIteratId)
LABEL_ITEM_DEF(OB_LOG_ITERATOR_ID, LogIteratoId)
LABEL_ITEM_DEF(OB_LOG_WRITER_ID, LogWriterId)
LABEL_ITEM_DEF(OB_LOG_FILE_STORE, LogFileStore)
LABEL_ITEM_DEF(OB_LOG_DISK_MANAGER, LogDiskManager)
LABEL_ITEM_DEF(OB_CLOG_MGR_ID, ClogMgrId)
LABEL_ITEM_DEF(OB_CLOG_SW, ClogSw)
LABEL_ITEM_DEF(OB_CLOG_RE, ClogRe)
LABEL_ITEM_DEF(OB_CLOG_GE, ClogGe)
LABEL_ITEM_DEF(OB_CLOG_SR_MAP, ClogSrMap)
LABEL_ITEM_DEF(OB_CLOG_CONSEC_INFO_MAP, ClogConsInfoMap)
LABEL_ITEM_DEF(OB_CLOG_EXTERNAL_RPC, ClogExternRpc)
LABEL_ITEM_DEF(OB_CLOG_FETCH_LE, ClogFetchLe)
LABEL_ITEM_DEF(OB_CLOG_INFO_BLK_HNDLR, ClogInfoBlkHndl)
LABEL_ITEM_DEF(OB_CLOG_BATCH_SUBMIT_CTX, ClogBatcSubmCtx)
LABEL_ITEM_DEF(OB_CLOG_BATCH_SUBMIT_DISK_TASK, ClogBatSubDisTa)
LABEL_ITEM_DEF(OB_LOG_INDEX_MOD, LogIndexMod)
LABEL_ITEM_DEF(OB_LOG_TASK, LogTask)
LABEL_ITEM_DEF(OB_LOG_TASK_BODY, LogTaskBody)
LABEL_ITEM_DEF(OB_LOG_FLUSH_TASK, LogFlushTask)
LABEL_ITEM_DEF(OB_LOG_FETCH_TASK, LogFetchTask)
LABEL_ITEM_DEF(OB_LOG_EVENT_TASK, LogEventTask)
LABEL_ITEM_DEF(OB_LOG_TRACE_PROFILE, LogTraceProfile)
LABEL_ITEM_DEF(OB_LOG_BLACK_LIST, LogBlackList)
LABEL_ITEM_DEF(OB_LOG_HOT_CACHE, LogHotCache)
LABEL_ITEM_DEF(OB_PARTITION_LOG_SERVICE, PartitLogServic)
LABEL_ITEM_DEF(OB_LOG_CHILD_REPLICA_HEARTBEATS, LogChildReplHea)
LABEL_ITEM_DEF(OB_LOG_CHILD_REPLICA_REGION, LogChildReplReg)
LABEL_ITEM_DEF(OB_LOG_CHILD_REPLICA_TYPE, LogChildReplTyp)
LABEL_ITEM_DEF(OB_LOG_CHILD_REPLICA_REGISTER_TIME, LogChilRepRegTi)
LABEL_ITEM_DEF(OB_LOG_CHILD_REPLICA_REPORT_TIME, LogChilRepRepTi)
LABEL_ITEM_DEF(OB_HASH_BUCKET_BATCH_SUBMIT_CTX, HashBucBatSubCt)
LABEL_ITEM_DEF(OB_SERVER_BLACKLIST, ServerBlacklist)
LABEL_ITEM_DEF(OB_ILOG_MEMSTORE_META, IlogMemstoMeta)
LABEL_ITEM_DEF(OB_ILOG_MEMSTORE_CURSOR, IlogMemstoCurso)
LABEL_ITEM_DEF(OB_ILOG_FILE_BUILDER, IlogFileBuilder)
LABEL_ITEM_DEF(OB_ILOG_STORAGE_ITERATOR, IlogStoragItera)
LABEL_ITEM_DEF(OB_LOG_AGGRE_BUFFER, LogAggreBuffer)
LABEL_ITEM_DEF(OB_LOG_AGGRE_BUFFER_ARRAY, LogAggreBuffArr)
LABEL_ITEM_DEF(OB_FETCH_LOG_HEARTBEAT_ARRAY_FOR_LIBOBLOG, FetLogHeaArrFoL)
LABEL_ITEM_DEF(OB_LOG_DECRYPT_ID, LogDecryptId)

// cursor cache
LABEL_ITEM_DEF(OB_CSR_FILE_ID_CACHE_FILE_LIST, CsrFilIdCacFilL)
LABEL_ITEM_DEF(OB_CSR_FILE_ID_CACHE_FILE_ITEM, CsrFilIdCacFilI)
LABEL_ITEM_DEF(OB_CSR_FILE_ID_CACHE_PKEY_MAP, CsrFilIdCacPkeM)
LABEL_ITEM_DEF(OB_CSR_PER_FILE_NODE_WRAPPER, CsrPerFileNodWr)
LABEL_ITEM_DEF(OB_CSR_PER_FILE_NODE_MAP, CsrPerFileNodMa)
LABEL_ITEM_DEF(OB_CSR_PER_FILE_BUF_AND_MAP, CsrPerFilBufAnM)

// CLOG SPLIT
LABEL_ITEM_DEF(OB_CLOG_SPLIT_MAP, ClogSplitMap)
LABEL_ITEM_DEF(OB_CLOG_SPLIT_INFO_ITEM, ClogSpliInfoIte)
LABEL_ITEM_DEF(OB_CLOG_SPLIT_LOG_BUF, ClogSpliLogBuf)

// clog external rpc for liboblog
LABEL_ITEM_DEF(OB_CLOG_EXT_RPC, ClogExtRpc)
LABEL_ITEM_DEF(OB_EXT_STREAM_MAP, ExtStreamMap)
LABEL_ITEM_DEF(OB_EXT_STREAM_ALLOCATOR, ExtStreamAlloca)
LABEL_ITEM_DEF(OB_CLOG_EXT_LINE_CACHE, ClogExtLineCach)

// for log archive
LABEL_ITEM_DEF(OB_LOG_ARCHIVE_LINE_CACHE, LogArchiLineCac)
// clog test nio
LABEL_ITEM_DEF(NIO_MOD_ID, NioModId)
LABEL_ITEM_DEF(NIO_MOD_ID2, NioModId2)

// clog log_tool
LABEL_ITEM_DEF(OB_LOG_TOOL, LogTool)

// clog history reporter
LABEL_ITEM_DEF(OB_CLOG_HISTORY_TASK_MAP, ClogHistTaskMap)

LABEL_ITEM_DEF(OB_RPC, Rpc)
LABEL_ITEM_DEF(OB_RPC_STAT, RpcStat)
LABEL_ITEM_DEF(OB_RPC_PROCESSOR, RpcProcessor)
LABEL_ITEM_DEF(OB_RPC_BUFFER, RpcBuffer)
LABEL_ITEM_DEF(OB_RPC_PTABLE, RpcPtable)
LABEL_ITEM_DEF(OB_MYSQL_PROCESSOR, MysqlProcessor)
LABEL_ITEM_DEF(OB_MYSQL_BUFFER, MysqlBuffer)
LABEL_ITEM_DEF(OB_MYSQL_PTABLE, MysqlPtable)
LABEL_ITEM_DEF(OB_RPC_HASH_BUCKET_CTX, RpcHashBuckeCtx)

// transaction
LABEL_ITEM_DEF(OB_END_TRANS_CALLBACK, EndTransCallbac)
LABEL_ITEM_DEF(OB_HASH_BUCKET_TRANS_CTX, HashBuckTranCtx)
LABEL_ITEM_DEF(OB_HASH_BUCKET_PARTITION_TRANS_CTX, HashBucParTraCt)
LABEL_ITEM_DEF(OB_HASH_BUCKET_TRANS_VERSION, HashBuckTranVer)
LABEL_ITEM_DEF(OB_TRANS_CHECK, TransCheck)
LABEL_ITEM_DEF(OB_TRANS_PUBLISH_VERSION_TOKEN, TranPublVersTok)
LABEL_ITEM_DEF(OB_HASH_BUCKET_TRANS_STATUS, HashBuckTranSta)
LABEL_ITEM_DEF(OB_TRANS_VIRTUAL_TABLE_PARTITION, TranVirtTablPar)
LABEL_ITEM_DEF(OB_TRANS_VIRTUAL_TABLE_TRANS_STAT, TranVirTabTraSt)
LABEL_ITEM_DEF(OB_TRANS_VIRTUAL_TABLE_PARTITION_STAT, TranVirTabParSt)
LABEL_ITEM_DEF(OB_TRANS_VIRTUAL_TABLE_MEMORY_STAT, TranVirTabMemSt)
LABEL_ITEM_DEF(OB_TRANS_REDO_LOG_ID_ARRAY, TranRedLogIdArr)
LABEL_ITEM_DEF(OB_TRANS_PARTITION_LOG_INFO_ARRAY, TranParLogInfAr)
LABEL_ITEM_DEF(OB_TRANS_PARTITION_ARRAY, TransPartitArra)
LABEL_ITEM_DEF(OB_TRANS_CLOG_BUF, TransClogBuf)
LABEL_ITEM_DEF(OB_TRANS_MUTATOR_BUF, TransMutatoBuf)
LABEL_ITEM_DEF(OB_PARTITION_TRANS_CTX_MGR, PartTranCtxMgr)
LABEL_ITEM_DEF(OB_TRANS_SUBMIT_LOG_TASK, TranSubmLogTask)
LABEL_ITEM_DEF(OB_TRANS_BACKFILL_NOP_LOG_TASK, TranBacNopLogTa)
LABEL_ITEM_DEF(OB_TRANS_ALLOC_LOG_ID_TASK, TranAllLogIdTas)
LABEL_ITEM_DEF(OB_TRANS_WAIT_TRANS_END_TASK, TranWaiTraEndTa)
LABEL_ITEM_DEF(OB_TRANS_CALLBACK_TRANS_TASK, TranCallTranTas)
LABEL_ITEM_DEF(OB_TRANS_LOCATION_CACHE, TransLocatiCach)
LABEL_ITEM_DEF(OB_TRANS_FREEZE_TASK, TransFreezeTask)
LABEL_ITEM_DEF(OB_TRANS_SCHE_CTX, TransScheCtx)
LABEL_ITEM_DEF(OB_TRANS_COORD_CTX, TransCoordCtx)
LABEL_ITEM_DEF(OB_TRANS_PART_CTX, TransPartCtx)
LABEL_ITEM_DEF(OB_TRANS_LOCAL_TASK, TransLocalTask)
LABEL_ITEM_DEF(OB_TRANS_WAIT_TASK, TransWaitTask)
LABEL_ITEM_DEF(OB_TRANS_TENANT_WAIT_QUEUE, TranTenaWaitQue)
LABEL_ITEM_DEF(OB_GTS_TASK, GtsTask)
LABEL_ITEM_DEF(OB_GTS_TASK_QUEUE, GtsTaskQueue)
LABEL_ITEM_DEF(OB_TRANS_RESULT_INFO, TransResultInfo)
LABEL_ITEM_DEF(OB_TRANS_RESULT_INFO_MGR, TranResuInfoMgr)
LABEL_ITEM_DEF(OB_TRANS_AUDIT_RECORD, TransAuditRecor)
LABEL_ITEM_DEF(OB_WRS_TENANT_SERVICE, WrsTenantServic)
LABEL_ITEM_DEF(OB_PARTITION_AUDIT_INFO, PartitAuditInfo)
LABEL_ITEM_DEF(OB_DUP_TABLE_PARTITION_INFO, DupTablePartInf)
LABEL_ITEM_DEF(OB_DUP_TABLE_PARTITION_MGR, DupTablePartMgr)
LABEL_ITEM_DEF(OB_DUP_TABLE_LEASE_INFO, DupTableLeasInf)
LABEL_ITEM_DEF(OB_DUP_TABLE_REDO_SYNC_TASK, DupTablRedSynTa)
LABEL_ITEM_DEF(OB_GTS_RPC_PROXY, GtsRpcProxy)
LABEL_ITEM_DEF(OB_GTS_REQUEST_RPC, GtsRequestRpc)
LABEL_ITEM_DEF(OB_HASH_BUCKET_HA_GTS, HashBuckHaGts)
LABEL_ITEM_DEF(OB_HA_GTS_REQ_MAP, HaGtsReqMap)
LABEL_ITEM_DEF(OB_HA_GTS_GTS_META_MAP, HaGtsGtsMetaMap)
LABEL_ITEM_DEF(OB_HA_GTS_TENANT_CACHE_MAP, HaGtsTenaCachMa)
LABEL_ITEM_DEF(OB_HA_GTS_HEARTBEAT_MAP, HaGtsHeartbMap)
LABEL_ITEM_DEF(OB_THREAD_LOCAL_TRANS_CTX, ThreLocaTranCtx)
LABEL_ITEM_DEF(OB_DEADLOCK_CHECKER, DeadlockChecker)
LABEL_ITEM_DEF(OB_TRANS_VIRTUAL_TABLE_DEADLOCK_STAT, TranVirTabDeaSt)
LABEL_ITEM_DEF(OB_END_TRANS_CB_TASK, EndTransCbTask)
LABEL_ITEM_DEF(OB_TRANS_CLOG_ENCRYPT_INFO, CLogEncryptInfo)

// rootservice
LABEL_ITEM_DEF(OB_HASH_BUCKET_LEADER_STATUS_MAP, HashBucLeaStaMa)
LABEL_ITEM_DEF(OB_HASH_BUCKET_PARTITION_DIST_MAP, HashBucParDisMa)
LABEL_ITEM_DEF(OB_MAJOR_FREEZE_PARTITION_LIST, MajoFreePartLis)
LABEL_ITEM_DEF(OB_HASH_BUCKET_FREEZE_STATUS_DIST_MAP, HasBucFreStaDiM)
LABEL_ITEM_DEF(OB_CREATE_PARTITION_FAILED_LIST, CreaPartFailLis)
LABEL_ITEM_DEF(OB_CREATE_PARTITION_CHECK_FULL_REPLICA_LIST, CreParCheFulReL)
LABEL_ITEM_DEF(OB_CREATE_PARTITION_CHECK_LIST, CreaPartChecLis)
LABEL_ITEM_DEF(OB_SERVER_ARPCARGS_MAP, ServerArpcaMap)
LABEL_ITEM_DEF(OB_LOCALITY_UTIL, LocalityUtil)
LABEL_ITEM_DEF(OB_HASH_BUCKET_SERVER_PARTITION_MAP, HashBucSerParMa)
LABEL_ITEM_DEF(OB_HASH_BUCKET_PARTITION_MAJORITY_MAP, HashBucParMajMa)

// storage_test
LABEL_ITEM_DEF(OB_TABLE_DATA_HOLDER, TableDataHolder)
LABEL_ITEM_DEF(OB_DATA_HOLDER, DataHolder)
LABEL_ITEM_DEF(OB_DATA_HOLDER_DATA, DataHolderData)
LABEL_ITEM_DEF(OB_DATA_HOLDER_INCREMENT_DATA, DataHoldIncrDat)
LABEL_ITEM_DEF(OB_DATA_MANAGER, DataManager)
LABEL_ITEM_DEF(OB_DATA_TRANSLATOR, DataTranslator)
LABEL_ITEM_DEF(OB_BASE_TASK_THREAD_MGR, BaseTaskThreMgr)
LABEL_ITEM_DEF(OB_INDEX_CHECK, IndexCheck)
LABEL_ITEM_DEF(OB_MEM_STAT_SET, MemStatSet)
LABEL_ITEM_DEF(OB_RING_BUFFER, RingBuffer)
LABEL_ITEM_DEF(OB_CONCURRENT_HASH_MAP, ConcurHashMap)
// backup and restore
LABEL_ITEM_DEF(RESTORE, Restore)
LABEL_ITEM_DEF(BACKUP, Backup)
LABEL_ITEM_DEF(OB_INC_BACKUP_MALLOC, IncBackupMalloc)
LABEL_ITEM_DEF(OB_INC_BACKUP_CFIFO, IncBackupCfifo)
LABEL_ITEM_DEF(OB_INC_BACKUP_SEQ_BR_POOL, IncBackSeqBrPoo)
LABEL_ITEM_DEF(OB_INC_BACKUP_SEQ_BR_ALLOCATOR, IncBackSeqBrAll)
LABEL_ITEM_DEF(OB_INC_BACKUP_FILL_BUF_MAP, IncBackFilBufMa)
LABEL_ITEM_DEF(OB_INC_BACKUP_DATA_OBJECT_MAP, IncBackDatObjMa)
LABEL_ITEM_DEF(OB_INC_BACKUP_TENANT_STREAM_MAP, IncBackTenStrMa)
LABEL_ITEM_DEF(OB_INC_BACKUP_TENANT_STREAM_POOL, IncBackTenStrPo)
LABEL_ITEM_DEF(RESTORE_MACRO_BLOCK, RestorMacroBloc)
LABEL_ITEM_DEF(OB_LOG_ARCHIVE_SCHEDULER, LogArchiveSched)
LABEL_ITEM_DEF(OB_RESTORE_SET_MEMBER_LIST, RestSetMembeLis)
LABEL_ITEM_DEF(OB_PHYSICAL_RESTORE_PARTITIONS, PhysicRestoPart)

LABEL_ITEM_DEF(OB_TRACE_LOG, TraceLog)
LABEL_ITEM_DEF(OB_LOG, Log)
LABEL_ITEM_DEF(OB_ASYNC_LOG, AsyncLog)
LABEL_ITEM_DEF(OB_ZLIB, Zlib)

LABEL_ITEM_DEF(OB_CORO, Coro)
LABEL_ITEM_DEF(OB_CO_LOCAL_STORAGE, CoLocalStorage)

// replication group
LABEL_ITEM_DEF(OB_RG_TRANSFER_COPY_SSTORE_QUEUE, RgTranCopySstQu)
LABEL_ITEM_DEF(OB_RG_TRANSFER_FETCH_LOG_TASK, RgTranFetcLogTa)

LABEL_ITEM_DEF(OB_EC_CALCULATE_BUFFER, EcCalculaBuffer)

// TABLE API
LABEL_ITEM_DEF(TABLE_PROC, TableProc)
LABEL_ITEM_DEF(TABLE_CLIENT, TableClient)
LABEL_ITEM_DEF(TABLE_BATCH_OPERATION, TableBatchOpera)
LABEL_ITEM_DEF(TABLE_BATCH_OPERATION_RESULT, TablBatcOperRes)

// schema
LABEL_ITEM_DEF(OB_TENANT_SCHEMA_MEM_MGR, TenaScheMemMgr)
LABEL_ITEM_DEF(OB_TENANT_SCHEMA_MGR, TenantSchemMgr)
LABEL_ITEM_DEF(OB_TENANT_SCHEMA_MEM_MGR_FOR_LIBOBLOG, TenSchMemMgrFoL)
LABEL_ITEM_DEF(OB_TENANT_SCHEMA_MGR_FOR_LIBOBLOG, TenaSchMgrForLi)
LABEL_ITEM_DEF(OB_SCHEMA_MGR_CACHE_MAP, ScheMgrCacheMap)
LABEL_ITEM_DEF(OB_SCHEMA_MGR_CACHE_FOR_LIBOBLOG_MAP, SchMgrCacForLiM)
LABEL_ITEM_DEF(OB_REFRESHED_SCHEMA_VERSION_MAP, RefrScheVersMap)
LABEL_ITEM_DEF(OB_RECEIVED_SCHEMA_VERSION_MAP, ReceScheVersMap)
LABEL_ITEM_DEF(OB_REFRESH_FULL_SCHEMA_MAP, RefrFullScheMap)
LABEL_ITEM_DEF(OB_MEM_MGR_MAP, MemMgrMap)
LABEL_ITEM_DEF(OB_MEM_MGR_FOR_LIBOBLOG_MAP, MemMgrForLiboMa)
LABEL_ITEM_DEF(OB_TENANT_SCHEMA_FOR_CACHE_MAP, TenaSchForCacMa)
LABEL_ITEM_DEF(OB_SCHEMA_STATUS_MAP, SchemaStatuMap)
LABEL_ITEM_DEF(OB_SCHEMA_VERSION_PAIRS, SchemaVersiPair)
LABEL_ITEM_DEF(OB_TENANT_SPACE_TABLE_ID_SET, TenaSpaTabIdSet)
LABEL_ITEM_DEF(OB_SYS_TABLE_NAME_MAP, SysTableNameMap)
LABEL_ITEM_DEF(OB_SCHEMA_MGR_INFO_ARRAY, ScheMgrInfoArra)
LABEL_ITEM_DEF(OB_MOCK_SCHEMA, MockSchema)
LABEL_ITEM_DEF(OB_MOCK_SCHEMA_MAP, MockSchemaMap)
LABEL_ITEM_DEF(OB_MOCK_SCHEMA_INFO_MAP, MockScheInfoMap)
LABEL_ITEM_DEF(OB_GEN_SCHEMA_VERSION_MAP, GenSchemVersMap)
LABEL_ITEM_DEF(OB_SCHEMA_DROP_TENANT_INFO_VEC, ScheDroTenInfVe)
LABEL_ITEM_DEF(OB_TABLE_NAME_WRAPPER_ARRAY, TablNameWrapArr)

// rc
LABEL_ITEM_DEF(OB_ROOT_CONTEXT, RootContext)

// dml
LABEL_ITEM_DEF(OB_DML_CHECK_ROWKEY_DISTINCT_BUCKET, DmlChecRowDisBu)
LABEL_ITEM_DEF(OB_DML_CHECK_ROWKEY_DISTINCT_NODE, DmlChecRowDisNo)

LABEL_ITEM_DEF(OB_MOD_END, ModEnd)
#endif

#ifndef __OB_COMMON_OB_MOD_DEFINE2_H__
#define __OB_COMMON_OB_MOD_DEFINE2_H__
#include <cstdint>

#include "lib/alloc/alloc_assist.h"
#include "lib/utility/ob_template_utils.h"

namespace oceanbase {
namespace common {
class ObString;
struct ObNewModIds {
  enum ObModIdEnum {
#define MOD_ITEM_DEF(name) name,
#include "lib/allocator/ob_mod_define.h"
#undef MOD_ITEM_DEF
  };
};

struct ObModItem {
  ObModItem() : hold_(0), used_(0), count_(0), alloc_count_(0), free_count_(0)
  {}
  inline void update(int64_t hold, int64_t used)
  {
    if (hold > 0) {
      count_ += 1;
      alloc_count_++;
    } else if (hold < 0) {
      count_ -= 1;
      free_count_++;
    }
    used_ += used;
    hold_ += hold;
  }
  int64_t format_string(char* buf, int64_t len, const char* name) const;
  ObModItem& operator+=(const ObModItem& item)
  {
    hold_ += item.hold_;
    used_ += item.used_;
    count_ += item.count_;
    alloc_count_ += item.alloc_count_;
    free_count_ += item.free_count_;
    return *this;
  }
  // desc
  bool operator<(const ObModItem mi) const
  {
    return hold_ > mi.hold_;
  }
  void reset()
  {
    hold_ = 0;
    used_ = 0;
    count_ = 0;
    alloc_count_ = 0;
    free_count_ = 0;
  }
  int64_t hold_;
  int64_t used_;
  int64_t count_;
  int64_t alloc_count_;
  int64_t free_count_;
};

class ObLocalModSet {
  enum { MOD_COUNT_LIMIT = ObNewModIds::OB_MOD_END };

public:
  ObLocalModSet()
  {
    reset();
  }
  void reset()
  {
    MEMSET(&mods_, 0, sizeof(mods_));
  }
  int64_t get_mod_hold(int64_t mod_id) const
  {
    return mods_[(mod_id >= 0 && mod_id < MOD_COUNT_LIMIT) ? mod_id : 0].hold_;
  }
  int64_t get_mod_used(int64_t mod_id) const
  {
    return mods_[(mod_id >= 0 && mod_id < MOD_COUNT_LIMIT) ? mod_id : 0].used_;
  }
  int64_t get_mod_count(int64_t mod_id) const
  {
    return mods_[(mod_id >= 0 && mod_id < MOD_COUNT_LIMIT) ? mod_id : 0].count_;
  }
  int64_t get_mod_alloc_count(int64_t mod_id) const
  {
    return mods_[(mod_id >= 0 && mod_id < MOD_COUNT_LIMIT) ? mod_id : 0].alloc_count_;
  }
  int64_t get_mod_free_count(int64_t mod_id) const
  {
    return mods_[(mod_id >= 0 && mod_id < MOD_COUNT_LIMIT) ? mod_id : 0].free_count_;
  }
  inline ObModItem get_mod(int64_t mod_id) const
  {
    return mods_[(mod_id >= 0 && mod_id < MOD_COUNT_LIMIT) ? mod_id : 0];
  }
  inline void mod_update(int64_t mod_id, int64_t hold, int64_t used)
  {
    mods_[(mod_id >= 0 && mod_id < MOD_COUNT_LIMIT) ? mod_id : 0].update(hold, used);
  }

private:
  ObModItem mods_[MOD_COUNT_LIMIT];
};

struct ObCtxIds {
  enum ObCtxIdEnum {
#define CTX_ITEM_DEF(name) name,
#include "lib/allocator/ob_mod_define.h"
#undef CTX_ITEM_DEF
  };
};

class ObCtxInfo {
public:
  enum { CTX_COUNT_LIMIT = ObCtxIds::MAX_CTX_ID };

  ObCtxInfo() : ctx_names_()
  {
#define CTX_ITEM_DEF(id) set_ctx_name(ObCtxIds::id, #id);
#include "lib/allocator/ob_mod_define.h"
#undef CTX_ITEM_DEF
  }
  const char* get_ctx_name(uint64_t ctx_id) const
  {
    const char* name = "INVALID_CTX_NAME";
    return ctx_id < ObCtxIds::MAX_CTX_ID ? ctx_names_[ctx_id] : name;
  }

private:
  void set_ctx_name(uint64_t ctx_id, const char* ctx_name)
  {
    if (ctx_id < ObCtxIds::MAX_CTX_ID) {
      ctx_names_[ctx_id] = ctx_name;
    }
  }

private:
  const char* ctx_names_[CTX_COUNT_LIMIT];
};

inline bool is_valid_mod_id(int64_t mod_id)
{
  return mod_id >= 0 && mod_id < ObNewModIds::OB_MOD_END;
}

class ObModSet {
public:
  enum { MOD_COUNT_LIMIT = ObNewModIds::OB_MOD_END };
  // You can pass the string uniformly where mod_id is used
  // No need to modify the ob_mod_define.h file
  // Please do not add mod_id if there is no special requirement
  STATIC_ASSERT(MOD_COUNT_LIMIT <= 16, "forbidden to add new mod_id!!!");
  ObModSet() : mod_names_()
  {
#define MOD_ITEM_DEF(id) set_mod_name(ObNewModIds::id, #id);
#include "lib/allocator/ob_mod_define.h"
#undef MOD_ITEM_DEF
  }
  virtual ~ObModSet()
  {}
  static ObModSet& instance()
  {
    static ObModSet ms;
    return ms;
  }
  int get_mod_id(const common::ObString& mod_name) const;
  const char* get_mod_name(int64_t mod_id) const
  {
    const char* t = "NONE";
    if (mod_id >= 0 && mod_id < MOD_COUNT_LIMIT) {
      t = mod_names_[mod_id];
    }
    return t;
  }

private:
  void set_mod_name(int64_t mod_id, const char* name)
  {
    if (mod_id >= 0 && mod_id < ObModSet::MOD_COUNT_LIMIT) {
      mod_names_[mod_id] = name;
    }
  }

private:
  const char* mod_names_[MOD_COUNT_LIMIT];
};

struct ObModIds {
#define LABEL_ITEM_DEF(name, real_name) static constexpr const char name[] = #real_name;
#include "lib/allocator/ob_mod_define.h"
#undef LABEL_ITEM_DEF
};

// for label cnt check
struct InnerModIds {
  enum InnerModIdEnum {
#define LABEL_ITEM_DEF(name, ...) name,
#include "lib/allocator/ob_mod_define.h"
#undef LABEL_ITEM_DEF
  };
  enum { LABEL_COUNT_LIMIT = InnerModIds::OB_MOD_END };
  STATIC_ASSERT(LABEL_COUNT_LIMIT <= 1028, "forbidden to add new label!!!");
};

};  // end namespace common
};  // end namespace oceanbase

#endif /* __OB_COMMON_OB_MOD_DEFINE2_H__ */
