/**
 * Copyright (c) 2021 OceanBase
 * OceanBase CE is licensed under Mulan PubL v2.
 * You can use this software according to the terms and conditions of the Mulan PubL v2.
 * You may obtain a copy of Mulan PubL v2 at:
 *          http://license.coscl.org.cn/MulanPubL-2.0
 * THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OF ANY KIND,
 * EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO NON-INFRINGEMENT,
 * MERCHANTABILITY OR FIT FOR A PARTICULAR PURPOSE.
 * See the Mulan PubL v2 for more details.
 */

#ifndef TBSYS_RUNNABLE_H_
#define TBSYS_RUNNABLE_H_

namespace oceanbase {
namespace obsys {
class CThread;
/**
 * @brief Runnable is an abstract class has a pure virtual run() method
 * Mainly used for Thread class
 */
class Runnable {

public:
  /*
   * Destructor
   */
  virtual ~Runnable()
  {}
  /**
   * Entry function
   */
  virtual void run(CThread* thread, void* arg) = 0;
};

}  // namespace obsys
}  // namespace oceanbase

#endif /*RUNNABLE_H_*/
