/**
 * Copyright (c) 2021 OceanBase
 * OceanBase CE is licensed under Mulan PubL v2.
 * You can use this software according to the terms and conditions of the Mulan PubL v2.
 * You may obtain a copy of Mulan PubL v2 at:
 *          http://license.coscl.org.cn/MulanPubL-2.0
 * THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OF ANY KIND,
 * EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO NON-INFRINGEMENT,
 * MERCHANTABILITY OR FIT FOR A PARTICULAR PURPOSE.
 * See the Mulan PubL v2 for more details.
 */

#ifndef OCEANBASE_OBSERVER_VIRTUAL_TABLE_OB_TENANT_VIRTUAL_CURRENT_TENANT_
#define OCEANBASE_OBSERVER_VIRTUAL_TABLE_OB_TENANT_VIRTUAL_CURRENT_TENANT_
#include "share/ob_virtual_table_scanner_iterator.h"
#include "common/ob_range.h"
namespace oceanbase {
namespace sql {
class ObSQLSessionInfo;
}
namespace common {
class ObMySQLProxy;
class ObNewRow;
}  // namespace common
namespace observer {
class ObTenantVirtualCurrentTenant : public common::ObVirtualTableScannerIterator {
public:
  ObTenantVirtualCurrentTenant();
  virtual ~ObTenantVirtualCurrentTenant();
  virtual int inner_get_next_row(common::ObNewRow*& row);
  virtual void reset();
  inline void set_sql_proxy(common::ObMySQLProxy* sql_proxy)
  {
    sql_proxy_ = sql_proxy;
  }

private:
  common::ObMySQLProxy* sql_proxy_;
  DISALLOW_COPY_AND_ASSIGN(ObTenantVirtualCurrentTenant);
};
}  // namespace observer
}  // namespace oceanbase
#endif /* OCEANBASE_OBSERVER_VIRTUAL_TABLE_TENANT_VIRTUAL_CURRENT_TENANT_ */
