/**
 * Copyright (c) 2021 OceanBase
 * OceanBase CE is licensed under Mulan PubL v2.
 * You can use this software according to the terms and conditions of the Mulan PubL v2.
 * You may obtain a copy of Mulan PubL v2 at:
 *          http://license.coscl.org.cn/MulanPubL-2.0
 * THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OF ANY KIND,
 * EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO NON-INFRINGEMENT,
 * MERCHANTABILITY OR FIT FOR A PARTICULAR PURPOSE.
 * See the Mulan PubL v2 for more details.
 */

#ifndef OCEANBASE_SQL_EXECUTOR_OB_ADDRS_PROVIDER_FACTORY_
#define OCEANBASE_SQL_EXECUTOR_OB_ADDRS_PROVIDER_FACTORY_

#include "lib/allocator/ob_allocator.h"
#include "lib/container/ob_se_array.h"

namespace oceanbase {
namespace sql {
class ObAddrsProvider;
class ObExecContext;
class ObAddrsProviderFactory {
public:
  ObAddrsProviderFactory();
  virtual ~ObAddrsProviderFactory();
  void reset();
  int create(ObExecContext& exec_ctx, int provider_type, ObAddrsProvider*& servers_provider);

private:
  common::ObSEArray<ObAddrsProvider*, 4> store_;

private:
  DISALLOW_COPY_AND_ASSIGN(ObAddrsProviderFactory);
};
}  // namespace sql
}  // namespace oceanbase
#endif /* OCEANBASE_SQL_EXECUTOR_OB_ADDRS_PROVIDER_FACTORY_ */
