/**
 * Copyright (c) 2021 OceanBase
 * OceanBase CE is licensed under Mulan PubL v2.
 * You can use this software according to the terms and conditions of the Mulan PubL v2.
 * You may obtain a copy of Mulan PubL v2 at:
 *          http://license.coscl.org.cn/MulanPubL-2.0
 * THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OF ANY KIND,
 * EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO NON-INFRINGEMENT,
 * MERCHANTABILITY OR FIT FOR A PARTICULAR PURPOSE.
 * See the Mulan PubL v2 for more details.
 */

#ifndef OCEANBASE_SRC_SQL_RESOLVER_DDL_OB_DROP_TABLE_RESOLVER_H_
#define OCEANBASE_SRC_SQL_RESOLVER_DDL_OB_DROP_TABLE_RESOLVER_H_ 1
#include "sql/resolver/ddl/ob_ddl_resolver.h"
#include "sql/resolver/ddl/ob_drop_table_stmt.h"
namespace oceanbase {
namespace sql {
class ObDropTableResolver : public ObDDLResolver {
public:
  enum node_type { MATERIALIZED_NODE = 0, IF_EXIST_NODE, TABLE_LIST_NODE, MAX_NODE };

public:
  explicit ObDropTableResolver(ObResolverParams& params);
  virtual ~ObDropTableResolver();

  virtual int resolve(const ParseNode& parse_tree);

private:
  DISALLOW_COPY_AND_ASSIGN(ObDropTableResolver);
};
}  // namespace sql
}  // namespace oceanbase
#endif /* OCEANBASE_SRC_SQL_RESOLVER_DDL_OB_DROP_TABLE_RESOLVER_H_ */
