/**
 * Copyright (c) 2021 OceanBase
 * OceanBase CE is licensed under Mulan PubL v2.
 * You can use this software according to the terms and conditions of the Mulan PubL v2.
 * You may obtain a copy of Mulan PubL v2 at:
 *          http://license.coscl.org.cn/MulanPubL-2.0
 * THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OF ANY KIND,
 * EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO NON-INFRINGEMENT,
 * MERCHANTABILITY OR FIT FOR A PARTICULAR PURPOSE.
 * See the Mulan PubL v2 for more details.
 */

#ifndef _OB_RAW_EXPR_CANONICALIZER_H
#define _OB_RAW_EXPR_CANONICALIZER_H 1
#include "sql/resolver/expr/ob_raw_expr.h"
namespace oceanbase {
namespace sql {
class ObRawExprCanonicalizer {
public:
  ObRawExprCanonicalizer()
  {}
  virtual ~ObRawExprCanonicalizer()
  {}
  /**
   * Canonicalize the expression.
   *
   * @param expr [in/out]
   *
   * @return error code
   */
  virtual int canonicalize(ObRawExpr*& expr) = 0;

private:
  // types and constants
private:
  // disallow copy
  DISALLOW_COPY_AND_ASSIGN(ObRawExprCanonicalizer);
  // function members
private:
  // data members
};

}  // end namespace sql
}  // end namespace oceanbase

#endif /* _OB_RAW_EXPR_CANONICALIZER_H */
