/**
 * Copyright (c) 2021 OceanBase
 * OceanBase CE is licensed under Mulan PubL v2.
 * You can use this software according to the terms and conditions of the Mulan PubL v2.
 * You may obtain a copy of Mulan PubL v2 at:
 *          http://license.coscl.org.cn/MulanPubL-2.0
 * THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OF ANY KIND,
 * EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO NON-INFRINGEMENT,
 * MERCHANTABILITY OR FIT FOR A PARTICULAR PURPOSE.
 * See the Mulan PubL v2 for more details.
 */

#ifndef _OB_INNER_TABLE_SCHEMA_CONSTANTS_H_
#define _OB_INNER_TABLE_SCHEMA_CONSTANTS_H_

#include "share/ob_define.h"

namespace oceanbase
{
namespace share
{
namespace schema
{
class ObTableSchema;
}
}

namespace share
{
const uint64_t OB_ALL_CORE_TABLE_TID = 1; // "__all_core_table"
const uint64_t OB_ALL_ROOT_TABLE_TID = 2; // "__all_root_table"
const uint64_t OB_ALL_TABLE_TID = 3; // "__all_table"
const uint64_t OB_ALL_COLUMN_TID = 4; // "__all_column"
const uint64_t OB_ALL_DDL_OPERATION_TID = 5; // "__all_ddl_operation"
const uint64_t OB_ALL_TABLE_V2_TID = 7; // "__all_table_v2"
const uint64_t OB_ALL_META_TABLE_TID = 101; // "__all_meta_table"
const uint64_t OB_ALL_USER_TID = 102; // "__all_user"
const uint64_t OB_ALL_USER_HISTORY_TID = 103; // "__all_user_history"
const uint64_t OB_ALL_DATABASE_TID = 104; // "__all_database"
const uint64_t OB_ALL_DATABASE_HISTORY_TID = 105; // "__all_database_history"
const uint64_t OB_ALL_TABLEGROUP_TID = 106; // "__all_tablegroup"
const uint64_t OB_ALL_TABLEGROUP_HISTORY_TID = 107; // "__all_tablegroup_history"
const uint64_t OB_ALL_TENANT_TID = 108; // "__all_tenant"
const uint64_t OB_ALL_TENANT_HISTORY_TID = 109; // "__all_tenant_history"
const uint64_t OB_ALL_TABLE_PRIVILEGE_TID = 110; // "__all_table_privilege"
const uint64_t OB_ALL_TABLE_PRIVILEGE_HISTORY_TID = 111; // "__all_table_privilege_history"
const uint64_t OB_ALL_DATABASE_PRIVILEGE_TID = 112; // "__all_database_privilege"
const uint64_t OB_ALL_DATABASE_PRIVILEGE_HISTORY_TID = 113; // "__all_database_privilege_history"
const uint64_t OB_ALL_TABLE_HISTORY_TID = 114; // "__all_table_history"
const uint64_t OB_ALL_COLUMN_HISTORY_TID = 115; // "__all_column_history"
const uint64_t OB_ALL_ZONE_TID = 116; // "__all_zone"
const uint64_t OB_ALL_SERVER_TID = 117; // "__all_server"
const uint64_t OB_ALL_SYS_PARAMETER_TID = 118; // "__all_sys_parameter"
const uint64_t OB_TENANT_PARAMETER_TID = 119; // "__tenant_parameter"
const uint64_t OB_ALL_SYS_VARIABLE_TID = 120; // "__all_sys_variable"
const uint64_t OB_ALL_SYS_STAT_TID = 121; // "__all_sys_stat"
const uint64_t OB_ALL_COLUMN_STATISTIC_TID = 122; // "__all_column_statistic"
const uint64_t OB_ALL_UNIT_TID = 123; // "__all_unit"
const uint64_t OB_ALL_UNIT_CONFIG_TID = 124; // "__all_unit_config"
const uint64_t OB_ALL_RESOURCE_POOL_TID = 125; // "__all_resource_pool"
const uint64_t OB_ALL_TENANT_RESOURCE_USAGE_TID = 126; // "__all_tenant_resource_usage"
const uint64_t OB_ALL_SEQUENCE_TID = 127; // "__all_sequence"
const uint64_t OB_ALL_CHARSET_TID = 128; // "__all_charset"
const uint64_t OB_ALL_COLLATION_TID = 129; // "__all_collation"
const uint64_t OB_ALL_LOCAL_INDEX_STATUS_TID = 134; // "__all_local_index_status"
const uint64_t OB_ALL_DUMMY_TID = 135; // "__all_dummy"
const uint64_t OB_ALL_FROZEN_MAP_TID = 136; // "__all_frozen_map"
const uint64_t OB_ALL_CLOG_HISTORY_INFO_TID = 137; // "__all_clog_history_info"
const uint64_t OB_ALL_CLOG_HISTORY_INFO_V2_TID = 139; // "__all_clog_history_info_v2"
const uint64_t OB_ALL_ROOTSERVICE_EVENT_HISTORY_TID = 140; // "__all_rootservice_event_history"
const uint64_t OB_ALL_PRIVILEGE_TID = 141; // "__all_privilege"
const uint64_t OB_ALL_OUTLINE_TID = 142; // "__all_outline"
const uint64_t OB_ALL_OUTLINE_HISTORY_TID = 143; // "__all_outline_history"
const uint64_t OB_ALL_ELECTION_EVENT_HISTORY_TID = 144; // "__all_election_event_history"
const uint64_t OB_ALL_RECYCLEBIN_TID = 145; // "__all_recyclebin"
const uint64_t OB_ALL_PART_TID = 146; // "__all_part"
const uint64_t OB_ALL_PART_HISTORY_TID = 147; // "__all_part_history"
const uint64_t OB_ALL_SUB_PART_TID = 148; // "__all_sub_part"
const uint64_t OB_ALL_SUB_PART_HISTORY_TID = 149; // "__all_sub_part_history"
const uint64_t OB_ALL_PART_INFO_TID = 150; // "__all_part_info"
const uint64_t OB_ALL_PART_INFO_HISTORY_TID = 151; // "__all_part_info_history"
const uint64_t OB_ALL_DEF_SUB_PART_TID = 152; // "__all_def_sub_part"
const uint64_t OB_ALL_DEF_SUB_PART_HISTORY_TID = 153; // "__all_def_sub_part_history"
const uint64_t OB_ALL_SERVER_EVENT_HISTORY_TID = 154; // "__all_server_event_history"
const uint64_t OB_ALL_ROOTSERVICE_JOB_TID = 155; // "__all_rootservice_job"
const uint64_t OB_ALL_UNIT_LOAD_HISTORY_TID = 156; // "__all_unit_load_history"
const uint64_t OB_ALL_SYS_VARIABLE_HISTORY_TID = 157; // "__all_sys_variable_history"
const uint64_t OB_ALL_RESTORE_JOB_TID = 158; // "__all_restore_job"
const uint64_t OB_ALL_RESTORE_TASK_TID = 159; // "__all_restore_task"
const uint64_t OB_ALL_RESTORE_JOB_HISTORY_TID = 160; // "__all_restore_job_history"
const uint64_t OB_ALL_TIME_ZONE_TID = 161; // "__all_time_zone"
const uint64_t OB_ALL_TIME_ZONE_NAME_TID = 162; // "__all_time_zone_name"
const uint64_t OB_ALL_TIME_ZONE_TRANSITION_TID = 163; // "__all_time_zone_transition"
const uint64_t OB_ALL_TIME_ZONE_TRANSITION_TYPE_TID = 164; // "__all_time_zone_transition_type"
const uint64_t OB_ALL_DDL_ID_TID = 165; // "__all_ddl_id"
const uint64_t OB_ALL_FOREIGN_KEY_TID = 166; // "__all_foreign_key"
const uint64_t OB_ALL_FOREIGN_KEY_HISTORY_TID = 167; // "__all_foreign_key_history"
const uint64_t OB_ALL_FOREIGN_KEY_COLUMN_TID = 168; // "__all_foreign_key_column"
const uint64_t OB_ALL_FOREIGN_KEY_COLUMN_HISTORY_TID = 169; // "__all_foreign_key_column_history"
const uint64_t OB_ALL_SYNONYM_TID = 180; // "__all_synonym"
const uint64_t OB_ALL_SYNONYM_HISTORY_TID = 181; // "__all_synonym_history"
const uint64_t OB_ALL_SEQUENCE_V2_TID = 182; // "__all_sequence_v2"
const uint64_t OB_ALL_TENANT_META_TABLE_TID = 183; // "__all_tenant_meta_table"
const uint64_t OB_ALL_INDEX_WAIT_TRANSACTION_STATUS_TID = 186; // "__all_index_wait_transaction_status"
const uint64_t OB_ALL_INDEX_SCHEDULE_TASK_TID = 187; // "__all_index_schedule_task"
const uint64_t OB_ALL_INDEX_CHECKSUM_TID = 188; // "__all_index_checksum"
const uint64_t OB_ALL_ROUTINE_TID = 189; // "__all_routine"
const uint64_t OB_ALL_ROUTINE_HISTORY_TID = 190; // "__all_routine_history"
const uint64_t OB_ALL_ROUTINE_PARAM_TID = 191; // "__all_routine_param"
const uint64_t OB_ALL_ROUTINE_PARAM_HISTORY_TID = 192; // "__all_routine_param_history"
const uint64_t OB_ALL_TABLE_STAT_TID = 193; // "__all_table_stat"
const uint64_t OB_ALL_COLUMN_STAT_TID = 194; // "__all_column_stat"
const uint64_t OB_ALL_HISTOGRAM_STAT_TID = 195; // "__all_histogram_stat"
const uint64_t OB_ALL_PACKAGE_TID = 196; // "__all_package"
const uint64_t OB_ALL_PACKAGE_HISTORY_TID = 197; // "__all_package_history"
const uint64_t OB_ALL_SQL_EXECUTE_TASK_TID = 198; // "__all_sql_execute_task"
const uint64_t OB_ALL_INDEX_BUILD_STAT_TID = 199; // "__all_index_build_stat"
const uint64_t OB_ALL_BUILD_INDEX_PARAM_TID = 200; // "__all_build_index_param"
const uint64_t OB_ALL_GLOBAL_INDEX_DATA_SRC_TID = 201; // "__all_global_index_data_src"
const uint64_t OB_ALL_ACQUIRED_SNAPSHOT_TID = 202; // "__all_acquired_snapshot"
const uint64_t OB_ALL_IMMEDIATE_EFFECT_INDEX_SSTABLE_TID = 203; // "__all_immediate_effect_index_sstable"
const uint64_t OB_ALL_SSTABLE_CHECKSUM_TID = 204; // "__all_sstable_checksum"
const uint64_t OB_ALL_TENANT_GC_PARTITION_INFO_TID = 205; // "__all_tenant_gc_partition_info"
const uint64_t OB_ALL_CONSTRAINT_TID = 206; // "__all_constraint"
const uint64_t OB_ALL_CONSTRAINT_HISTORY_TID = 207; // "__all_constraint_history"
const uint64_t OB_ALL_ORI_SCHEMA_VERSION_TID = 208; // "__all_ori_schema_version"
const uint64_t OB_ALL_FUNC_TID = 209; // "__all_func"
const uint64_t OB_ALL_FUNC_HISTORY_TID = 210; // "__all_func_history"
const uint64_t OB_ALL_TEMP_TABLE_TID = 211; // "__all_temp_table"
const uint64_t OB_ALL_SSTABLE_COLUMN_CHECKSUM_TID = 212; // "__all_sstable_column_checksum"
const uint64_t OB_ALL_SEQUENCE_OBJECT_TID = 213; // "__all_sequence_object"
const uint64_t OB_ALL_SEQUENCE_OBJECT_HISTORY_TID = 214; // "__all_sequence_object_history"
const uint64_t OB_ALL_SEQUENCE_VALUE_TID = 215; // "__all_sequence_value"
const uint64_t OB_ALL_TENANT_PLAN_BASELINE_TID = 216; // "__all_tenant_plan_baseline"
const uint64_t OB_ALL_TENANT_PLAN_BASELINE_HISTORY_TID = 217; // "__all_tenant_plan_baseline_history"
const uint64_t OB_ALL_DDL_HELPER_TID = 218; // "__all_ddl_helper"
const uint64_t OB_ALL_FREEZE_SCHEMA_VERSION_TID = 219; // "__all_freeze_schema_version"
const uint64_t OB_ALL_TYPE_TID = 220; // "__all_type"
const uint64_t OB_ALL_TYPE_HISTORY_TID = 221; // "__all_type_history"
const uint64_t OB_ALL_TYPE_ATTR_TID = 222; // "__all_type_attr"
const uint64_t OB_ALL_TYPE_ATTR_HISTORY_TID = 223; // "__all_type_attr_history"
const uint64_t OB_ALL_COLL_TYPE_TID = 224; // "__all_coll_type"
const uint64_t OB_ALL_COLL_TYPE_HISTORY_TID = 225; // "__all_coll_type_history"
const uint64_t OB_ALL_WEAK_READ_SERVICE_TID = 226; // "__all_weak_read_service"
const uint64_t OB_ALL_GTS_TID = 229; // "__all_gts"
const uint64_t OB_ALL_TENANT_GTS_TID = 230; // "__all_tenant_gts"
const uint64_t OB_ALL_PARTITION_MEMBER_LIST_TID = 231; // "__all_partition_member_list"
const uint64_t OB_ALL_DBLINK_TID = 232; // "__all_dblink"
const uint64_t OB_ALL_DBLINK_HISTORY_TID = 233; // "__all_dblink_history"
const uint64_t OB_ALL_TENANT_PARTITION_META_TABLE_TID = 234; // "__all_tenant_partition_meta_table"
const uint64_t OB_ALL_TENANT_ROLE_GRANTEE_MAP_TID = 235; // "__all_tenant_role_grantee_map"
const uint64_t OB_ALL_TENANT_ROLE_GRANTEE_MAP_HISTORY_TID = 236; // "__all_tenant_role_grantee_map_history"
const uint64_t OB_ALL_TENANT_KEYSTORE_TID = 237; // "__all_tenant_keystore"
const uint64_t OB_ALL_TENANT_KEYSTORE_HISTORY_TID = 238; // "__all_tenant_keystore_history"
const uint64_t OB_ALL_TENANT_TABLESPACE_TID = 247; // "__all_tenant_tablespace"
const uint64_t OB_ALL_TENANT_TABLESPACE_HISTORY_TID = 248; // "__all_tenant_tablespace_history"
const uint64_t OB_ALL_TENANT_USER_FAILED_LOGIN_STAT_TID = 249; // "__all_tenant_user_failed_login_stat"
const uint64_t OB_ALL_TENANT_PROFILE_TID = 250; // "__all_tenant_profile"
const uint64_t OB_ALL_TENANT_PROFILE_HISTORY_TID = 251; // "__all_tenant_profile_history"
const uint64_t OB_ALL_TENANT_SECURITY_AUDIT_TID = 252; // "__all_tenant_security_audit"
const uint64_t OB_ALL_TENANT_SECURITY_AUDIT_HISTORY_TID = 253; // "__all_tenant_security_audit_history"
const uint64_t OB_ALL_TENANT_TRIGGER_TID = 254; // "__all_tenant_trigger"
const uint64_t OB_ALL_TENANT_TRIGGER_HISTORY_TID = 255; // "__all_tenant_trigger_history"
const uint64_t OB_ALL_SEED_PARAMETER_TID = 256; // "__all_seed_parameter"
const uint64_t OB_ALL_TENANT_SSTABLE_COLUMN_CHECKSUM_TID = 258; // "__all_tenant_sstable_column_checksum"
const uint64_t OB_ALL_TENANT_SECURITY_AUDIT_RECORD_TID = 259; // "__all_tenant_security_audit_record"
const uint64_t OB_ALL_TENANT_SYSAUTH_TID = 260; // "__all_tenant_sysauth"
const uint64_t OB_ALL_TENANT_SYSAUTH_HISTORY_TID = 261; // "__all_tenant_sysauth_history"
const uint64_t OB_ALL_TENANT_OBJAUTH_TID = 262; // "__all_tenant_objauth"
const uint64_t OB_ALL_TENANT_OBJAUTH_HISTORY_TID = 263; // "__all_tenant_objauth_history"
const uint64_t OB_ALL_TENANT_BACKUP_INFO_TID = 264; // "__all_tenant_backup_info"
const uint64_t OB_ALL_RESTORE_INFO_TID = 265; // "__all_restore_info"
const uint64_t OB_ALL_TENANT_BACKUP_LOG_ARCHIVE_STATUS_TID = 266; // "__all_tenant_backup_log_archive_status"
const uint64_t OB_ALL_BACKUP_LOG_ARCHIVE_STATUS_HISTORY_TID = 267; // "__all_backup_log_archive_status_history"
const uint64_t OB_ALL_TENANT_BACKUP_TASK_TID = 268; // "__all_tenant_backup_task"
const uint64_t OB_ALL_BACKUP_TASK_HISTORY_TID = 269; // "__all_backup_task_history"
const uint64_t OB_ALL_TENANT_PG_BACKUP_TASK_TID = 270; // "__all_tenant_pg_backup_task"
const uint64_t OB_ALL_TENANT_ERROR_TID = 272; // "__all_tenant_error"
const uint64_t OB_ALL_SERVER_RECOVERY_STATUS_TID = 273; // "__all_server_recovery_status"
const uint64_t OB_ALL_DATAFILE_RECOVERY_STATUS_TID = 274; // "__all_datafile_recovery_status"
const uint64_t OB_ALL_TENANT_BACKUP_CLEAN_INFO_TID = 276; // "__all_tenant_backup_clean_info"
const uint64_t OB_ALL_BACKUP_CLEAN_INFO_HISTORY_TID = 277; // "__all_backup_clean_info_history"
const uint64_t OB_ALL_BACKUP_TASK_CLEAN_HISTORY_TID = 278; // "__all_backup_task_clean_history"
const uint64_t OB_ALL_RESTORE_PROGRESS_TID = 279; // "__all_restore_progress"
const uint64_t OB_ALL_RESTORE_HISTORY_TID = 280; // "__all_restore_history"
const uint64_t OB_ALL_TENANT_RESTORE_PG_INFO_TID = 281; // "__all_tenant_restore_pg_info"
const uint64_t OB_ALL_TABLE_V2_HISTORY_TID = 282; // "__all_table_v2_history"
const uint64_t OB_ALL_TENANT_OBJECT_TYPE_TID = 283; // "__all_tenant_object_type"
const uint64_t OB_ALL_TENANT_OBJECT_TYPE_HISTORY_TID = 284; // "__all_tenant_object_type_history"
const uint64_t OB_ALL_BACKUP_VALIDATION_JOB_TID = 285; // "__all_backup_validation_job"
const uint64_t OB_ALL_BACKUP_VALIDATION_JOB_HISTORY_TID = 286; // "__all_backup_validation_job_history"
const uint64_t OB_ALL_TENANT_BACKUP_VALIDATION_TASK_TID = 287; // "__all_tenant_backup_validation_task"
const uint64_t OB_ALL_BACKUP_VALIDATION_TASK_HISTORY_TID = 288; // "__all_backup_validation_task_history"
const uint64_t OB_ALL_TENANT_PG_BACKUP_VALIDATION_TASK_TID = 289; // "__all_tenant_pg_backup_validation_task"
const uint64_t OB_ALL_TENANT_TIME_ZONE_TID = 290; // "__all_tenant_time_zone"
const uint64_t OB_ALL_TENANT_TIME_ZONE_NAME_TID = 291; // "__all_tenant_time_zone_name"
const uint64_t OB_ALL_TENANT_TIME_ZONE_TRANSITION_TID = 292; // "__all_tenant_time_zone_transition"
const uint64_t OB_ALL_TENANT_TIME_ZONE_TRANSITION_TYPE_TID = 293; // "__all_tenant_time_zone_transition_type"
const uint64_t OB_ALL_TENANT_CONSTRAINT_COLUMN_TID = 294; // "__all_tenant_constraint_column"
const uint64_t OB_ALL_TENANT_CONSTRAINT_COLUMN_HISTORY_TID = 295; // "__all_tenant_constraint_column_history"
const uint64_t OB_ALL_TENANT_GLOBAL_TRANSACTION_TID = 296; // "__all_tenant_global_transaction"
const uint64_t OB_ALL_TENANT_DEPENDENCY_TID = 297; // "__all_tenant_dependency"
const uint64_t OB_ALL_BACKUP_BACKUPSET_JOB_TID = 298; // "__all_backup_backupset_job"
const uint64_t OB_ALL_BACKUP_BACKUPSET_JOB_HISTORY_TID = 299; // "__all_backup_backupset_job_history"
const uint64_t OB_ALL_TENANT_BACKUP_BACKUPSET_TASK_TID = 300; // "__all_tenant_backup_backupset_task"
const uint64_t OB_ALL_BACKUP_BACKUPSET_TASK_HISTORY_TID = 301; // "__all_backup_backupset_task_history"
const uint64_t OB_ALL_TENANT_PG_BACKUP_BACKUPSET_TASK_TID = 302; // "__all_tenant_pg_backup_backupset_task"
const uint64_t OB_ALL_TENANT_BACKUP_BACKUP_LOG_ARCHIVE_STATUS_TID = 303; // "__all_tenant_backup_backup_log_archive_status"
const uint64_t OB_ALL_BACKUP_BACKUP_LOG_ARCHIVE_STATUS_HISTORY_TID = 304; // "__all_backup_backup_log_archive_status_history"
const uint64_t OB_ALL_RES_MGR_PLAN_TID = 305; // "__all_res_mgr_plan"
const uint64_t OB_ALL_RES_MGR_DIRECTIVE_TID = 306; // "__all_res_mgr_directive"
const uint64_t OB_ALL_RES_MGR_MAPPING_RULE_TID = 307; // "__all_res_mgr_mapping_rule"
const uint64_t OB_ALL_RES_MGR_CONSUMER_GROUP_TID = 316; // "__all_res_mgr_consumer_group"
const uint64_t OB_TENANT_VIRTUAL_ALL_TABLE_TID = 10001; // "__tenant_virtual_all_table"
const uint64_t OB_TENANT_VIRTUAL_TABLE_COLUMN_TID = 10002; // "__tenant_virtual_table_column"
const uint64_t OB_TENANT_VIRTUAL_TABLE_INDEX_TID = 10003; // "__tenant_virtual_table_index"
const uint64_t OB_TENANT_VIRTUAL_SHOW_CREATE_DATABASE_TID = 10004; // "__tenant_virtual_show_create_database"
const uint64_t OB_TENANT_VIRTUAL_SHOW_CREATE_TABLE_TID = 10005; // "__tenant_virtual_show_create_table"
const uint64_t OB_TENANT_VIRTUAL_SESSION_VARIABLE_TID = 10006; // "__tenant_virtual_session_variable"
const uint64_t OB_TENANT_VIRTUAL_PRIVILEGE_GRANT_TID = 10007; // "__tenant_virtual_privilege_grant"
const uint64_t OB_ALL_VIRTUAL_PROCESSLIST_TID = 10008; // "__all_virtual_processlist"
const uint64_t OB_TENANT_VIRTUAL_WARNING_TID = 10009; // "__tenant_virtual_warning"
const uint64_t OB_TENANT_VIRTUAL_CURRENT_TENANT_TID = 10010; // "__tenant_virtual_current_tenant"
const uint64_t OB_TENANT_VIRTUAL_DATABASE_STATUS_TID = 10011; // "__tenant_virtual_database_status"
const uint64_t OB_TENANT_VIRTUAL_TENANT_STATUS_TID = 10012; // "__tenant_virtual_tenant_status"
const uint64_t OB_TENANT_VIRTUAL_INTERM_RESULT_TID = 10013; // "__tenant_virtual_interm_result"
const uint64_t OB_TENANT_VIRTUAL_PARTITION_STAT_TID = 10014; // "__tenant_virtual_partition_stat"
const uint64_t OB_TENANT_VIRTUAL_STATNAME_TID = 10015; // "__tenant_virtual_statname"
const uint64_t OB_TENANT_VIRTUAL_EVENT_NAME_TID = 10016; // "__tenant_virtual_event_name"
const uint64_t OB_TENANT_VIRTUAL_GLOBAL_VARIABLE_TID = 10017; // "__tenant_virtual_global_variable"
const uint64_t OB_TENANT_VIRTUAL_SHOW_TABLES_TID = 10018; // "__tenant_virtual_show_tables"
const uint64_t OB_TENANT_VIRTUAL_SHOW_CREATE_PROCEDURE_TID = 10019; // "__tenant_virtual_show_create_procedure"
const uint64_t OB_ALL_VIRTUAL_CORE_META_TABLE_TID = 11001; // "__all_virtual_core_meta_table"
const uint64_t OB_ALL_VIRTUAL_ZONE_STAT_TID = 11002; // "__all_virtual_zone_stat"
const uint64_t OB_ALL_VIRTUAL_PLAN_CACHE_STAT_TID = 11003; // "__all_virtual_plan_cache_stat"
const uint64_t OB_ALL_VIRTUAL_PLAN_STAT_TID = 11004; // "__all_virtual_plan_stat"
const uint64_t OB_ALL_VIRTUAL_MEM_LEAK_CHECKER_INFO_TID = 11006; // "__all_virtual_mem_leak_checker_info"
const uint64_t OB_ALL_VIRTUAL_LATCH_TID = 11007; // "__all_virtual_latch"
const uint64_t OB_ALL_VIRTUAL_KVCACHE_INFO_TID = 11008; // "__all_virtual_kvcache_info"
const uint64_t OB_ALL_VIRTUAL_DATA_TYPE_CLASS_TID = 11009; // "__all_virtual_data_type_class"
const uint64_t OB_ALL_VIRTUAL_DATA_TYPE_TID = 11010; // "__all_virtual_data_type"
const uint64_t OB_ALL_VIRTUAL_SERVER_STAT_TID = 11011; // "__all_virtual_server_stat"
const uint64_t OB_ALL_VIRTUAL_REBALANCE_TASK_STAT_TID = 11012; // "__all_virtual_rebalance_task_stat"
const uint64_t OB_ALL_VIRTUAL_SESSION_EVENT_TID = 11013; // "__all_virtual_session_event"
const uint64_t OB_ALL_VIRTUAL_SESSION_WAIT_TID = 11014; // "__all_virtual_session_wait"
const uint64_t OB_ALL_VIRTUAL_SESSION_WAIT_HISTORY_TID = 11015; // "__all_virtual_session_wait_history"
const uint64_t OB_ALL_VIRTUAL_SYSTEM_EVENT_TID = 11017; // "__all_virtual_system_event"
const uint64_t OB_ALL_VIRTUAL_TENANT_MEMSTORE_INFO_TID = 11018; // "__all_virtual_tenant_memstore_info"
const uint64_t OB_ALL_VIRTUAL_CONCURRENCY_OBJECT_POOL_TID = 11019; // "__all_virtual_concurrency_object_pool"
const uint64_t OB_ALL_VIRTUAL_SESSTAT_TID = 11020; // "__all_virtual_sesstat"
const uint64_t OB_ALL_VIRTUAL_SYSSTAT_TID = 11021; // "__all_virtual_sysstat"
const uint64_t OB_ALL_VIRTUAL_STORAGE_STAT_TID = 11022; // "__all_virtual_storage_stat"
const uint64_t OB_ALL_VIRTUAL_DISK_STAT_TID = 11023; // "__all_virtual_disk_stat"
const uint64_t OB_ALL_VIRTUAL_MEMSTORE_INFO_TID = 11024; // "__all_virtual_memstore_info"
const uint64_t OB_ALL_VIRTUAL_PARTITION_INFO_TID = 11025; // "__all_virtual_partition_info"
const uint64_t OB_ALL_VIRTUAL_UPGRADE_INSPECTION_TID = 11026; // "__all_virtual_upgrade_inspection"
const uint64_t OB_ALL_VIRTUAL_TRANS_STAT_TID = 11027; // "__all_virtual_trans_stat"
const uint64_t OB_ALL_VIRTUAL_TRANS_MGR_STAT_TID = 11028; // "__all_virtual_trans_mgr_stat"
const uint64_t OB_ALL_VIRTUAL_ELECTION_INFO_TID = 11029; // "__all_virtual_election_info"
const uint64_t OB_ALL_VIRTUAL_ELECTION_MEM_STAT_TID = 11030; // "__all_virtual_election_mem_stat"
const uint64_t OB_ALL_VIRTUAL_SQL_AUDIT_TID = 11031; // "__all_virtual_sql_audit"
const uint64_t OB_ALL_VIRTUAL_TRANS_MEM_STAT_TID = 11032; // "__all_virtual_trans_mem_stat"
const uint64_t OB_ALL_VIRTUAL_PARTITION_SSTABLE_IMAGE_INFO_TID = 11033; // "__all_virtual_partition_sstable_image_info"
const uint64_t OB_ALL_VIRTUAL_CORE_ROOT_TABLE_TID = 11034; // "__all_virtual_core_root_table"
const uint64_t OB_ALL_VIRTUAL_CORE_ALL_TABLE_TID = 11035; // "__all_virtual_core_all_table"
const uint64_t OB_ALL_VIRTUAL_CORE_COLUMN_TABLE_TID = 11036; // "__all_virtual_core_column_table"
const uint64_t OB_ALL_VIRTUAL_MEMORY_INFO_TID = 11037; // "__all_virtual_memory_info"
const uint64_t OB_ALL_VIRTUAL_TENANT_STAT_TID = 11038; // "__all_virtual_tenant_stat"
const uint64_t OB_ALL_VIRTUAL_SYS_PARAMETER_STAT_TID = 11039; // "__all_virtual_sys_parameter_stat"
const uint64_t OB_ALL_VIRTUAL_PARTITION_REPLAY_STATUS_TID = 11040; // "__all_virtual_partition_replay_status"
const uint64_t OB_ALL_VIRTUAL_CLOG_STAT_TID = 11041; // "__all_virtual_clog_stat"
const uint64_t OB_ALL_VIRTUAL_TRACE_LOG_TID = 11042; // "__all_virtual_trace_log"
const uint64_t OB_ALL_VIRTUAL_ENGINE_TID = 11043; // "__all_virtual_engine"
const uint64_t OB_ALL_VIRTUAL_PROXY_SERVER_STAT_TID = 11045; // "__all_virtual_proxy_server_stat"
const uint64_t OB_ALL_VIRTUAL_PROXY_SYS_VARIABLE_TID = 11046; // "__all_virtual_proxy_sys_variable"
const uint64_t OB_ALL_VIRTUAL_PROXY_SCHEMA_TID = 11047; // "__all_virtual_proxy_schema"
const uint64_t OB_ALL_VIRTUAL_PLAN_CACHE_PLAN_EXPLAIN_TID = 11048; // "__all_virtual_plan_cache_plan_explain"
const uint64_t OB_ALL_VIRTUAL_OBRPC_STAT_TID = 11049; // "__all_virtual_obrpc_stat"
const uint64_t OB_ALL_VIRTUAL_PARTITION_SSTABLE_MERGE_INFO_TID = 11051; // "__all_virtual_partition_sstable_merge_info"
const uint64_t OB_ALL_VIRTUAL_SQL_MONITOR_TID = 11052; // "__all_virtual_sql_monitor"
const uint64_t OB_TENANT_VIRTUAL_OUTLINE_TID = 11053; // "__tenant_virtual_outline"
const uint64_t OB_TENANT_VIRTUAL_CONCURRENT_LIMIT_SQL_TID = 11054; // "__tenant_virtual_concurrent_limit_sql"
const uint64_t OB_ALL_VIRTUAL_SQL_PLAN_STATISTICS_TID = 11055; // "__all_virtual_sql_plan_statistics"
const uint64_t OB_ALL_VIRTUAL_PARTITION_SSTABLE_MACRO_INFO_TID = 11056; // "__all_virtual_partition_sstable_macro_info"
const uint64_t OB_ALL_VIRTUAL_PROXY_PARTITION_INFO_TID = 11057; // "__all_virtual_proxy_partition_info"
const uint64_t OB_ALL_VIRTUAL_PROXY_PARTITION_TID = 11058; // "__all_virtual_proxy_partition"
const uint64_t OB_ALL_VIRTUAL_PROXY_SUB_PARTITION_TID = 11059; // "__all_virtual_proxy_sub_partition"
const uint64_t OB_ALL_VIRTUAL_PROXY_ROUTE_TID = 11060; // "__all_virtual_proxy_route"
const uint64_t OB_ALL_VIRTUAL_REBALANCE_TENANT_STAT_TID = 11061; // "__all_virtual_rebalance_tenant_stat"
const uint64_t OB_ALL_VIRTUAL_REBALANCE_UNIT_STAT_TID = 11062; // "__all_virtual_rebalance_unit_stat"
const uint64_t OB_ALL_VIRTUAL_REBALANCE_REPLICA_STAT_TID = 11063; // "__all_virtual_rebalance_replica_stat"
const uint64_t OB_ALL_VIRTUAL_PARTITION_AMPLIFICATION_STAT_TID = 11064; // "__all_virtual_partition_amplification_stat"
const uint64_t OB_ALL_VIRTUAL_ELECTION_EVENT_HISTORY_TID = 11067; // "__all_virtual_election_event_history"
const uint64_t OB_ALL_VIRTUAL_PARTITION_STORE_INFO_TID = 11068; // "__all_virtual_partition_store_info"
const uint64_t OB_ALL_VIRTUAL_LEADER_STAT_TID = 11069; // "__all_virtual_leader_stat"
const uint64_t OB_ALL_VIRTUAL_PARTITION_MIGRATION_STATUS_TID = 11070; // "__all_virtual_partition_migration_status"
const uint64_t OB_ALL_VIRTUAL_SYS_TASK_STATUS_TID = 11071; // "__all_virtual_sys_task_status"
const uint64_t OB_ALL_VIRTUAL_MACRO_BLOCK_MARKER_STATUS_TID = 11072; // "__all_virtual_macro_block_marker_status"
const uint64_t OB_ALL_VIRTUAL_SERVER_CLOG_STAT_TID = 11073; // "__all_virtual_server_clog_stat"
const uint64_t OB_ALL_VIRTUAL_ROOTSERVICE_STAT_TID = 11074; // "__all_virtual_rootservice_stat"
const uint64_t OB_ALL_VIRTUAL_ELECTION_PRIORITY_TID = 11075; // "__all_virtual_election_priority"
const uint64_t OB_ALL_VIRTUAL_TENANT_DISK_STAT_TID = 11076; // "__all_virtual_tenant_disk_stat"
const uint64_t OB_ALL_VIRTUAL_REBALANCE_MAP_STAT_TID = 11078; // "__all_virtual_rebalance_map_stat"
const uint64_t OB_ALL_VIRTUAL_REBALANCE_MAP_ITEM_STAT_TID = 11079; // "__all_virtual_rebalance_map_item_stat"
const uint64_t OB_ALL_VIRTUAL_IO_STAT_TID = 11080; // "__all_virtual_io_stat"
const uint64_t OB_ALL_VIRTUAL_LONG_OPS_STATUS_TID = 11081; // "__all_virtual_long_ops_status"
const uint64_t OB_ALL_VIRTUAL_REBALANCE_UNIT_MIGRATE_STAT_TID = 11082; // "__all_virtual_rebalance_unit_migrate_stat"
const uint64_t OB_ALL_VIRTUAL_REBALANCE_UNIT_DISTRIBUTION_STAT_TID = 11083; // "__all_virtual_rebalance_unit_distribution_stat"
const uint64_t OB_ALL_VIRTUAL_SERVER_OBJECT_POOL_TID = 11084; // "__all_virtual_server_object_pool"
const uint64_t OB_ALL_VIRTUAL_TRANS_LOCK_STAT_TID = 11085; // "__all_virtual_trans_lock_stat"
const uint64_t OB_ALL_VIRTUAL_ELECTION_GROUP_INFO_TID = 11086; // "__all_virtual_election_group_info"
const uint64_t OB_TENANT_VIRTUAL_SHOW_CREATE_TABLEGROUP_TID = 11087; // "__tenant_virtual_show_create_tablegroup"
const uint64_t OB_ALL_VIRTUAL_SERVER_BLACKLIST_TID = 11088; // "__all_virtual_server_blacklist"
const uint64_t OB_ALL_VIRTUAL_PARTITION_SPLIT_INFO_TID = 11089; // "__all_virtual_partition_split_info"
const uint64_t OB_ALL_VIRTUAL_TRANS_RESULT_INFO_STAT_TID = 11090; // "__all_virtual_trans_result_info_stat"
const uint64_t OB_ALL_VIRTUAL_DUPLICATE_PARTITION_MGR_STAT_TID = 11091; // "__all_virtual_duplicate_partition_mgr_stat"
const uint64_t OB_ALL_VIRTUAL_TENANT_PARAMETER_STAT_TID = 11092; // "__all_virtual_tenant_parameter_stat"
const uint64_t OB_ALL_VIRTUAL_SERVER_SCHEMA_INFO_TID = 11093; // "__all_virtual_server_schema_info"
const uint64_t OB_ALL_VIRTUAL_MEMORY_CONTEXT_STAT_TID = 11094; // "__all_virtual_memory_context_stat"
const uint64_t OB_ALL_VIRTUAL_DUMP_TENANT_INFO_TID = 11095; // "__all_virtual_dump_tenant_info"
const uint64_t OB_ALL_VIRTUAL_TENANT_PARAMETER_INFO_TID = 11096; // "__all_virtual_tenant_parameter_info"
const uint64_t OB_ALL_VIRTUAL_DAG_WARNING_HISTORY_TID = 11099; // "__all_virtual_dag_warning_history"
const uint64_t OB_SESSION_VARIABLES_TID = 12001; // "SESSION_VARIABLES"
const uint64_t OB_TABLE_PRIVILEGES_TID = 12002; // "TABLE_PRIVILEGES"
const uint64_t OB_USER_PRIVILEGES_TID = 12003; // "USER_PRIVILEGES"
const uint64_t OB_SCHEMA_PRIVILEGES_TID = 12004; // "SCHEMA_PRIVILEGES"
const uint64_t OB_TABLE_CONSTRAINTS_TID = 12005; // "TABLE_CONSTRAINTS"
const uint64_t OB_GLOBAL_STATUS_TID = 12006; // "GLOBAL_STATUS"
const uint64_t OB_PARTITIONS_TID = 12007; // "PARTITIONS"
const uint64_t OB_SESSION_STATUS_TID = 12008; // "SESSION_STATUS"
const uint64_t OB_USER_TID = 12009; // "user"
const uint64_t OB_DB_TID = 12010; // "db"
const uint64_t OB_ALL_VIRTUAL_SERVER_MEMORY_INFO_TID = 12011; // "__all_virtual_server_memory_info"
const uint64_t OB_ALL_VIRTUAL_PARTITION_TABLE_TID = 12012; // "__all_virtual_partition_table"
const uint64_t OB_ALL_VIRTUAL_LOCK_WAIT_STAT_TID = 12013; // "__all_virtual_lock_wait_stat"
const uint64_t OB_ALL_VIRTUAL_PARTITION_ITEM_TID = 12014; // "__all_virtual_partition_item"
const uint64_t OB_ALL_VIRTUAL_REPLICA_TASK_TID = 12015; // "__all_virtual_replica_task"
const uint64_t OB_ALL_VIRTUAL_PARTITION_LOCATION_TID = 12016; // "__all_virtual_partition_location"
const uint64_t OB_PROC_TID = 12030; // "proc"
const uint64_t OB_TENANT_VIRTUAL_COLLATION_TID = 12031; // "__tenant_virtual_collation"
const uint64_t OB_TENANT_VIRTUAL_CHARSET_TID = 12032; // "__tenant_virtual_charset"
const uint64_t OB_ALL_VIRTUAL_TENANT_MEMSTORE_ALLOCATOR_INFO_TID = 12033; // "__all_virtual_tenant_memstore_allocator_info"
const uint64_t OB_ALL_VIRTUAL_TABLE_MGR_TID = 12034; // "__all_virtual_table_mgr"
const uint64_t OB_ALL_VIRTUAL_META_TABLE_TID = 12035; // "__all_virtual_meta_table"
const uint64_t OB_ALL_VIRTUAL_FREEZE_INFO_TID = 12036; // "__all_virtual_freeze_info"
const uint64_t OB_PARAMETERS_TID = 12037; // "PARAMETERS"
const uint64_t OB_ALL_VIRTUAL_BAD_BLOCK_TABLE_TID = 12038; // "__all_virtual_bad_block_table"
const uint64_t OB_ALL_VIRTUAL_PX_WORKER_STAT_TID = 12039; // "__all_virtual_px_worker_stat"
const uint64_t OB_ALL_VIRTUAL_TRANS_AUDIT_TID = 12040; // "__all_virtual_trans_audit"
const uint64_t OB_ALL_VIRTUAL_TRANS_SQL_AUDIT_TID = 12041; // "__all_virtual_trans_sql_audit"
const uint64_t OB_ALL_VIRTUAL_WEAK_READ_STAT_TID = 12042; // "__all_virtual_weak_read_stat"
const uint64_t OB_ALL_VIRTUAL_PARTITION_AUDIT_TID = 12054; // "__all_virtual_partition_audit"
const uint64_t OB_ALL_VIRTUAL_SEQUENCE_V2_TID = 12055; // "__all_virtual_sequence_v2"
const uint64_t OB_ALL_VIRTUAL_SEQUENCE_VALUE_TID = 12056; // "__all_virtual_sequence_value"
const uint64_t OB_ALL_VIRTUAL_CLUSTER_TID = 12057; // "__all_virtual_cluster"
const uint64_t OB_ALL_VIRTUAL_PARTITION_TABLE_STORE_STAT_TID = 12058; // "__all_virtual_partition_table_store_stat"
const uint64_t OB_ALL_VIRTUAL_DDL_OPERATION_TID = 12059; // "__all_virtual_ddl_operation"
const uint64_t OB_ALL_VIRTUAL_OUTLINE_TID = 12060; // "__all_virtual_outline"
const uint64_t OB_ALL_VIRTUAL_OUTLINE_HISTORY_TID = 12061; // "__all_virtual_outline_history"
const uint64_t OB_ALL_VIRTUAL_SYNONYM_TID = 12062; // "__all_virtual_synonym"
const uint64_t OB_ALL_VIRTUAL_SYNONYM_HISTORY_TID = 12063; // "__all_virtual_synonym_history"
const uint64_t OB_ALL_VIRTUAL_DATABASE_PRIVILEGE_TID = 12064; // "__all_virtual_database_privilege"
const uint64_t OB_ALL_VIRTUAL_DATABASE_PRIVILEGE_HISTORY_TID = 12065; // "__all_virtual_database_privilege_history"
const uint64_t OB_ALL_VIRTUAL_TABLE_PRIVILEGE_TID = 12066; // "__all_virtual_table_privilege"
const uint64_t OB_ALL_VIRTUAL_TABLE_PRIVILEGE_HISTORY_TID = 12067; // "__all_virtual_table_privilege_history"
const uint64_t OB_ALL_VIRTUAL_DATABASE_TID = 12068; // "__all_virtual_database"
const uint64_t OB_ALL_VIRTUAL_DATABASE_HISTORY_TID = 12069; // "__all_virtual_database_history"
const uint64_t OB_ALL_VIRTUAL_TABLEGROUP_TID = 12070; // "__all_virtual_tablegroup"
const uint64_t OB_ALL_VIRTUAL_TABLEGROUP_HISTORY_TID = 12071; // "__all_virtual_tablegroup_history"
const uint64_t OB_ALL_VIRTUAL_TABLE_TID = 12072; // "__all_virtual_table"
const uint64_t OB_ALL_VIRTUAL_TABLE_HISTORY_TID = 12073; // "__all_virtual_table_history"
const uint64_t OB_ALL_VIRTUAL_COLUMN_TID = 12074; // "__all_virtual_column"
const uint64_t OB_ALL_VIRTUAL_COLUMN_HISTORY_TID = 12075; // "__all_virtual_column_history"
const uint64_t OB_ALL_VIRTUAL_PART_TID = 12076; // "__all_virtual_part"
const uint64_t OB_ALL_VIRTUAL_PART_HISTORY_TID = 12077; // "__all_virtual_part_history"
const uint64_t OB_ALL_VIRTUAL_PART_INFO_TID = 12078; // "__all_virtual_part_info"
const uint64_t OB_ALL_VIRTUAL_PART_INFO_HISTORY_TID = 12079; // "__all_virtual_part_info_history"
const uint64_t OB_ALL_VIRTUAL_DEF_SUB_PART_TID = 12080; // "__all_virtual_def_sub_part"
const uint64_t OB_ALL_VIRTUAL_DEF_SUB_PART_HISTORY_TID = 12081; // "__all_virtual_def_sub_part_history"
const uint64_t OB_ALL_VIRTUAL_SUB_PART_TID = 12082; // "__all_virtual_sub_part"
const uint64_t OB_ALL_VIRTUAL_SUB_PART_HISTORY_TID = 12083; // "__all_virtual_sub_part_history"
const uint64_t OB_ALL_VIRTUAL_CONSTRAINT_TID = 12084; // "__all_virtual_constraint"
const uint64_t OB_ALL_VIRTUAL_CONSTRAINT_HISTORY_TID = 12085; // "__all_virtual_constraint_history"
const uint64_t OB_ALL_VIRTUAL_FOREIGN_KEY_TID = 12086; // "__all_virtual_foreign_key"
const uint64_t OB_ALL_VIRTUAL_FOREIGN_KEY_HISTORY_TID = 12087; // "__all_virtual_foreign_key_history"
const uint64_t OB_ALL_VIRTUAL_FOREIGN_KEY_COLUMN_TID = 12088; // "__all_virtual_foreign_key_column"
const uint64_t OB_ALL_VIRTUAL_FOREIGN_KEY_COLUMN_HISTORY_TID = 12089; // "__all_virtual_foreign_key_column_history"
const uint64_t OB_ALL_VIRTUAL_TEMP_TABLE_TID = 12090; // "__all_virtual_temp_table"
const uint64_t OB_ALL_VIRTUAL_ORI_SCHEMA_VERSION_TID = 12091; // "__all_virtual_ori_schema_version"
const uint64_t OB_ALL_VIRTUAL_SYS_STAT_TID = 12092; // "__all_virtual_sys_stat"
const uint64_t OB_ALL_VIRTUAL_USER_TID = 12093; // "__all_virtual_user"
const uint64_t OB_ALL_VIRTUAL_USER_HISTORY_TID = 12094; // "__all_virtual_user_history"
const uint64_t OB_ALL_VIRTUAL_SYS_VARIABLE_TID = 12095; // "__all_virtual_sys_variable"
const uint64_t OB_ALL_VIRTUAL_SYS_VARIABLE_HISTORY_TID = 12096; // "__all_virtual_sys_variable_history"
const uint64_t OB_ALL_VIRTUAL_FUNC_TID = 12097; // "__all_virtual_func"
const uint64_t OB_ALL_VIRTUAL_FUNC_HISTORY_TID = 12098; // "__all_virtual_func_history"
const uint64_t OB_ALL_VIRTUAL_PACKAGE_TID = 12099; // "__all_virtual_package"
const uint64_t OB_ALL_VIRTUAL_PACKAGE_HISTORY_TID = 12100; // "__all_virtual_package_history"
const uint64_t OB_ALL_VIRTUAL_ROUTINE_TID = 12101; // "__all_virtual_routine"
const uint64_t OB_ALL_VIRTUAL_ROUTINE_HISTORY_TID = 12102; // "__all_virtual_routine_history"
const uint64_t OB_ALL_VIRTUAL_ROUTINE_PARAM_TID = 12103; // "__all_virtual_routine_param"
const uint64_t OB_ALL_VIRTUAL_ROUTINE_PARAM_HISTORY_TID = 12104; // "__all_virtual_routine_param_history"
const uint64_t OB_ALL_VIRTUAL_TYPE_TID = 12105; // "__all_virtual_type"
const uint64_t OB_ALL_VIRTUAL_TYPE_HISTORY_TID = 12106; // "__all_virtual_type_history"
const uint64_t OB_ALL_VIRTUAL_TYPE_ATTR_TID = 12107; // "__all_virtual_type_attr"
const uint64_t OB_ALL_VIRTUAL_TYPE_ATTR_HISTORY_TID = 12108; // "__all_virtual_type_attr_history"
const uint64_t OB_ALL_VIRTUAL_COLL_TYPE_TID = 12109; // "__all_virtual_coll_type"
const uint64_t OB_ALL_VIRTUAL_COLL_TYPE_HISTORY_TID = 12110; // "__all_virtual_coll_type_history"
const uint64_t OB_ALL_VIRTUAL_COLUMN_STAT_TID = 12111; // "__all_virtual_column_stat"
const uint64_t OB_ALL_VIRTUAL_TABLE_STAT_TID = 12112; // "__all_virtual_table_stat"
const uint64_t OB_ALL_VIRTUAL_HISTOGRAM_STAT_TID = 12113; // "__all_virtual_histogram_stat"
const uint64_t OB_ALL_VIRTUAL_COLUMN_STATISTIC_TID = 12114; // "__all_virtual_column_statistic"
const uint64_t OB_ALL_VIRTUAL_RECYCLEBIN_TID = 12115; // "__all_virtual_recyclebin"
const uint64_t OB_ALL_VIRTUAL_TENANT_GC_PARTITION_INFO_TID = 12116; // "__all_virtual_tenant_gc_partition_info"
const uint64_t OB_ALL_VIRTUAL_TENANT_PLAN_BASELINE_TID = 12117; // "__all_virtual_tenant_plan_baseline"
const uint64_t OB_ALL_VIRTUAL_TENANT_PLAN_BASELINE_HISTORY_TID = 12118; // "__all_virtual_tenant_plan_baseline_history"
const uint64_t OB_ALL_VIRTUAL_SEQUENCE_OBJECT_TID = 12119; // "__all_virtual_sequence_object"
const uint64_t OB_ALL_VIRTUAL_SEQUENCE_OBJECT_HISTORY_TID = 12120; // "__all_virtual_sequence_object_history"
const uint64_t OB_ALL_VIRTUAL_RAID_STAT_TID = 12121; // "__all_virtual_raid_stat"
const uint64_t OB_ALL_VIRTUAL_SERVER_LOG_META_TID = 12122; // "__all_virtual_server_log_meta"
const uint64_t OB_ALL_VIRTUAL_DTL_CHANNEL_TID = 12123; // "__all_virtual_dtl_channel"
const uint64_t OB_ALL_VIRTUAL_DTL_MEMORY_TID = 12124; // "__all_virtual_dtl_memory"
const uint64_t OB_ALL_VIRTUAL_DTL_FIRST_CACHED_BUFFER_TID = 12125; // "__all_virtual_dtl_first_cached_buffer"
const uint64_t OB_ALL_VIRTUAL_DBLINK_TID = 12126; // "__all_virtual_dblink"
const uint64_t OB_ALL_VIRTUAL_DBLINK_HISTORY_TID = 12127; // "__all_virtual_dblink_history"
const uint64_t OB_ALL_VIRTUAL_TENANT_PARTITION_META_TABLE_TID = 12128; // "__all_virtual_tenant_partition_meta_table"
const uint64_t OB_ALL_VIRTUAL_TENANT_ROLE_GRANTEE_MAP_TID = 12129; // "__all_virtual_tenant_role_grantee_map"
const uint64_t OB_ALL_VIRTUAL_TENANT_ROLE_GRANTEE_MAP_HISTORY_TID = 12130; // "__all_virtual_tenant_role_grantee_map_history"
const uint64_t OB_ALL_VIRTUAL_TENANT_KEYSTORE_TID = 12131; // "__all_virtual_tenant_keystore"
const uint64_t OB_ALL_VIRTUAL_TENANT_KEYSTORE_HISTORY_TID = 12132; // "__all_virtual_tenant_keystore_history"
const uint64_t OB_ALL_VIRTUAL_DEADLOCK_STAT_TID = 12141; // "__all_virtual_deadlock_stat"
const uint64_t OB_ALL_VIRTUAL_TENANT_TABLESPACE_TID = 12142; // "__all_virtual_tenant_tablespace"
const uint64_t OB_ALL_VIRTUAL_TENANT_TABLESPACE_HISTORY_TID = 12143; // "__all_virtual_tenant_tablespace_history"
const uint64_t OB_ALL_VIRTUAL_INFORMATION_COLUMNS_TID = 12144; // "__ALL_VIRTUAL_INFORMATION_COLUMNS"
const uint64_t OB_ALL_VIRTUAL_PG_PARTITION_INFO_TID = 12145; // "__all_virtual_pg_partition_info"
const uint64_t OB_ALL_VIRTUAL_TENANT_USER_FAILED_LOGIN_STAT_TID = 12146; // "__all_virtual_tenant_user_failed_login_stat"
const uint64_t OB_ALL_VIRTUAL_TENANT_PROFILE_TID = 12147; // "__all_virtual_tenant_profile"
const uint64_t OB_ALL_VIRTUAL_TENANT_PROFILE_HISTORY_TID = 12148; // "__all_virtual_tenant_profile_history"
const uint64_t OB_ALL_VIRTUAL_SECURITY_AUDIT_TID = 12149; // "__all_virtual_security_audit"
const uint64_t OB_ALL_VIRTUAL_SECURITY_AUDIT_HISTORY_TID = 12150; // "__all_virtual_security_audit_history"
const uint64_t OB_ALL_VIRTUAL_TRIGGER_TID = 12151; // "__all_virtual_trigger"
const uint64_t OB_ALL_VIRTUAL_TRIGGER_HISTORY_TID = 12152; // "__all_virtual_trigger_history"
const uint64_t OB_ALL_VIRTUAL_CLUSTER_STATS_TID = 12153; // "__all_virtual_cluster_stats"
const uint64_t OB_ALL_VIRTUAL_SSTABLE_COLUMN_CHECKSUM_TID = 12154; // "__all_virtual_sstable_column_checksum"
const uint64_t OB_ALL_VIRTUAL_PS_STAT_TID = 12155; // "__all_virtual_ps_stat"
const uint64_t OB_ALL_VIRTUAL_PS_ITEM_INFO_TID = 12156; // "__all_virtual_ps_item_info"
const uint64_t OB_ALL_VIRTUAL_SQL_WORKAREA_HISTORY_STAT_TID = 12158; // "__all_virtual_sql_workarea_history_stat"
const uint64_t OB_ALL_VIRTUAL_SQL_WORKAREA_ACTIVE_TID = 12159; // "__all_virtual_sql_workarea_active"
const uint64_t OB_ALL_VIRTUAL_SQL_WORKAREA_HISTOGRAM_TID = 12160; // "__all_virtual_sql_workarea_histogram"
const uint64_t OB_ALL_VIRTUAL_SQL_WORKAREA_MEMORY_INFO_TID = 12161; // "__all_virtual_sql_workarea_memory_info"
const uint64_t OB_ALL_VIRTUAL_SECURITY_AUDIT_RECORD_TID = 12162; // "__all_virtual_security_audit_record"
const uint64_t OB_ALL_VIRTUAL_SYSAUTH_TID = 12163; // "__all_virtual_sysauth"
const uint64_t OB_ALL_VIRTUAL_SYSAUTH_HISTORY_TID = 12164; // "__all_virtual_sysauth_history"
const uint64_t OB_ALL_VIRTUAL_OBJAUTH_TID = 12165; // "__all_virtual_objauth"
const uint64_t OB_ALL_VIRTUAL_OBJAUTH_HISTORY_TID = 12166; // "__all_virtual_objauth_history"
const uint64_t OB_ALL_VIRTUAL_BACKUP_INFO_TID = 12167; // "__all_virtual_backup_info"
const uint64_t OB_ALL_VIRTUAL_BACKUP_LOG_ARCHIVE_STATUS_TID = 12168; // "__all_virtual_backup_log_archive_status"
const uint64_t OB_ALL_VIRTUAL_BACKUP_TASK_TID = 12170; // "__all_virtual_backup_task"
const uint64_t OB_ALL_VIRTUAL_PG_BACKUP_TASK_TID = 12171; // "__all_virtual_pg_backup_task"
const uint64_t OB_ALL_VIRTUAL_PG_BACKUP_LOG_ARCHIVE_STATUS_TID = 12173; // "__all_virtual_pg_backup_log_archive_status"
const uint64_t OB_ALL_VIRTUAL_SERVER_BACKUP_LOG_ARCHIVE_STATUS_TID = 12174; // "__all_virtual_server_backup_log_archive_status"
const uint64_t OB_ALL_VIRTUAL_ERROR_TID = 12175; // "__all_virtual_error"
const uint64_t OB_ALL_VIRTUAL_TIMESTAMP_SERVICE_TID = 12176; // "__all_virtual_timestamp_service"
const uint64_t OB_REFERENTIAL_CONSTRAINTS_TID = 12177; // "REFERENTIAL_CONSTRAINTS"
const uint64_t OB_ALL_VIRTUAL_TABLE_MODIFICATIONS_TID = 12179; // "__all_virtual_table_modifications"
const uint64_t OB_ALL_VIRTUAL_BACKUP_CLEAN_INFO_TID = 12180; // "__all_virtual_backup_clean_info"
const uint64_t OB_ALL_VIRTUAL_RESTORE_PG_INFO_TID = 12181; // "__all_virtual_restore_pg_info"
const uint64_t OB_ALL_VIRTUAL_OBJECT_TYPE_TID = 12182; // "__all_virtual_object_type"
const uint64_t OB_ALL_VIRTUAL_TRANS_TABLE_STATUS_TID = 12183; // "__all_virtual_trans_table_status"
const uint64_t OB_ALL_VIRTUAL_PG_LOG_ARCHIVE_STAT_TID = 12184; // "__all_virtual_pg_log_archive_stat"
const uint64_t OB_ALL_VIRTUAL_SQL_PLAN_MONITOR_TID = 12185; // "__all_virtual_sql_plan_monitor"
const uint64_t OB_ALL_VIRTUAL_SQL_MONITOR_STATNAME_TID = 12186; // "__all_virtual_sql_monitor_statname"
const uint64_t OB_ALL_VIRTUAL_OPEN_CURSOR_TID = 12187; // "__all_virtual_open_cursor"
const uint64_t OB_ALL_VIRTUAL_BACKUP_VALIDATION_TASK_TID = 12188; // "__all_virtual_backup_validation_task"
const uint64_t OB_ALL_VIRTUAL_PG_BACKUP_VALIDATION_TASK_TID = 12189; // "__all_virtual_pg_backup_validation_task"
const uint64_t OB_ALL_VIRTUAL_TIME_ZONE_TID = 12190; // "__all_virtual_time_zone"
const uint64_t OB_ALL_VIRTUAL_TIME_ZONE_NAME_TID = 12191; // "__all_virtual_time_zone_name"
const uint64_t OB_ALL_VIRTUAL_TIME_ZONE_TRANSITION_TID = 12192; // "__all_virtual_time_zone_transition"
const uint64_t OB_ALL_VIRTUAL_TIME_ZONE_TRANSITION_TYPE_TID = 12193; // "__all_virtual_time_zone_transition_type"
const uint64_t OB_ALL_VIRTUAL_CONSTRAINT_COLUMN_TID = 12194; // "__all_virtual_constraint_column"
const uint64_t OB_ALL_VIRTUAL_CONSTRAINT_COLUMN_HISTORY_TID = 12195; // "__all_virtual_constraint_column_history"
const uint64_t OB_ALL_VIRTUAL_FILES_TID = 12196; // "__all_virtual_files"
const uint64_t OB_FILES_TID = 12197; // "FILES"
const uint64_t OB_ALL_VIRTUAL_DEPENDENCY_TID = 12198; // "__all_virtual_dependency"
const uint64_t OB_TENANT_VIRTUAL_OBJECT_DEFINITION_TID = 12199; // "__tenant_virtual_object_definition"
const uint64_t OB_ALL_VIRTUAL_RESERVED_TABLE_MGR_TID = 12200; // "__all_virtual_reserved_table_mgr"
const uint64_t OB_ALL_VIRTUAL_BACKUPSET_HISTORY_MGR_TID = 12201; // "__all_virtual_backupset_history_mgr"
const uint64_t OB_ALL_VIRTUAL_BACKUP_BACKUPSET_TASK_TID = 12202; // "__all_virtual_backup_backupset_task"
const uint64_t OB_ALL_VIRTUAL_PG_BACKUP_BACKUPSET_TASK_TID = 12203; // "__all_virtual_pg_backup_backupset_task"
const uint64_t OB_ALL_VIRTUAL_BACKUP_BACKUP_LOG_ARCHIVE_STATUS_TID = 12204; // "__all_virtual_backup_backup_log_archive_status"
const uint64_t OB_ALL_VIRTUAL_GLOBAL_TRANSACTION_TID = 12206; // "__all_virtual_global_transaction"
const uint64_t OB_ALL_VIRTUAL_TABLE_AGENT_TID = 15001; // "ALL_VIRTUAL_TABLE_AGENT"
const uint64_t OB_ALL_VIRTUAL_COLUMN_AGENT_TID = 15002; // "ALL_VIRTUAL_COLUMN_AGENT"
const uint64_t OB_ALL_VIRTUAL_DATABASE_AGENT_TID = 15003; // "ALL_VIRTUAL_DATABASE_AGENT"
const uint64_t OB_ALL_VIRTUAL_SEQUENCE_V2_AGENT_TID = 15004; // "ALL_VIRTUAL_SEQUENCE_V2_AGENT"
const uint64_t OB_ALL_VIRTUAL_PART_AGENT_TID = 15005; // "ALL_VIRTUAL_PART_AGENT"
const uint64_t OB_ALL_VIRTUAL_SUB_PART_AGENT_TID = 15006; // "ALL_VIRTUAL_SUB_PART_AGENT"
const uint64_t OB_ALL_VIRTUAL_PACKAGE_AGENT_TID = 15007; // "ALL_VIRTUAL_PACKAGE_AGENT"
const uint64_t OB_ALL_VIRTUAL_TENANT_META_TABLE_AGENT_TID = 15008; // "ALL_VIRTUAL_TENANT_META_TABLE_AGENT"
const uint64_t OB_ALL_VIRTUAL_SQL_AUDIT_ORA_TID = 15009; // "ALL_VIRTUAL_SQL_AUDIT_ORA"
const uint64_t OB_ALL_VIRTUAL_PLAN_STAT_ORA_TID = 15010; // "ALL_VIRTUAL_PLAN_STAT_ORA"
const uint64_t OB_ALL_VIRTUAL_SQL_PLAN_STATISTICS_AGENT_TID = 15011; // "ALL_VIRTUAL_SQL_PLAN_STATISTICS_AGENT"
const uint64_t OB_ALL_VIRTUAL_PLAN_CACHE_PLAN_EXPLAIN_ORA_TID = 15012; // "ALL_VIRTUAL_PLAN_CACHE_PLAN_EXPLAIN_ORA"
const uint64_t OB_ALL_VIRTUAL_SEQUENCE_VALUE_AGENT_TID = 15013; // "ALL_VIRTUAL_SEQUENCE_VALUE_AGENT"
const uint64_t OB_ALL_VIRTUAL_SEQUENCE_OBJECT_AGENT_TID = 15014; // "ALL_VIRTUAL_SEQUENCE_OBJECT_AGENT"
const uint64_t OB_ALL_VIRTUAL_USER_AGENT_TID = 15015; // "ALL_VIRTUAL_USER_AGENT"
const uint64_t OB_ALL_VIRTUAL_SYNONYM_AGENT_TID = 15016; // "ALL_VIRTUAL_SYNONYM_AGENT"
const uint64_t OB_ALL_VIRTUAL_FOREIGN_KEY_AGENT_TID = 15017; // "ALL_VIRTUAL_FOREIGN_KEY_AGENT"
const uint64_t OB_ALL_VIRTUAL_COLUMN_STAT_AGENT_TID = 15018; // "ALL_VIRTUAL_COLUMN_STAT_AGENT"
const uint64_t OB_ALL_VIRTUAL_COLUMN_STATISTIC_AGENT_TID = 15019; // "ALL_VIRTUAL_COLUMN_STATISTIC_AGENT"
const uint64_t OB_ALL_VIRTUAL_PARTITION_TABLE_AGENT_TID = 15020; // "ALL_VIRTUAL_PARTITION_TABLE_AGENT"
const uint64_t OB_ALL_VIRTUAL_TABLE_STAT_AGENT_TID = 15021; // "ALL_VIRTUAL_TABLE_STAT_AGENT"
const uint64_t OB_ALL_VIRTUAL_RECYCLEBIN_AGENT_TID = 15022; // "ALL_VIRTUAL_RECYCLEBIN_AGENT"
const uint64_t OB_TENANT_VIRTUAL_OUTLINE_AGENT_TID = 15023; // "TENANT_VIRTUAL_OUTLINE_AGENT"
const uint64_t OB_ALL_VIRTUAL_ROUTINE_AGENT_TID = 15024; // "ALL_VIRTUAL_ROUTINE_AGENT"
const uint64_t OB_ALL_VIRTUAL_TABLEGROUP_AGENT_TID = 15025; // "ALL_VIRTUAL_TABLEGROUP_AGENT"
const uint64_t OB_ALL_VIRTUAL_PRIVILEGE_AGENT_TID = 15026; // "ALL_VIRTUAL_PRIVILEGE_AGENT"
const uint64_t OB_ALL_VIRTUAL_SYS_PARAMETER_STAT_AGENT_TID = 15027; // "ALL_VIRTUAL_SYS_PARAMETER_STAT_AGENT"
const uint64_t OB_TENANT_VIRTUAL_TABLE_INDEX_AGENT_TID = 15028; // "TENANT_VIRTUAL_TABLE_INDEX_AGENT"
const uint64_t OB_TENANT_VIRTUAL_CHARSET_AGENT_TID = 15029; // "TENANT_VIRTUAL_CHARSET_AGENT"
const uint64_t OB_TENANT_VIRTUAL_ALL_TABLE_AGENT_TID = 15030; // "TENANT_VIRTUAL_ALL_TABLE_AGENT"
const uint64_t OB_TENANT_VIRTUAL_COLLATION_AGENT_TID = 15031; // "TENANT_VIRTUAL_COLLATION_AGENT"
const uint64_t OB_ALL_VIRTUAL_FOREIGN_KEY_COLUMN_AGENT_TID = 15032; // "ALL_VIRTUAL_FOREIGN_KEY_COLUMN_AGENT"
const uint64_t OB_ALL_VIRTUAL_SERVER_AGENT_TID = 15033; // "ALL_VIRTUAL_SERVER_AGENT"
const uint64_t OB_ALL_VIRTUAL_PLAN_CACHE_STAT_ORA_TID = 15034; // "ALL_VIRTUAL_PLAN_CACHE_STAT_ORA"
const uint64_t OB_ALL_VIRTUAL_PROCESSLIST_ORA_TID = 15035; // "ALL_VIRTUAL_PROCESSLIST_ORA"
const uint64_t OB_ALL_VIRTUAL_SESSION_WAIT_ORA_TID = 15036; // "ALL_VIRTUAL_SESSION_WAIT_ORA"
const uint64_t OB_ALL_VIRTUAL_SESSION_WAIT_HISTORY_ORA_TID = 15037; // "ALL_VIRTUAL_SESSION_WAIT_HISTORY_ORA"
const uint64_t OB_ALL_VIRTUAL_MEMORY_INFO_ORA_TID = 15038; // "ALL_VIRTUAL_MEMORY_INFO_ORA"
const uint64_t OB_ALL_VIRTUAL_TENANT_MEMSTORE_INFO_ORA_TID = 15039; // "ALL_VIRTUAL_TENANT_MEMSTORE_INFO_ORA"
const uint64_t OB_ALL_VIRTUAL_MEMSTORE_INFO_ORA_TID = 15040; // "ALL_VIRTUAL_MEMSTORE_INFO_ORA"
const uint64_t OB_ALL_VIRTUAL_SERVER_MEMORY_INFO_AGENT_TID = 15041; // "ALL_VIRTUAL_SERVER_MEMORY_INFO_AGENT"
const uint64_t OB_ALL_VIRTUAL_SESSTAT_ORA_TID = 15042; // "ALL_VIRTUAL_SESSTAT_ORA"
const uint64_t OB_ALL_VIRTUAL_SYSSTAT_ORA_TID = 15043; // "ALL_VIRTUAL_SYSSTAT_ORA"
const uint64_t OB_ALL_VIRTUAL_SYSTEM_EVENT_ORA_TID = 15044; // "ALL_VIRTUAL_SYSTEM_EVENT_ORA"
const uint64_t OB_ALL_VIRTUAL_TENANT_MEMSTORE_ALLOCATOR_INFO_AGENT_TID = 15045; // "ALL_VIRTUAL_TENANT_MEMSTORE_ALLOCATOR_INFO_AGENT"
const uint64_t OB_TENANT_VIRTUAL_SESSION_VARIABLE_ORA_TID = 15046; // "TENANT_VIRTUAL_SESSION_VARIABLE_ORA"
const uint64_t OB_TENANT_VIRTUAL_GLOBAL_VARIABLE_ORA_TID = 15047; // "TENANT_VIRTUAL_GLOBAL_VARIABLE_ORA"
const uint64_t OB_TENANT_VIRTUAL_SHOW_CREATE_TABLE_ORA_TID = 15048; // "TENANT_VIRTUAL_SHOW_CREATE_TABLE_ORA"
const uint64_t OB_TENANT_VIRTUAL_SHOW_CREATE_PROCEDURE_ORA_TID = 15049; // "TENANT_VIRTUAL_SHOW_CREATE_PROCEDURE_ORA"
const uint64_t OB_TENANT_VIRTUAL_SHOW_CREATE_TABLEGROUP_ORA_TID = 15050; // "TENANT_VIRTUAL_SHOW_CREATE_TABLEGROUP_ORA"
const uint64_t OB_TENANT_VIRTUAL_PRIVILEGE_GRANT_ORA_TID = 15051; // "TENANT_VIRTUAL_PRIVILEGE_GRANT_ORA"
const uint64_t OB_TENANT_VIRTUAL_TABLE_COLUMN_ORA_TID = 15052; // "TENANT_VIRTUAL_TABLE_COLUMN_ORA"
const uint64_t OB_ALL_VIRTUAL_TRACE_LOG_ORA_TID = 15053; // "ALL_VIRTUAL_TRACE_LOG_ORA"
const uint64_t OB_TENANT_VIRTUAL_CONCURRENT_LIMIT_SQL_AGENT_TID = 15054; // "TENANT_VIRTUAL_CONCURRENT_LIMIT_SQL_AGENT"
const uint64_t OB_ALL_VIRTUAL_CONSTRAINT_AGENT_TID = 15055; // "ALL_VIRTUAL_CONSTRAINT_AGENT"
const uint64_t OB_ALL_VIRTUAL_TYPE_AGENT_TID = 15056; // "ALL_VIRTUAL_TYPE_AGENT"
const uint64_t OB_ALL_VIRTUAL_TYPE_ATTR_AGENT_TID = 15057; // "ALL_VIRTUAL_TYPE_ATTR_AGENT"
const uint64_t OB_ALL_VIRTUAL_COLL_TYPE_AGENT_TID = 15058; // "ALL_VIRTUAL_COLL_TYPE_AGENT"
const uint64_t OB_ALL_VIRTUAL_ROUTINE_PARAM_AGENT_TID = 15059; // "ALL_VIRTUAL_ROUTINE_PARAM_AGENT"
const uint64_t OB_ALL_VIRTUAL_DATA_TYPE_ORA_TID = 15060; // "ALL_VIRTUAL_DATA_TYPE_ORA"
const uint64_t OB_ALL_VIRTUAL_TABLE_SYS_AGENT_TID = 15062; // "ALL_VIRTUAL_TABLE_SYS_AGENT"
const uint64_t OB_ALL_VIRTUAL_SSTABLE_CHECKSUM_AGENT_TID = 15063; // "ALL_VIRTUAL_SSTABLE_CHECKSUM_AGENT"
const uint64_t OB_ALL_VIRTUAL_PARTITION_INFO_AGENT_TID = 15064; // "ALL_VIRTUAL_PARTITION_INFO_AGENT"
const uint64_t OB_ALL_VIRTUAL_TENANT_PARTITION_META_TABLE_AGENT_TID = 15065; // "ALL_VIRTUAL_TENANT_PARTITION_META_TABLE_AGENT"
const uint64_t OB_ALL_VIRTUAL_TENANT_KEYSTORE_AGENT_TID = 15066; // "ALL_VIRTUAL_TENANT_KEYSTORE_AGENT"
const uint64_t OB_ALL_VIRTUAL_TENANT_TABLESPACE_AGENT_TID = 15071; // "ALL_VIRTUAL_TENANT_TABLESPACE_AGENT"
const uint64_t OB_ALL_VIRTUAL_TENANT_PROFILE_AGENT_TID = 15072; // "ALL_VIRTUAL_TENANT_PROFILE_AGENT"
const uint64_t OB_ALL_VIRTUAL_TENANT_ROLE_GRANTEE_MAP_AGENT_TID = 15073; // "ALL_VIRTUAL_TENANT_ROLE_GRANTEE_MAP_AGENT"
const uint64_t OB_ALL_VIRTUAL_TABLE_PRIVILEGE_AGENT_TID = 15074; // "ALL_VIRTUAL_TABLE_PRIVILEGE_AGENT"
const uint64_t OB_ALL_VIRTUAL_SECURITY_AUDIT_AGENT_TID = 15075; // "ALL_VIRTUAL_SECURITY_AUDIT_AGENT"
const uint64_t OB_ALL_VIRTUAL_SECURITY_AUDIT_HISTORY_AGENT_TID = 15076; // "ALL_VIRTUAL_SECURITY_AUDIT_HISTORY_AGENT"
const uint64_t OB_ALL_VIRTUAL_TRIGGER_AGENT_TID = 15079; // "ALL_VIRTUAL_TRIGGER_AGENT"
const uint64_t OB_ALL_VIRTUAL_PX_WORKER_STAT_ORA_TID = 15080; // "ALL_VIRTUAL_PX_WORKER_STAT_ORA"
const uint64_t OB_ALL_VIRTUAL_PS_STAT_ORA_TID = 15081; // "ALL_VIRTUAL_PS_STAT_ORA"
const uint64_t OB_ALL_VIRTUAL_PS_ITEM_INFO_ORA_TID = 15082; // "ALL_VIRTUAL_PS_ITEM_INFO_ORA"
const uint64_t OB_ALL_VIRTUAL_TENANT_PARAMETER_STAT_ORA_TID = 15083; // "ALL_VIRTUAL_TENANT_PARAMETER_STAT_ORA"
const uint64_t OB_ALL_VIRTUAL_SQL_WORKAREA_HISTORY_STAT_AGENT_TID = 15084; // "ALL_VIRTUAL_SQL_WORKAREA_HISTORY_STAT_AGENT"
const uint64_t OB_ALL_VIRTUAL_SQL_WORKAREA_ACTIVE_AGENT_TID = 15085; // "ALL_VIRTUAL_SQL_WORKAREA_ACTIVE_AGENT"
const uint64_t OB_ALL_VIRTUAL_SQL_WORKAREA_HISTOGRAM_AGENT_TID = 15086; // "ALL_VIRTUAL_SQL_WORKAREA_HISTOGRAM_AGENT"
const uint64_t OB_ALL_VIRTUAL_SQL_WORKAREA_MEMORY_INFO_AGENT_TID = 15087; // "ALL_VIRTUAL_SQL_WORKAREA_MEMORY_INFO_AGENT"
const uint64_t OB_ALL_VIRTUAL_SECURITY_AUDIT_RECORD_AGENT_TID = 15088; // "ALL_VIRTUAL_SECURITY_AUDIT_RECORD_AGENT"
const uint64_t OB_ALL_VIRTUAL_SYSAUTH_AGENT_TID = 15089; // "ALL_VIRTUAL_SYSAUTH_AGENT"
const uint64_t OB_ALL_VIRTUAL_SYSAUTH_HISTORY_AGENT_TID = 15090; // "ALL_VIRTUAL_SYSAUTH_HISTORY_AGENT"
const uint64_t OB_ALL_VIRTUAL_OBJAUTH_AGENT_TID = 15091; // "ALL_VIRTUAL_OBJAUTH_AGENT"
const uint64_t OB_ALL_VIRTUAL_OBJAUTH_HISTORY_AGENT_TID = 15092; // "ALL_VIRTUAL_OBJAUTH_HISTORY_AGENT"
const uint64_t OB_ALL_VIRTUAL_ERROR_AGENT_TID = 15093; // "ALL_VIRTUAL_ERROR_AGENT"
const uint64_t OB_ALL_VIRTUAL_TABLE_MGR_AGENT_TID = 15094; // "ALL_VIRTUAL_TABLE_MGR_AGENT"
const uint64_t OB_ALL_VIRTUAL_DEF_SUB_PART_AGENT_TID = 15095; // "ALL_VIRTUAL_DEF_SUB_PART_AGENT"
const uint64_t OB_ALL_VIRTUAL_OBJECT_TYPE_AGENT_TID = 15096; // "ALL_VIRTUAL_OBJECT_TYPE_AGENT"
const uint64_t OB_ALL_VIRTUAL_SERVER_SCHEMA_INFO_AGENT_TID = 15097; // "ALL_VIRTUAL_SERVER_SCHEMA_INFO_AGENT"
const uint64_t OB_ALL_VIRTUAL_DBLINK_AGENT_TID = 15098; // "ALL_VIRTUAL_DBLINK_AGENT"
const uint64_t OB_ALL_VIRTUAL_DBLINK_HISTORY_AGENT_TID = 15099; // "ALL_VIRTUAL_DBLINK_HISTORY_AGENT"
const uint64_t OB_ALL_VIRTUAL_SQL_PLAN_MONITOR_ORA_TID = 15100; // "ALL_VIRTUAL_SQL_PLAN_MONITOR_ORA"
const uint64_t OB_ALL_VIRTUAL_SQL_MONITOR_STATNAME_ORA_TID = 15101; // "ALL_VIRTUAL_SQL_MONITOR_STATNAME_ORA"
const uint64_t OB_ALL_VIRTUAL_LOCK_WAIT_STAT_ORA_TID = 15102; // "ALL_VIRTUAL_LOCK_WAIT_STAT_ORA"
const uint64_t OB_ALL_VIRTUAL_OPEN_CURSOR_ORA_TID = 15103; // "ALL_VIRTUAL_OPEN_CURSOR_ORA"
const uint64_t OB_ALL_VIRTUAL_CONSTRAINT_COLUMN_AGENT_TID = 15104; // "ALL_VIRTUAL_CONSTRAINT_COLUMN_AGENT"
const uint64_t OB_ALL_VIRTUAL_DEPENDENCY_AGENT_TID = 15105; // "ALL_VIRTUAL_DEPENDENCY_AGENT"
const uint64_t OB_ALL_VIRTUAL_TENANT_TIME_ZONE_AGENT_TID = 15106; // "ALL_VIRTUAL_TENANT_TIME_ZONE_AGENT"
const uint64_t OB_ALL_VIRTUAL_TENANT_TIME_ZONE_NAME_AGENT_TID = 15107; // "ALL_VIRTUAL_TENANT_TIME_ZONE_NAME_AGENT"
const uint64_t OB_ALL_VIRTUAL_TENANT_TIME_ZONE_TRANSITION_AGENT_TID = 15108; // "ALL_VIRTUAL_TENANT_TIME_ZONE_TRANSITION_AGENT"
const uint64_t OB_ALL_VIRTUAL_TENANT_TIME_ZONE_TRANSITION_TYPE_AGENT_TID = 15109; // "ALL_VIRTUAL_TENANT_TIME_ZONE_TRANSITION_TYPE_AGENT"
const uint64_t OB_TENANT_VIRTUAL_OBJECT_DEFINITION_ORA_TID = 15110; // "TENANT_VIRTUAL_OBJECT_DEFINITION_ORA"
const uint64_t OB_ALL_VIRTUAL_ROUTINE_PARAM_SYS_AGENT_TID = 15111; // "ALL_VIRTUAL_ROUTINE_PARAM_SYS_AGENT"
const uint64_t OB_ALL_VIRTUAL_TYPE_SYS_AGENT_TID = 15112; // "ALL_VIRTUAL_TYPE_SYS_AGENT"
const uint64_t OB_ALL_VIRTUAL_TYPE_ATTR_SYS_AGENT_TID = 15113; // "ALL_VIRTUAL_TYPE_ATTR_SYS_AGENT"
const uint64_t OB_ALL_VIRTUAL_COLL_TYPE_SYS_AGENT_TID = 15114; // "ALL_VIRTUAL_COLL_TYPE_SYS_AGENT"
const uint64_t OB_ALL_VIRTUAL_PACKAGE_SYS_AGENT_TID = 15115; // "ALL_VIRTUAL_PACKAGE_SYS_AGENT"
const uint64_t OB_ALL_VIRTUAL_TENANT_TRIGGER_SYS_AGENT_TID = 15116; // "ALL_VIRTUAL_TENANT_TRIGGER_SYS_AGENT"
const uint64_t OB_ALL_VIRTUAL_ROUTINE_SYS_AGENT_TID = 15117; // "ALL_VIRTUAL_ROUTINE_SYS_AGENT"
const uint64_t OB_ALL_VIRTUAL_TENANT_GLOBAL_TRANSACTION_AGENT_TID = 15118; // "ALL_VIRTUAL_TENANT_GLOBAL_TRANSACTION_AGENT"
const uint64_t OB_ALL_VIRTUAL_ACQUIRED_SNAPSHOT_AGENT_TID = 15119; // "ALL_VIRTUAL_ACQUIRED_SNAPSHOT_AGENT"
const uint64_t OB_ALL_VIRTUAL_TABLE_REAL_AGENT_ORA_TID = 15120; // "ALL_VIRTUAL_TABLE_REAL_AGENT_ORA"
const uint64_t OB_ALL_VIRTUAL_COLUMN_REAL_AGENT_ORA_TID = 15121; // "ALL_VIRTUAL_COLUMN_REAL_AGENT_ORA"
const uint64_t OB_ALL_VIRTUAL_DATABASE_REAL_AGENT_ORA_TID = 15122; // "ALL_VIRTUAL_DATABASE_REAL_AGENT_ORA"
const uint64_t OB_ALL_VIRTUAL_SEQUENCE_V2_REAL_AGENT_ORA_TID = 15123; // "ALL_VIRTUAL_SEQUENCE_V2_REAL_AGENT_ORA"
const uint64_t OB_ALL_VIRTUAL_PART_REAL_AGENT_ORA_TID = 15124; // "ALL_VIRTUAL_PART_REAL_AGENT_ORA"
const uint64_t OB_ALL_VIRTUAL_SUB_PART_REAL_AGENT_ORA_TID = 15125; // "ALL_VIRTUAL_SUB_PART_REAL_AGENT_ORA"
const uint64_t OB_ALL_VIRTUAL_PACKAGE_REAL_AGENT_ORA_TID = 15126; // "ALL_VIRTUAL_PACKAGE_REAL_AGENT_ORA"
const uint64_t OB_ALL_VIRTUAL_SEQUENCE_VALUE_REAL_AGENT_ORA_TID = 15127; // "ALL_VIRTUAL_SEQUENCE_VALUE_REAL_AGENT_ORA"
const uint64_t OB_ALL_VIRTUAL_SEQUENCE_OBJECT_REAL_AGENT_ORA_TID = 15128; // "ALL_VIRTUAL_SEQUENCE_OBJECT_REAL_AGENT_ORA"
const uint64_t OB_ALL_VIRTUAL_USER_REAL_AGENT_ORA_TID = 15129; // "ALL_VIRTUAL_USER_REAL_AGENT_ORA"
const uint64_t OB_ALL_VIRTUAL_SYNONYM_REAL_AGENT_ORA_TID = 15130; // "ALL_VIRTUAL_SYNONYM_REAL_AGENT_ORA"
const uint64_t OB_ALL_VIRTUAL_FOREIGN_KEY_REAL_AGENT_ORA_TID = 15131; // "ALL_VIRTUAL_FOREIGN_KEY_REAL_AGENT_ORA"
const uint64_t OB_ALL_VIRTUAL_COLUMN_STAT_REAL_AGENT_ORA_TID = 15132; // "ALL_VIRTUAL_COLUMN_STAT_REAL_AGENT_ORA"
const uint64_t OB_ALL_VIRTUAL_COLUMN_STATISTIC_REAL_AGENT_ORA_TID = 15133; // "ALL_VIRTUAL_COLUMN_STATISTIC_REAL_AGENT_ORA"
const uint64_t OB_ALL_VIRTUAL_TABLE_STAT_REAL_AGENT_ORA_TID = 15134; // "ALL_VIRTUAL_TABLE_STAT_REAL_AGENT_ORA"
const uint64_t OB_ALL_VIRTUAL_RECYCLEBIN_REAL_AGENT_ORA_TID = 15135; // "ALL_VIRTUAL_RECYCLEBIN_REAL_AGENT_ORA"
const uint64_t OB_ALL_VIRTUAL_ROUTINE_REAL_AGENT_ORA_TID = 15136; // "ALL_VIRTUAL_ROUTINE_REAL_AGENT_ORA"
const uint64_t OB_ALL_VIRTUAL_TABLEGROUP_REAL_AGENT_ORA_TID = 15137; // "ALL_VIRTUAL_TABLEGROUP_REAL_AGENT_ORA"
const uint64_t OB_ALL_VIRTUAL_FOREIGN_KEY_COLUMN_REAL_AGENT_ORA_TID = 15138; // "ALL_VIRTUAL_FOREIGN_KEY_COLUMN_REAL_AGENT_ORA"
const uint64_t OB_ALL_VIRTUAL_CONSTRAINT_REAL_AGENT_ORA_TID = 15139; // "ALL_VIRTUAL_CONSTRAINT_REAL_AGENT_ORA"
const uint64_t OB_ALL_VIRTUAL_TYPE_REAL_AGENT_ORA_TID = 15140; // "ALL_VIRTUAL_TYPE_REAL_AGENT_ORA"
const uint64_t OB_ALL_VIRTUAL_TYPE_ATTR_REAL_AGENT_ORA_TID = 15141; // "ALL_VIRTUAL_TYPE_ATTR_REAL_AGENT_ORA"
const uint64_t OB_ALL_VIRTUAL_COLL_TYPE_REAL_AGENT_ORA_TID = 15142; // "ALL_VIRTUAL_COLL_TYPE_REAL_AGENT_ORA"
const uint64_t OB_ALL_VIRTUAL_ROUTINE_PARAM_REAL_AGENT_ORA_TID = 15143; // "ALL_VIRTUAL_ROUTINE_PARAM_REAL_AGENT_ORA"
const uint64_t OB_ALL_VIRTUAL_TENANT_PARTITION_META_TABLE_REAL_AGENT_ORA_TID = 15144; // "ALL_VIRTUAL_TENANT_PARTITION_META_TABLE_REAL_AGENT_ORA"
const uint64_t OB_ALL_VIRTUAL_TENANT_KEYSTORE_REAL_AGENT_ORA_TID = 15145; // "ALL_VIRTUAL_TENANT_KEYSTORE_REAL_AGENT_ORA"
const uint64_t OB_ALL_VIRTUAL_TENANT_TABLESPACE_REAL_AGENT_ORA_TID = 15150; // "ALL_VIRTUAL_TENANT_TABLESPACE_REAL_AGENT_ORA"
const uint64_t OB_ALL_VIRTUAL_TENANT_PROFILE_REAL_AGENT_ORA_TID = 15151; // "ALL_VIRTUAL_TENANT_PROFILE_REAL_AGENT_ORA"
const uint64_t OB_ALL_VIRTUAL_TENANT_ROLE_GRANTEE_MAP_REAL_AGENT_ORA_TID = 15152; // "ALL_VIRTUAL_TENANT_ROLE_GRANTEE_MAP_REAL_AGENT_ORA"
const uint64_t OB_ALL_VIRTUAL_TABLE_PRIVILEGE_REAL_AGENT_ORA_TID = 15153; // "ALL_VIRTUAL_TABLE_PRIVILEGE_REAL_AGENT_ORA"
const uint64_t OB_ALL_VIRTUAL_TENANT_SECURITY_AUDIT_REAL_AGENT_ORA_TID = 15154; // "ALL_VIRTUAL_TENANT_SECURITY_AUDIT_REAL_AGENT_ORA"
const uint64_t OB_ALL_VIRTUAL_TENANT_SECURITY_AUDIT_HISTORY_REAL_AGENT_ORA_TID = 15155; // "ALL_VIRTUAL_TENANT_SECURITY_AUDIT_HISTORY_REAL_AGENT_ORA"
const uint64_t OB_ALL_VIRTUAL_TENANT_TRIGGER_REAL_AGENT_ORA_TID = 15156; // "ALL_VIRTUAL_TENANT_TRIGGER_REAL_AGENT_ORA"
const uint64_t OB_ALL_VIRTUAL_TENANT_SECURITY_AUDIT_RECORD_REAL_AGENT_ORA_TID = 15157; // "ALL_VIRTUAL_TENANT_SECURITY_AUDIT_RECORD_REAL_AGENT_ORA"
const uint64_t OB_ALL_VIRTUAL_TENANT_SYSAUTH_REAL_AGENT_ORA_TID = 15158; // "ALL_VIRTUAL_TENANT_SYSAUTH_REAL_AGENT_ORA"
const uint64_t OB_ALL_VIRTUAL_TENANT_SYSAUTH_HISTORY_REAL_AGENT_ORA_TID = 15159; // "ALL_VIRTUAL_TENANT_SYSAUTH_HISTORY_REAL_AGENT_ORA"
const uint64_t OB_ALL_VIRTUAL_TENANT_OBJAUTH_REAL_AGENT_ORA_TID = 15160; // "ALL_VIRTUAL_TENANT_OBJAUTH_REAL_AGENT_ORA"
const uint64_t OB_ALL_VIRTUAL_TENANT_OBJAUTH_HISTORY_REAL_AGENT_ORA_TID = 15161; // "ALL_VIRTUAL_TENANT_OBJAUTH_HISTORY_REAL_AGENT_ORA"
const uint64_t OB_ALL_VIRTUAL_TENANT_ERROR_REAL_AGENT_ORA_TID = 15162; // "ALL_VIRTUAL_TENANT_ERROR_REAL_AGENT_ORA"
const uint64_t OB_ALL_VIRTUAL_DEF_SUB_PART_REAL_AGENT_ORA_TID = 15163; // "ALL_VIRTUAL_DEF_SUB_PART_REAL_AGENT_ORA"
const uint64_t OB_ALL_VIRTUAL_TENANT_OBJECT_TYPE_REAL_AGENT_ORA_TID = 15164; // "ALL_VIRTUAL_TENANT_OBJECT_TYPE_REAL_AGENT_ORA"
const uint64_t OB_ALL_VIRTUAL_DBLINK_REAL_AGENT_ORA_TID = 15165; // "ALL_VIRTUAL_DBLINK_REAL_AGENT_ORA"
const uint64_t OB_ALL_VIRTUAL_DBLINK_HISTORY_REAL_AGENT_ORA_TID = 15166; // "ALL_VIRTUAL_DBLINK_HISTORY_REAL_AGENT_ORA"
const uint64_t OB_ALL_VIRTUAL_TENANT_CONSTRAINT_COLUMN_REAL_AGENT_ORA_TID = 15167; // "ALL_VIRTUAL_TENANT_CONSTRAINT_COLUMN_REAL_AGENT_ORA"
const uint64_t OB_ALL_VIRTUAL_TENANT_DEPENDENCY_REAL_AGENT_ORA_TID = 15168; // "ALL_VIRTUAL_TENANT_DEPENDENCY_REAL_AGENT_ORA"
const uint64_t OB_ALL_VIRTUAL_TENANT_META_TABLE_REAL_AGENT_ORA_TID = 15169; // "ALL_VIRTUAL_TENANT_META_TABLE_REAL_AGENT_ORA"
const uint64_t OB_ALL_VIRTUAL_TENANT_TIME_ZONE_REAL_AGENT_ORA_TID = 15170; // "ALL_VIRTUAL_TENANT_TIME_ZONE_REAL_AGENT_ORA"
const uint64_t OB_ALL_VIRTUAL_TENANT_TIME_ZONE_NAME_REAL_AGENT_ORA_TID = 15171; // "ALL_VIRTUAL_TENANT_TIME_ZONE_NAME_REAL_AGENT_ORA"
const uint64_t OB_ALL_VIRTUAL_TENANT_TIME_ZONE_TRANSITION_REAL_AGENT_ORA_TID = 15172; // "ALL_VIRTUAL_TENANT_TIME_ZONE_TRANSITION_REAL_AGENT_ORA"
const uint64_t OB_ALL_VIRTUAL_TENANT_TIME_ZONE_TRANSITION_TYPE_REAL_AGENT_ORA_TID = 15173; // "ALL_VIRTUAL_TENANT_TIME_ZONE_TRANSITION_TYPE_REAL_AGENT_ORA"
const uint64_t OB_ALL_VIRTUAL_RES_MGR_PLAN_REAL_AGENT_ORA_TID = 15174; // "ALL_VIRTUAL_RES_MGR_PLAN_REAL_AGENT_ORA"
const uint64_t OB_ALL_VIRTUAL_RES_MGR_DIRECTIVE_REAL_AGENT_ORA_TID = 15175; // "ALL_VIRTUAL_RES_MGR_DIRECTIVE_REAL_AGENT_ORA"
const uint64_t OB_ALL_VIRTUAL_TRANS_LOCK_STAT_ORA_TID = 15176; // "ALL_VIRTUAL_TRANS_LOCK_STAT_ORA"
const uint64_t OB_ALL_VIRTUAL_RES_MGR_MAPPING_RULE_REAL_AGENT_ORA_TID = 15177; // "ALL_VIRTUAL_RES_MGR_MAPPING_RULE_REAL_AGENT_ORA"
const uint64_t OB_ALL_VIRTUAL_RES_MGR_CONSUMER_GROUP_REAL_AGENT_ORA_TID = 15179; // "ALL_VIRTUAL_RES_MGR_CONSUMER_GROUP_REAL_AGENT_ORA"
const uint64_t OB_GV_PLAN_CACHE_STAT_TID = 20001; // "gv$plan_cache_stat"
const uint64_t OB_GV_PLAN_CACHE_PLAN_STAT_TID = 20002; // "gv$plan_cache_plan_stat"
const uint64_t OB_SCHEMATA_TID = 20003; // "SCHEMATA"
const uint64_t OB_CHARACTER_SETS_TID = 20004; // "CHARACTER_SETS"
const uint64_t OB_GLOBAL_VARIABLES_TID = 20005; // "GLOBAL_VARIABLES"
const uint64_t OB_STATISTICS_TID = 20006; // "STATISTICS"
const uint64_t OB_VIEWS_TID = 20007; // "VIEWS"
const uint64_t OB_TABLES_TID = 20008; // "TABLES"
const uint64_t OB_COLLATIONS_TID = 20009; // "COLLATIONS"
const uint64_t OB_COLLATION_CHARACTER_SET_APPLICABILITY_TID = 20010; // "COLLATION_CHARACTER_SET_APPLICABILITY"
const uint64_t OB_PROCESSLIST_TID = 20011; // "PROCESSLIST"
const uint64_t OB_KEY_COLUMN_USAGE_TID = 20012; // "KEY_COLUMN_USAGE"
const uint64_t OB_DBA_OUTLINES_TID = 20013; // "DBA_OUTLINES"
const uint64_t OB_ENGINES_TID = 20014; // "ENGINES"
const uint64_t OB_ROUTINES_TID = 20015; // "ROUTINES"
const uint64_t OB_GV_SESSION_EVENT_TID = 21000; // "gv$session_event"
const uint64_t OB_GV_SESSION_WAIT_TID = 21001; // "gv$session_wait"
const uint64_t OB_GV_SESSION_WAIT_HISTORY_TID = 21002; // "gv$session_wait_history"
const uint64_t OB_GV_SYSTEM_EVENT_TID = 21003; // "gv$system_event"
const uint64_t OB_GV_SESSTAT_TID = 21004; // "gv$sesstat"
const uint64_t OB_GV_SYSSTAT_TID = 21005; // "gv$sysstat"
const uint64_t OB_V_STATNAME_TID = 21006; // "v$statname"
const uint64_t OB_V_EVENT_NAME_TID = 21007; // "v$event_name"
const uint64_t OB_V_SESSION_EVENT_TID = 21008; // "v$session_event"
const uint64_t OB_V_SESSION_WAIT_TID = 21009; // "v$session_wait"
const uint64_t OB_V_SESSION_WAIT_HISTORY_TID = 21010; // "v$session_wait_history"
const uint64_t OB_V_SESSTAT_TID = 21011; // "v$sesstat"
const uint64_t OB_V_SYSSTAT_TID = 21012; // "v$sysstat"
const uint64_t OB_V_SYSTEM_EVENT_TID = 21013; // "v$system_event"
const uint64_t OB_GV_SQL_AUDIT_TID = 21014; // "gv$sql_audit"
const uint64_t OB_GV_LATCH_TID = 21015; // "gv$latch"
const uint64_t OB_GV_MEMORY_TID = 21016; // "gv$memory"
const uint64_t OB_V_MEMORY_TID = 21017; // "v$memory"
const uint64_t OB_GV_MEMSTORE_TID = 21018; // "gv$memstore"
const uint64_t OB_V_MEMSTORE_TID = 21019; // "v$memstore"
const uint64_t OB_GV_MEMSTORE_INFO_TID = 21020; // "gv$memstore_info"
const uint64_t OB_V_MEMSTORE_INFO_TID = 21021; // "v$memstore_info"
const uint64_t OB_V_PLAN_CACHE_STAT_TID = 21022; // "v$plan_cache_stat"
const uint64_t OB_V_PLAN_CACHE_PLAN_STAT_TID = 21023; // "v$plan_cache_plan_stat"
const uint64_t OB_GV_PLAN_CACHE_PLAN_EXPLAIN_TID = 21024; // "gv$plan_cache_plan_explain"
const uint64_t OB_V_PLAN_CACHE_PLAN_EXPLAIN_TID = 21025; // "v$plan_cache_plan_explain"
const uint64_t OB_V_SQL_AUDIT_TID = 21026; // "v$sql_audit"
const uint64_t OB_V_LATCH_TID = 21027; // "v$latch"
const uint64_t OB_GV_OBRPC_OUTGOING_TID = 21028; // "gv$obrpc_outgoing"
const uint64_t OB_V_OBRPC_OUTGOING_TID = 21029; // "v$obrpc_outgoing"
const uint64_t OB_GV_OBRPC_INCOMING_TID = 21030; // "gv$obrpc_incoming"
const uint64_t OB_V_OBRPC_INCOMING_TID = 21031; // "v$obrpc_incoming"
const uint64_t OB_GV_SQL_TID = 21032; // "gv$sql"
const uint64_t OB_V_SQL_TID = 21033; // "v$sql"
const uint64_t OB_GV_SQL_MONITOR_TID = 21034; // "gv$sql_monitor"
const uint64_t OB_V_SQL_MONITOR_TID = 21035; // "v$sql_monitor"
const uint64_t OB_GV_SQL_PLAN_MONITOR_TID = 21036; // "gv$sql_plan_monitor"
const uint64_t OB_V_SQL_PLAN_MONITOR_TID = 21037; // "v$sql_plan_monitor"
const uint64_t OB_USER_RECYCLEBIN_TID = 21038; // "USER_RECYCLEBIN"
const uint64_t OB_GV_OUTLINE_TID = 21039; // "gv$outline"
const uint64_t OB_GV_CONCURRENT_LIMIT_SQL_TID = 21040; // "gv$concurrent_limit_sql"
const uint64_t OB_GV_SQL_PLAN_STATISTICS_TID = 21041; // "gv$sql_plan_statistics"
const uint64_t OB_V_SQL_PLAN_STATISTICS_TID = 21042; // "v$sql_plan_statistics"
const uint64_t OB_GV_SERVER_MEMSTORE_TID = 21043; // "gv$server_memstore"
const uint64_t OB_GV_UNIT_LOAD_BALANCE_EVENT_HISTORY_TID = 21044; // "gv$unit_load_balance_event_history"
const uint64_t OB_GV_TENANT_TID = 21045; // "gv$tenant"
const uint64_t OB_GV_DATABASE_TID = 21046; // "gv$database"
const uint64_t OB_GV_TABLE_TID = 21047; // "gv$table"
const uint64_t OB_GV_UNIT_TID = 21048; // "gv$unit"
const uint64_t OB_V_UNIT_TID = 21049; // "v$unit"
const uint64_t OB_GV_PARTITION_TID = 21050; // "gv$partition"
const uint64_t OB_V_PARTITION_TID = 21051; // "v$partition"
const uint64_t OB_GV_LOCK_WAIT_STAT_TID = 21052; // "gv$lock_wait_stat"
const uint64_t OB_V_LOCK_WAIT_STAT_TID = 21053; // "v$lock_wait_stat"
const uint64_t OB_TIME_ZONE_TID = 21054; // "time_zone"
const uint64_t OB_TIME_ZONE_NAME_TID = 21055; // "time_zone_name"
const uint64_t OB_TIME_ZONE_TRANSITION_TID = 21056; // "time_zone_transition"
const uint64_t OB_TIME_ZONE_TRANSITION_TYPE_TID = 21057; // "time_zone_transition_type"
const uint64_t OB_GV_SESSION_LONGOPS_TID = 21059; // "gv$session_longops"
const uint64_t OB_V_SESSION_LONGOPS_TID = 21060; // "v$session_longops"
const uint64_t OB_GV_TENANT_MEMSTORE_ALLOCATOR_INFO_TID = 21064; // "gv$tenant_memstore_allocator_info"
const uint64_t OB_V_TENANT_MEMSTORE_ALLOCATOR_INFO_TID = 21065; // "v$tenant_memstore_allocator_info"
const uint64_t OB_GV_TENANT_SEQUENCE_OBJECT_TID = 21066; // "gv$tenant_sequence_object"
const uint64_t OB_COLUMNS_TID = 21068; // "COLUMNS"
const uint64_t OB_GV_MINOR_MERGE_INFO_TID = 21069; // "gv$minor_merge_info"
const uint64_t OB_GV_TENANT_PX_WORKER_STAT_TID = 21071; // "gv$tenant_px_worker_stat"
const uint64_t OB_V_TENANT_PX_WORKER_STAT_TID = 21072; // "v$tenant_px_worker_stat"
const uint64_t OB_GV_PARTITION_AUDIT_TID = 21073; // "gv$partition_audit"
const uint64_t OB_V_PARTITION_AUDIT_TID = 21074; // "v$partition_audit"
const uint64_t OB_V_OB_CLUSTER_TID = 21075; // "v$ob_cluster"
const uint64_t OB_GV_PS_STAT_TID = 21079; // "gv$ps_stat"
const uint64_t OB_V_PS_STAT_TID = 21080; // "v$ps_stat"
const uint64_t OB_GV_PS_ITEM_INFO_TID = 21081; // "gv$ps_item_info"
const uint64_t OB_V_PS_ITEM_INFO_TID = 21082; // "v$ps_item_info"
const uint64_t OB_GV_SQL_WORKAREA_TID = 21083; // "gv$sql_workarea"
const uint64_t OB_V_SQL_WORKAREA_TID = 21084; // "v$sql_workarea"
const uint64_t OB_GV_SQL_WORKAREA_ACTIVE_TID = 21085; // "gv$sql_workarea_active"
const uint64_t OB_V_SQL_WORKAREA_ACTIVE_TID = 21086; // "v$sql_workarea_active"
const uint64_t OB_GV_SQL_WORKAREA_HISTOGRAM_TID = 21087; // "gv$sql_workarea_histogram"
const uint64_t OB_V_SQL_WORKAREA_HISTOGRAM_TID = 21088; // "v$sql_workarea_histogram"
const uint64_t OB_GV_OB_SQL_WORKAREA_MEMORY_INFO_TID = 21089; // "gv$ob_sql_workarea_memory_info"
const uint64_t OB_V_OB_SQL_WORKAREA_MEMORY_INFO_TID = 21090; // "v$ob_sql_workarea_memory_info"
const uint64_t OB_GV_PLAN_CACHE_REFERENCE_INFO_TID = 21097; // "gv$plan_cache_reference_info"
const uint64_t OB_V_PLAN_CACHE_REFERENCE_INFO_TID = 21098; // "v$plan_cache_reference_info"
const uint64_t OB_V_OB_TIMESTAMP_SERVICE_TID = 21099; // "v$ob_timestamp_service"
const uint64_t OB_GV_SSTABLE_TID = 21100; // "gv$sstable"
const uint64_t OB_V_SSTABLE_TID = 21101; // "v$sstable"
const uint64_t OB_CDB_OB_BACKUP_ARCHIVELOG_SUMMARY_TID = 21102; // "CDB_OB_BACKUP_ARCHIVELOG_SUMMARY"
const uint64_t OB_CDB_OB_BACKUP_JOB_DETAILS_TID = 21103; // "CDB_OB_BACKUP_JOB_DETAILS"
const uint64_t OB_CDB_OB_BACKUP_SET_DETAILS_TID = 21104; // "CDB_OB_BACKUP_SET_DETAILS"
const uint64_t OB_CDB_OB_BACKUP_SET_EXPIRED_TID = 21105; // "CDB_OB_BACKUP_SET_EXPIRED"
const uint64_t OB_CDB_OB_BACKUP_PROGRESS_TID = 21106; // "CDB_OB_BACKUP_PROGRESS"
const uint64_t OB_CDB_OB_BACKUP_ARCHIVELOG_PROGRESS_TID = 21107; // "CDB_OB_BACKUP_ARCHIVELOG_PROGRESS"
const uint64_t OB_CDB_OB_BACKUP_CLEAN_HISTORY_TID = 21108; // "CDB_OB_BACKUP_CLEAN_HISTORY"
const uint64_t OB_CDB_OB_BACKUP_TASK_CLEAN_HISTORY_TID = 21109; // "CDB_OB_BACKUP_TASK_CLEAN_HISTORY"
const uint64_t OB_CDB_OB_RESTORE_PROGRESS_TID = 21110; // "CDB_OB_RESTORE_PROGRESS"
const uint64_t OB_CDB_OB_RESTORE_HISTORY_TID = 21111; // "CDB_OB_RESTORE_HISTORY"
const uint64_t OB_GV_SERVER_SCHEMA_INFO_TID = 21112; // "gv$server_schema_info"
const uint64_t OB_V_SERVER_SCHEMA_INFO_TID = 21113; // "v$server_schema_info"
const uint64_t OB_CDB_CKPT_HISTORY_TID = 21114; // "CDB_CKPT_HISTORY"
const uint64_t OB_GV_OB_TRANS_TABLE_STATUS_TID = 21115; // "gv$ob_trans_table_status"
const uint64_t OB_V_OB_TRANS_TABLE_STATUS_TID = 21116; // "v$ob_trans_table_status"
const uint64_t OB_V_SQL_MONITOR_STATNAME_TID = 21117; // "v$sql_monitor_statname"
const uint64_t OB_GV_MERGE_INFO_TID = 21118; // "gv$merge_info"
const uint64_t OB_V_MERGE_INFO_TID = 21119; // "v$merge_info"
const uint64_t OB_GV_LOCK_TID = 21120; // "gv$lock"
const uint64_t OB_V_LOCK_TID = 21121; // "v$lock"
const uint64_t OB_CDB_OB_BACKUP_VALIDATION_JOB_TID = 21122; // "CDB_OB_BACKUP_VALIDATION_JOB"
const uint64_t OB_CDB_OB_BACKUP_VALIDATION_JOB_HISTORY_TID = 21123; // "CDB_OB_BACKUP_VALIDATION_JOB_HISTORY"
const uint64_t OB_CDB_OB_TENANT_BACKUP_VALIDATION_TASK_TID = 21124; // "CDB_OB_TENANT_BACKUP_VALIDATION_TASK"
const uint64_t OB_CDB_OB_BACKUP_VALIDATION_TASK_HISTORY_TID = 21125; // "CDB_OB_BACKUP_VALIDATION_TASK_HISTORY"
const uint64_t OB_V_RESTORE_POINT_TID = 21126; // "v$restore_point"
const uint64_t OB_CDB_OB_BACKUP_SET_OBSOLETE_TID = 21127; // "CDB_OB_BACKUP_SET_OBSOLETE"
const uint64_t OB_CDB_OB_BACKUP_BACKUPSET_JOB_TID = 21128; // "CDB_OB_BACKUP_BACKUPSET_JOB"
const uint64_t OB_CDB_OB_BACKUP_BACKUPSET_JOB_HISTORY_TID = 21129; // "CDB_OB_BACKUP_BACKUPSET_JOB_HISTORY"
const uint64_t OB_CDB_OB_BACKUP_BACKUPSET_TASK_TID = 21130; // "CDB_OB_BACKUP_BACKUPSET_TASK"
const uint64_t OB_CDB_OB_BACKUP_BACKUPSET_TASK_HISTORY_TID = 21131; // "CDB_OB_BACKUP_BACKUPSET_TASK_HISTORY"
const uint64_t OB_CDB_OB_BACKUP_BACKUP_ARCHIVELOG_SUMMARY_TID = 21132; // "CDB_OB_BACKUP_BACKUP_ARCHIVELOG_SUMMARY"
const uint64_t OB_DBA_SYNONYMS_TID = 25001; // "DBA_SYNONYMS"
const uint64_t OB_DBA_OBJECTS_TID = 25002; // "DBA_OBJECTS"
const uint64_t OB_ALL_OBJECTS_TID = 25003; // "ALL_OBJECTS"
const uint64_t OB_USER_OBJECTS_TID = 25004; // "USER_OBJECTS"
const uint64_t OB_DBA_SEQUENCES_TID = 25005; // "DBA_SEQUENCES"
const uint64_t OB_ALL_SEQUENCES_TID = 25006; // "ALL_SEQUENCES"
const uint64_t OB_USER_SEQUENCES_TID = 25007; // "USER_SEQUENCES"
const uint64_t OB_DBA_USERS_TID = 25008; // "DBA_USERS"
const uint64_t OB_ALL_USERS_TID = 25009; // "ALL_USERS"
const uint64_t OB_ALL_SYNONYMS_TID = 25010; // "ALL_SYNONYMS"
const uint64_t OB_USER_SYNONYMS_TID = 25011; // "USER_SYNONYMS"
const uint64_t OB_DBA_IND_COLUMNS_TID = 25012; // "DBA_IND_COLUMNS"
const uint64_t OB_ALL_IND_COLUMNS_TID = 25013; // "ALL_IND_COLUMNS"
const uint64_t OB_USER_IND_COLUMNS_TID = 25014; // "USER_IND_COLUMNS"
const uint64_t OB_DBA_CONSTRAINTS_TID = 25015; // "DBA_CONSTRAINTS"
const uint64_t OB_ALL_CONSTRAINTS_TID = 25016; // "ALL_CONSTRAINTS"
const uint64_t OB_USER_CONSTRAINTS_TID = 25017; // "USER_CONSTRAINTS"
const uint64_t OB_ALL_TAB_COLS_V_TID = 25018; // "ALL_TAB_COLS_V$"
const uint64_t OB_DBA_TAB_COLS_V_TID = 25019; // "DBA_TAB_COLS_V$"
const uint64_t OB_USER_TAB_COLS_V_TID = 25020; // "USER_TAB_COLS_V$"
const uint64_t OB_ALL_TAB_COLS_TID = 25021; // "ALL_TAB_COLS"
const uint64_t OB_DBA_TAB_COLS_TID = 25022; // "DBA_TAB_COLS"
const uint64_t OB_USER_TAB_COLS_TID = 25023; // "USER_TAB_COLS"
const uint64_t OB_ALL_TAB_COLUMNS_TID = 25024; // "ALL_TAB_COLUMNS"
const uint64_t OB_DBA_TAB_COLUMNS_TID = 25025; // "DBA_TAB_COLUMNS"
const uint64_t OB_USER_TAB_COLUMNS_TID = 25026; // "USER_TAB_COLUMNS"
const uint64_t OB_ALL_TABLES_TID = 25027; // "ALL_TABLES"
const uint64_t OB_DBA_TABLES_TID = 25028; // "DBA_TABLES"
const uint64_t OB_USER_TABLES_TID = 25029; // "USER_TABLES"
const uint64_t OB_DBA_TAB_COMMENTS_TID = 25030; // "DBA_TAB_COMMENTS"
const uint64_t OB_ALL_TAB_COMMENTS_TID = 25031; // "ALL_TAB_COMMENTS"
const uint64_t OB_USER_TAB_COMMENTS_TID = 25032; // "USER_TAB_COMMENTS"
const uint64_t OB_DBA_COL_COMMENTS_TID = 25033; // "DBA_COL_COMMENTS"
const uint64_t OB_ALL_COL_COMMENTS_TID = 25034; // "ALL_COL_COMMENTS"
const uint64_t OB_USER_COL_COMMENTS_TID = 25035; // "USER_COL_COMMENTS"
const uint64_t OB_DBA_INDEXES_TID = 25036; // "DBA_INDEXES"
const uint64_t OB_ALL_INDEXES_TID = 25037; // "ALL_INDEXES"
const uint64_t OB_USER_INDEXES_TID = 25038; // "USER_INDEXES"
const uint64_t OB_DBA_CONS_COLUMNS_TID = 25039; // "DBA_CONS_COLUMNS"
const uint64_t OB_ALL_CONS_COLUMNS_TID = 25040; // "ALL_CONS_COLUMNS"
const uint64_t OB_USER_CONS_COLUMNS_TID = 25041; // "USER_CONS_COLUMNS"
const uint64_t OB_USER_SEGMENTS_TID = 25042; // "USER_SEGMENTS"
const uint64_t OB_DBA_SEGMENTS_TID = 25043; // "DBA_SEGMENTS"
const uint64_t OB_DBA_TYPES_TID = 25044; // "DBA_TYPES"
const uint64_t OB_ALL_TYPES_TID = 25045; // "ALL_TYPES"
const uint64_t OB_USER_TYPES_TID = 25046; // "USER_TYPES"
const uint64_t OB_DBA_TYPE_ATTRS_TID = 25047; // "DBA_TYPE_ATTRS"
const uint64_t OB_ALL_TYPE_ATTRS_TID = 25048; // "ALL_TYPE_ATTRS"
const uint64_t OB_USER_TYPE_ATTRS_TID = 25049; // "USER_TYPE_ATTRS"
const uint64_t OB_DBA_COLL_TYPES_TID = 25050; // "DBA_COLL_TYPES"
const uint64_t OB_ALL_COLL_TYPES_TID = 25051; // "ALL_COLL_TYPES"
const uint64_t OB_USER_COLL_TYPES_TID = 25052; // "USER_COLL_TYPES"
const uint64_t OB_DBA_PROCEDURES_TID = 25053; // "DBA_PROCEDURES"
const uint64_t OB_DBA_ARGUMENTS_TID = 25054; // "DBA_ARGUMENTS"
const uint64_t OB_DBA_SOURCE_TID = 25055; // "DBA_SOURCE"
const uint64_t OB_ALL_PROCEDURES_TID = 25056; // "ALL_PROCEDURES"
const uint64_t OB_ALL_ARGUMENTS_TID = 25057; // "ALL_ARGUMENTS"
const uint64_t OB_ALL_SOURCE_TID = 25058; // "ALL_SOURCE"
const uint64_t OB_USER_PROCEDURES_TID = 25059; // "USER_PROCEDURES"
const uint64_t OB_USER_ARGUMENTS_TID = 25060; // "USER_ARGUMENTS"
const uint64_t OB_USER_SOURCE_TID = 25061; // "USER_SOURCE"
const uint64_t OB_DBA_PART_KEY_COLUMNS_TID = 25062; // "DBA_PART_KEY_COLUMNS"
const uint64_t OB_ALL_PART_KEY_COLUMNS_TID = 25063; // "ALL_PART_KEY_COLUMNS"
const uint64_t OB_USER_PART_KEY_COLUMNS_TID = 25064; // "USER_PART_KEY_COLUMNS"
const uint64_t OB_DBA_SUBPART_KEY_COLUMNS_TID = 25065; // "DBA_SUBPART_KEY_COLUMNS"
const uint64_t OB_ALL_SUBPART_KEY_COLUMNS_TID = 25066; // "ALL_SUBPART_KEY_COLUMNS"
const uint64_t OB_USER_SUBPART_KEY_COLUMNS_TID = 25067; // "USER_SUBPART_KEY_COLUMNS"
const uint64_t OB_DBA_VIEWS_TID = 25068; // "DBA_VIEWS"
const uint64_t OB_ALL_VIEWS_TID = 25069; // "ALL_VIEWS"
const uint64_t OB_USER_VIEWS_TID = 25070; // "USER_VIEWS"
const uint64_t OB_ALL_TAB_PARTITIONS_ORA_TID = 25071; // "ALL_TAB_PARTITIONS_ORA"
const uint64_t OB_ALL_TAB_SUBPARTITIONS_ORA_TID = 25072; // "ALL_TAB_SUBPARTITIONS_ORA"
const uint64_t OB_ALL_PART_TABLES_ORA_TID = 25073; // "ALL_PART_TABLES_ORA"
const uint64_t OB_DBA_PART_TABLES_ORA_TID = 25074; // "DBA_PART_TABLES_ORA"
const uint64_t OB_USER_PART_TABLES_ORA_TID = 25075; // "USER_PART_TABLES_ORA"
const uint64_t OB_DBA_TAB_PARTITIONS_ORA_TID = 25076; // "DBA_TAB_PARTITIONS_ORA"
const uint64_t OB_USER_TAB_PARTITIONS_ORA_TID = 25077; // "USER_TAB_PARTITIONS_ORA"
const uint64_t OB_DBA_TAB_SUBPARTITIONS_ORA_TID = 25078; // "DBA_TAB_SUBPARTITIONS_ORA"
const uint64_t OB_USER_TAB_SUBPARTITIONS_ORA_TID = 25079; // "USER_TAB_SUBPARTITIONS_ORA"
const uint64_t OB_DBA_SUBPARTITION_TEMPLATES_ORA_TID = 25080; // "DBA_SUBPARTITION_TEMPLATES_ORA"
const uint64_t OB_ALL_SUBPARTITION_TEMPLATES_ORA_TID = 25081; // "ALL_SUBPARTITION_TEMPLATES_ORA"
const uint64_t OB_USER_SUBPARTITION_TEMPLATES_ORA_TID = 25082; // "USER_SUBPARTITION_TEMPLATES_ORA"
const uint64_t OB_DBA_PART_INDEXES_TID = 25083; // "DBA_PART_INDEXES"
const uint64_t OB_ALL_PART_INDEXES_TID = 25084; // "ALL_PART_INDEXES"
const uint64_t OB_USER_PART_INDEXES_TID = 25085; // "USER_PART_INDEXES"
const uint64_t OB_ALL_ALL_TABLES_ORA_TID = 25086; // "ALL_ALL_TABLES_ORA"
const uint64_t OB_DBA_ALL_TABLES_ORA_TID = 25087; // "DBA_ALL_TABLES_ORA"
const uint64_t OB_USER_ALL_TABLES_ORA_TID = 25088; // "USER_ALL_TABLES_ORA"
const uint64_t OB_DBA_PROFILES_ORA_TID = 25089; // "DBA_PROFILES_ORA"
const uint64_t OB_USER_PROFILES_ORA_TID = 25090; // "USER_PROFILES_ORA"
const uint64_t OB_ALL_PROFILES_ORA_TID = 25091; // "ALL_PROFILES_ORA"
const uint64_t OB_ALL_MVIEW_COMMENTS_ORA_TID = 25092; // "ALL_MVIEW_COMMENTS_ORA"
const uint64_t OB_USER_MVIEW_COMMENTS_ORA_TID = 25093; // "USER_MVIEW_COMMENTS_ORA"
const uint64_t OB_DBA_MVIEW_COMMENTS_ORA_TID = 25094; // "DBA_MVIEW_COMMENTS_ORA"
const uint64_t OB_ALL_SCHEDULER_PROGRAM_ARGS_ORA_TID = 25095; // "ALL_SCHEDULER_PROGRAM_ARGS_ORA"
const uint64_t OB_DBA_SCHEDULER_PROGRAM_ARGS_ORA_TID = 25096; // "DBA_SCHEDULER_PROGRAM_ARGS_ORA"
const uint64_t OB_USER_SCHEDULER_PROGRAM_ARGS_ORA_TID = 25097; // "USER_SCHEDULER_PROGRAM_ARGS_ORA"
const uint64_t OB_ALL_SCHEDULER_JOB_ARGS_ORA_TID = 25098; // "ALL_SCHEDULER_JOB_ARGS_ORA"
const uint64_t OB_DBA_SCHEDULER_JOB_ARGS_ORA_TID = 25099; // "DBA_SCHEDULER_JOB_ARGS_ORA"
const uint64_t OB_USER_SCHEDULER_JOB_ARGS_ORA_TID = 25100; // "USER_SCHEDULER_JOB_ARGS_ORA"
const uint64_t OB_ALL_ERRORS_ORA_TID = 25101; // "ALL_ERRORS_ORA"
const uint64_t OB_DBA_ERRORS_ORA_TID = 25102; // "DBA_ERRORS_ORA"
const uint64_t OB_USER_ERRORS_ORA_TID = 25103; // "USER_ERRORS_ORA"
const uint64_t OB_ALL_TYPE_METHODS_ORA_TID = 25104; // "ALL_TYPE_METHODS_ORA"
const uint64_t OB_DBA_TYPE_METHODS_ORA_TID = 25105; // "DBA_TYPE_METHODS_ORA"
const uint64_t OB_USER_TYPE_METHODS_ORA_TID = 25106; // "USER_TYPE_METHODS_ORA"
const uint64_t OB_ALL_METHOD_PARAMS_ORA_TID = 25107; // "ALL_METHOD_PARAMS_ORA"
const uint64_t OB_DBA_METHOD_PARAMS_ORA_TID = 25108; // "DBA_METHOD_PARAMS_ORA"
const uint64_t OB_USER_METHOD_PARAMS_ORA_TID = 25109; // "USER_METHOD_PARAMS_ORA"
const uint64_t OB_DBA_TABLESPACES_ORA_TID = 25110; // "DBA_TABLESPACES_ORA"
const uint64_t OB_USER_TABLESPACES_ORA_TID = 25111; // "USER_TABLESPACES_ORA"
const uint64_t OB_DBA_IND_EXPRESSIONS_TID = 25112; // "DBA_IND_EXPRESSIONS"
const uint64_t OB_USER_IND_EXPRESSIONS_TID = 25113; // "USER_IND_EXPRESSIONS"
const uint64_t OB_ALL_IND_EXPRESSIONS_TID = 25114; // "ALL_IND_EXPRESSIONS"
const uint64_t OB_ALL_IND_PARTITIONS_TID = 25115; // "ALL_IND_PARTITIONS"
const uint64_t OB_USER_IND_PARTITIONS_TID = 25116; // "USER_IND_PARTITIONS"
const uint64_t OB_DBA_IND_PARTITIONS_TID = 25117; // "DBA_IND_PARTITIONS"
const uint64_t OB_DBA_IND_SUBPARTITIONS_TID = 25118; // "DBA_IND_SUBPARTITIONS"
const uint64_t OB_ALL_IND_SUBPARTITIONS_TID = 25119; // "ALL_IND_SUBPARTITIONS"
const uint64_t OB_USER_IND_SUBPARTITIONS_TID = 25120; // "USER_IND_SUBPARTITIONS"
const uint64_t OB_DBA_ROLES_TID = 25121; // "DBA_ROLES"
const uint64_t OB_DBA_ROLE_PRIVS_TID = 25122; // "DBA_ROLE_PRIVS"
const uint64_t OB_USER_ROLE_PRIVS_TID = 25123; // "USER_ROLE_PRIVS"
const uint64_t OB_DBA_TAB_PRIVS_TID = 25124; // "DBA_TAB_PRIVS"
const uint64_t OB_ALL_TAB_PRIVS_TID = 25125; // "ALL_TAB_PRIVS"
const uint64_t OB_USER_TAB_PRIVS_TID = 25126; // "USER_TAB_PRIVS"
const uint64_t OB_DBA_SYS_PRIVS_TID = 25127; // "DBA_SYS_PRIVS"
const uint64_t OB_USER_SYS_PRIVS_TID = 25128; // "USER_SYS_PRIVS"
const uint64_t OB_DBA_COL_PRIVS_ORA_TID = 25143; // "DBA_COL_PRIVS_ORA"
const uint64_t OB_USER_COL_PRIVS_ORA_TID = 25144; // "USER_COL_PRIVS_ORA"
const uint64_t OB_ALL_COL_PRIVS_ORA_TID = 25145; // "ALL_COL_PRIVS_ORA"
const uint64_t OB_ROLE_TAB_PRIVS_ORA_TID = 25146; // "ROLE_TAB_PRIVS_ORA"
const uint64_t OB_ROLE_SYS_PRIVS_ORA_TID = 25147; // "ROLE_SYS_PRIVS_ORA"
const uint64_t OB_ROLE_ROLE_PRIVS_ORA_TID = 25148; // "ROLE_ROLE_PRIVS_ORA"
const uint64_t OB_DICTIONARY_ORA_TID = 25149; // "DICTIONARY_ORA"
const uint64_t OB_DICT_ORA_TID = 25150; // "DICT_ORA"
const uint64_t OB_ALL_TRIGGERS_TID = 25151; // "ALL_TRIGGERS"
const uint64_t OB_DBA_TRIGGERS_TID = 25152; // "DBA_TRIGGERS"
const uint64_t OB_USER_TRIGGERS_TID = 25153; // "USER_TRIGGERS"
const uint64_t OB_ALL_DEPENDENCIES_ORA_TID = 25154; // "ALL_DEPENDENCIES_ORA"
const uint64_t OB_DBA_DEPENDENCIES_ORA_TID = 25155; // "DBA_DEPENDENCIES_ORA"
const uint64_t OB_USER_DEPENDENCIES_ORA_TID = 25156; // "USER_DEPENDENCIES_ORA"
const uint64_t OB_DBA_RSRC_PLANS_TID = 25157; // "DBA_RSRC_PLANS"
const uint64_t OB_DBA_RSRC_PLAN_DIRECTIVES_TID = 25158; // "DBA_RSRC_PLAN_DIRECTIVES"
const uint64_t OB_DBA_RSRC_GROUP_MAPPINGS_TID = 25159; // "DBA_RSRC_GROUP_MAPPINGS"
const uint64_t OB_DBA_RECYCLEBIN_ORA_TID = 25160; // "DBA_RECYCLEBIN_ORA"
const uint64_t OB_USER_RECYCLEBIN_ORA_TID = 25161; // "USER_RECYCLEBIN_ORA"
const uint64_t OB_DBA_RSRC_CONSUMER_GROUPS_TID = 25162; // "DBA_RSRC_CONSUMER_GROUPS"
const uint64_t OB_GV_OUTLINE_ORA_TID = 28001; // "GV$OUTLINE_ORA"
const uint64_t OB_GV_SQL_AUDIT_ORA_TID = 28002; // "GV$SQL_AUDIT_ORA"
const uint64_t OB_V_SQL_AUDIT_ORA_TID = 28003; // "V$SQL_AUDIT_ORA"
const uint64_t OB_GV_INSTANCE_TID = 28004; // "GV$INSTANCE"
const uint64_t OB_V_INSTANCE_TID = 28005; // "V$INSTANCE"
const uint64_t OB_GV_PLAN_CACHE_PLAN_STAT_ORA_TID = 28006; // "GV$PLAN_CACHE_PLAN_STAT_ORA"
const uint64_t OB_V_PLAN_CACHE_PLAN_STAT_ORA_TID = 28007; // "V$PLAN_CACHE_PLAN_STAT_ORA"
const uint64_t OB_GV_PLAN_CACHE_PLAN_EXPLAIN_ORA_TID = 28008; // "GV$PLAN_CACHE_PLAN_EXPLAIN_ORA"
const uint64_t OB_V_PLAN_CACHE_PLAN_EXPLAIN_ORA_TID = 28009; // "V$PLAN_CACHE_PLAN_EXPLAIN_ORA"
const uint64_t OB_GV_SESSION_WAIT_ORA_TID = 28010; // "GV$SESSION_WAIT_ORA"
const uint64_t OB_V_SESSION_WAIT_ORA_TID = 28011; // "V$SESSION_WAIT_ORA"
const uint64_t OB_GV_SESSION_WAIT_HISTORY_ORA_TID = 28012; // "GV$SESSION_WAIT_HISTORY_ORA"
const uint64_t OB_V_SESSION_WAIT_HISTORY_ORA_TID = 28013; // "V$SESSION_WAIT_HISTORY_ORA"
const uint64_t OB_GV_MEMORY_ORA_TID = 28014; // "GV$MEMORY_ORA"
const uint64_t OB_V_MEMORY_ORA_TID = 28015; // "V$MEMORY_ORA"
const uint64_t OB_GV_MEMSTORE_ORA_TID = 28016; // "GV$MEMSTORE_ORA"
const uint64_t OB_V_MEMSTORE_ORA_TID = 28017; // "V$MEMSTORE_ORA"
const uint64_t OB_GV_MEMSTORE_INFO_ORA_TID = 28018; // "GV$MEMSTORE_INFO_ORA"
const uint64_t OB_V_MEMSTORE_INFO_ORA_TID = 28019; // "V$MEMSTORE_INFO_ORA"
const uint64_t OB_GV_SERVER_MEMSTORE_ORA_TID = 28020; // "GV$SERVER_MEMSTORE_ORA"
const uint64_t OB_GV_SESSTAT_ORA_TID = 28021; // "GV$SESSTAT_ORA"
const uint64_t OB_V_SESSTAT_ORA_TID = 28022; // "V$SESSTAT_ORA"
const uint64_t OB_GV_SYSSTAT_ORA_TID = 28023; // "GV$SYSSTAT_ORA"
const uint64_t OB_V_SYSSTAT_ORA_TID = 28024; // "V$SYSSTAT_ORA"
const uint64_t OB_GV_SYSTEM_EVENT_ORA_TID = 28025; // "GV$SYSTEM_EVENT_ORA"
const uint64_t OB_V_SYSTEM_EVENT_ORA_TID = 28026; // "V$SYSTEM_EVENT_ORA"
const uint64_t OB_GV_TENANT_MEMSTORE_ALLOCATOR_INFO_ORA_TID = 28027; // "GV$TENANT_MEMSTORE_ALLOCATOR_INFO_ORA"
const uint64_t OB_V_TENANT_MEMSTORE_ALLOCATOR_INFO_ORA_TID = 28028; // "V$TENANT_MEMSTORE_ALLOCATOR_INFO_ORA"
const uint64_t OB_GV_PLAN_CACHE_STAT_ORA_TID = 28029; // "GV$PLAN_CACHE_STAT_ORA"
const uint64_t OB_V_PLAN_CACHE_STAT_ORA_TID = 28030; // "V$PLAN_CACHE_STAT_ORA"
const uint64_t OB_GV_CONCURRENT_LIMIT_SQL_ORA_TID = 28031; // "GV$CONCURRENT_LIMIT_SQL_ORA"
const uint64_t OB_NLS_SESSION_PARAMETERS_ORA_TID = 28032; // "NLS_SESSION_PARAMETERS_ORA"
const uint64_t OB_NLS_INSTANCE_PARAMETERS_ORA_TID = 28033; // "NLS_INSTANCE_PARAMETERS_ORA"
const uint64_t OB_NLS_DATABASE_PARAMETERS_ORA_TID = 28034; // "NLS_DATABASE_PARAMETERS_ORA"
const uint64_t OB_V_NLS_PARAMETERS_ORA_TID = 28035; // "V$NLS_PARAMETERS_ORA"
const uint64_t OB_V_VERSION_ORA_TID = 28036; // "V$VERSION_ORA"
const uint64_t OB_GV_TENANT_PX_WORKER_STAT_ORA_TID = 28037; // "GV$TENANT_PX_WORKER_STAT_ORA"
const uint64_t OB_V_TENANT_PX_WORKER_STAT_ORA_TID = 28038; // "V$TENANT_PX_WORKER_STAT_ORA"
const uint64_t OB_GV_PS_STAT_ORA_TID = 28039; // "GV$PS_STAT_ORA"
const uint64_t OB_V_PS_STAT_ORA_TID = 28040; // "V$PS_STAT_ORA"
const uint64_t OB_GV_PS_ITEM_INFO_ORA_TID = 28041; // "GV$PS_ITEM_INFO_ORA"
const uint64_t OB_V_PS_ITEM_INFO_ORA_TID = 28042; // "V$PS_ITEM_INFO_ORA"
const uint64_t OB_GV_SQL_WORKAREA_ACTIVE_ORA_TID = 28045; // "GV$SQL_WORKAREA_ACTIVE_ORA"
const uint64_t OB_V_SQL_WORKAREA_ACTIVE_ORA_TID = 28046; // "V$SQL_WORKAREA_ACTIVE_ORA"
const uint64_t OB_GV_SQL_WORKAREA_HISTOGRAM_ORA_TID = 28047; // "GV$SQL_WORKAREA_HISTOGRAM_ORA"
const uint64_t OB_V_SQL_WORKAREA_HISTOGRAM_ORA_TID = 28048; // "V$SQL_WORKAREA_HISTOGRAM_ORA"
const uint64_t OB_GV_OB_SQL_WORKAREA_MEMORY_INFO_ORA_TID = 28049; // "GV$OB_SQL_WORKAREA_MEMORY_INFO_ORA"
const uint64_t OB_V_OB_SQL_WORKAREA_MEMORY_INFO_ORA_TID = 28050; // "V$OB_SQL_WORKAREA_MEMORY_INFO_ORA"
const uint64_t OB_GV_PLAN_CACHE_REFERENCE_INFO_ORA_TID = 28051; // "GV$PLAN_CACHE_REFERENCE_INFO_ORA"
const uint64_t OB_V_PLAN_CACHE_REFERENCE_INFO_ORA_TID = 28052; // "V$PLAN_CACHE_REFERENCE_INFO_ORA"
const uint64_t OB_GV_SQL_WORKAREA_ORA_TID = 28053; // "GV$SQL_WORKAREA_ORA"
const uint64_t OB_V_SQL_WORKAREA_ORA_TID = 28054; // "V$SQL_WORKAREA_ORA"
const uint64_t OB_GV_SSTABLE_ORA_TID = 28055; // "GV$SSTABLE_ORA"
const uint64_t OB_V_SSTABLE_ORA_TID = 28056; // "V$SSTABLE_ORA"
const uint64_t OB_GV_SERVER_SCHEMA_INFO_ORA_TID = 28057; // "GV$SERVER_SCHEMA_INFO_ORA"
const uint64_t OB_V_SERVER_SCHEMA_INFO_ORA_TID = 28058; // "V$SERVER_SCHEMA_INFO_ORA"
const uint64_t OB_GV_SQL_PLAN_MONITOR_ORA_TID = 28059; // "GV$SQL_PLAN_MONITOR_ORA"
const uint64_t OB_V_SQL_PLAN_MONITOR_ORA_TID = 28060; // "V$SQL_PLAN_MONITOR_ORA"
const uint64_t OB_V_SQL_MONITOR_STATNAME_ORA_TID = 28061; // "V$SQL_MONITOR_STATNAME_ORA"
const uint64_t OB_GV_LOCK_ORA_TID = 28062; // "GV$LOCK_ORA"
const uint64_t OB_V_LOCK_ORA_TID = 28063; // "V$LOCK_ORA"
const uint64_t OB_GV_OPEN_CURSOR_ORA_TID = 28064; // "GV$OPEN_CURSOR_ORA"
const uint64_t OB_V_OPEN_CURSOR_ORA_TID = 28065; // "V$OPEN_CURSOR_ORA"
const uint64_t OB_V_TIMEZONE_NAMES_ORA_TID = 28066; // "V$TIMEZONE_NAMES_ORA"
const uint64_t OB_GV_GLOBAL_TRANSACTION_ORA_TID = 28067; // "GV$GLOBAL_TRANSACTION_ORA"
const uint64_t OB_V_GLOBAL_TRANSACTION_ORA_TID = 28068; // "V$GLOBAL_TRANSACTION_ORA"
const uint64_t OB_V_RESTORE_POINT_ORA_TID = 28069; // "V$RESTORE_POINT_ORA"
const uint64_t OB_V_RSRC_PLAN_ORA_TID = 28070; // "V$RSRC_PLAN_ORA"
const uint64_t OB_TRIGGERS_TID = 28071; // "TRIGGERS"
const uint64_t OB_ALL_TABLE_V2_HISTORY_IDX_DATA_TABLE_ID_TID = 9998; // "__all_table_v2_history"
const uint64_t OB_ALL_TABLE_HISTORY_IDX_DATA_TABLE_ID_TID = 9999; // "__all_table_history"
const uint64_t OB_ALL_VIRTUAL_PLAN_CACHE_STAT_ALL_VIRTUAL_PLAN_CACHE_STAT_I1_TID = 14999; // "__all_virtual_plan_cache_stat"
const uint64_t OB_ALL_VIRTUAL_SESSION_EVENT_ALL_VIRTUAL_SESSION_EVENT_I1_TID = 14998; // "__all_virtual_session_event"
const uint64_t OB_ALL_VIRTUAL_SESSION_WAIT_ALL_VIRTUAL_SESSION_WAIT_I1_TID = 14997; // "__all_virtual_session_wait"
const uint64_t OB_ALL_VIRTUAL_SESSION_WAIT_HISTORY_ALL_VIRTUAL_SESSION_WAIT_HISTORY_I1_TID = 14996; // "__all_virtual_session_wait_history"
const uint64_t OB_ALL_VIRTUAL_SYSTEM_EVENT_ALL_VIRTUAL_SYSTEM_EVENT_I1_TID = 14995; // "__all_virtual_system_event"
const uint64_t OB_ALL_VIRTUAL_SESSTAT_ALL_VIRTUAL_SESSTAT_I1_TID = 14994; // "__all_virtual_sesstat"
const uint64_t OB_ALL_VIRTUAL_SYSSTAT_ALL_VIRTUAL_SYSSTAT_I1_TID = 14993; // "__all_virtual_sysstat"
const uint64_t OB_ALL_VIRTUAL_SQL_AUDIT_ALL_VIRTUAL_SQL_AUDIT_I1_TID = 14992; // "__all_virtual_sql_audit"
const uint64_t OB_ALL_VIRTUAL_REPLICA_TASK_ALL_VIRTUAL_REPLICA_TASK_I1_TID = 14991; // "__all_virtual_replica_task"
const uint64_t OB_ALL_VIRTUAL_SQL_PLAN_MONITOR_ALL_VIRTUAL_SQL_PLAN_MONITOR_I1_TID = 14990; // "__all_virtual_sql_plan_monitor"
const uint64_t OB_ALL_VIRTUAL_SQL_AUDIT_ORA_ALL_VIRTUAL_SQL_AUDIT_I1_TID = 19999; // "ALL_VIRTUAL_SQL_AUDIT_ORA"
const uint64_t OB_ALL_VIRTUAL_PLAN_CACHE_STAT_ORA_ALL_VIRTUAL_PLAN_CACHE_STAT_I1_TID = 19998; // "ALL_VIRTUAL_PLAN_CACHE_STAT_ORA"
const uint64_t OB_ALL_VIRTUAL_SESSION_WAIT_ORA_ALL_VIRTUAL_SESSION_WAIT_I1_TID = 19997; // "ALL_VIRTUAL_SESSION_WAIT_ORA"
const uint64_t OB_ALL_VIRTUAL_SESSION_WAIT_HISTORY_ORA_ALL_VIRTUAL_SESSION_WAIT_HISTORY_I1_TID = 19996; // "ALL_VIRTUAL_SESSION_WAIT_HISTORY_ORA"
const uint64_t OB_ALL_VIRTUAL_SESSTAT_ORA_ALL_VIRTUAL_SESSTAT_I1_TID = 19995; // "ALL_VIRTUAL_SESSTAT_ORA"
const uint64_t OB_ALL_VIRTUAL_SYSSTAT_ORA_ALL_VIRTUAL_SYSSTAT_I1_TID = 19994; // "ALL_VIRTUAL_SYSSTAT_ORA"
const uint64_t OB_ALL_VIRTUAL_SYSTEM_EVENT_ORA_ALL_VIRTUAL_SYSTEM_EVENT_I1_TID = 19993; // "ALL_VIRTUAL_SYSTEM_EVENT_ORA"
const uint64_t OB_ALL_VIRTUAL_SQL_PLAN_MONITOR_ORA_ALL_VIRTUAL_SQL_PLAN_MONITOR_I1_TID = 19992; // "ALL_VIRTUAL_SQL_PLAN_MONITOR_ORA"

const char *const OB_ALL_CORE_TABLE_TNAME = "__all_core_table";
const char *const OB_ALL_ROOT_TABLE_TNAME = "__all_root_table";
const char *const OB_ALL_TABLE_TNAME = "__all_table";
const char *const OB_ALL_COLUMN_TNAME = "__all_column";
const char *const OB_ALL_DDL_OPERATION_TNAME = "__all_ddl_operation";
const char *const OB_ALL_TABLE_V2_TNAME = "__all_table_v2";
const char *const OB_ALL_META_TABLE_TNAME = "__all_meta_table";
const char *const OB_ALL_USER_TNAME = "__all_user";
const char *const OB_ALL_USER_HISTORY_TNAME = "__all_user_history";
const char *const OB_ALL_DATABASE_TNAME = "__all_database";
const char *const OB_ALL_DATABASE_HISTORY_TNAME = "__all_database_history";
const char *const OB_ALL_TABLEGROUP_TNAME = "__all_tablegroup";
const char *const OB_ALL_TABLEGROUP_HISTORY_TNAME = "__all_tablegroup_history";
const char *const OB_ALL_TENANT_TNAME = "__all_tenant";
const char *const OB_ALL_TENANT_HISTORY_TNAME = "__all_tenant_history";
const char *const OB_ALL_TABLE_PRIVILEGE_TNAME = "__all_table_privilege";
const char *const OB_ALL_TABLE_PRIVILEGE_HISTORY_TNAME = "__all_table_privilege_history";
const char *const OB_ALL_DATABASE_PRIVILEGE_TNAME = "__all_database_privilege";
const char *const OB_ALL_DATABASE_PRIVILEGE_HISTORY_TNAME = "__all_database_privilege_history";
const char *const OB_ALL_TABLE_HISTORY_TNAME = "__all_table_history";
const char *const OB_ALL_COLUMN_HISTORY_TNAME = "__all_column_history";
const char *const OB_ALL_ZONE_TNAME = "__all_zone";
const char *const OB_ALL_SERVER_TNAME = "__all_server";
const char *const OB_ALL_SYS_PARAMETER_TNAME = "__all_sys_parameter";
const char *const OB_TENANT_PARAMETER_TNAME = "__tenant_parameter";
const char *const OB_ALL_SYS_VARIABLE_TNAME = "__all_sys_variable";
const char *const OB_ALL_SYS_STAT_TNAME = "__all_sys_stat";
const char *const OB_ALL_COLUMN_STATISTIC_TNAME = "__all_column_statistic";
const char *const OB_ALL_UNIT_TNAME = "__all_unit";
const char *const OB_ALL_UNIT_CONFIG_TNAME = "__all_unit_config";
const char *const OB_ALL_RESOURCE_POOL_TNAME = "__all_resource_pool";
const char *const OB_ALL_TENANT_RESOURCE_USAGE_TNAME = "__all_tenant_resource_usage";
const char *const OB_ALL_SEQUENCE_TNAME = "__all_sequence";
const char *const OB_ALL_CHARSET_TNAME = "__all_charset";
const char *const OB_ALL_COLLATION_TNAME = "__all_collation";
const char *const OB_ALL_LOCAL_INDEX_STATUS_TNAME = "__all_local_index_status";
const char *const OB_ALL_DUMMY_TNAME = "__all_dummy";
const char *const OB_ALL_FROZEN_MAP_TNAME = "__all_frozen_map";
const char *const OB_ALL_CLOG_HISTORY_INFO_TNAME = "__all_clog_history_info";
const char *const OB_ALL_CLOG_HISTORY_INFO_V2_TNAME = "__all_clog_history_info_v2";
const char *const OB_ALL_ROOTSERVICE_EVENT_HISTORY_TNAME = "__all_rootservice_event_history";
const char *const OB_ALL_PRIVILEGE_TNAME = "__all_privilege";
const char *const OB_ALL_OUTLINE_TNAME = "__all_outline";
const char *const OB_ALL_OUTLINE_HISTORY_TNAME = "__all_outline_history";
const char *const OB_ALL_ELECTION_EVENT_HISTORY_TNAME = "__all_election_event_history";
const char *const OB_ALL_RECYCLEBIN_TNAME = "__all_recyclebin";
const char *const OB_ALL_PART_TNAME = "__all_part";
const char *const OB_ALL_PART_HISTORY_TNAME = "__all_part_history";
const char *const OB_ALL_SUB_PART_TNAME = "__all_sub_part";
const char *const OB_ALL_SUB_PART_HISTORY_TNAME = "__all_sub_part_history";
const char *const OB_ALL_PART_INFO_TNAME = "__all_part_info";
const char *const OB_ALL_PART_INFO_HISTORY_TNAME = "__all_part_info_history";
const char *const OB_ALL_DEF_SUB_PART_TNAME = "__all_def_sub_part";
const char *const OB_ALL_DEF_SUB_PART_HISTORY_TNAME = "__all_def_sub_part_history";
const char *const OB_ALL_SERVER_EVENT_HISTORY_TNAME = "__all_server_event_history";
const char *const OB_ALL_ROOTSERVICE_JOB_TNAME = "__all_rootservice_job";
const char *const OB_ALL_UNIT_LOAD_HISTORY_TNAME = "__all_unit_load_history";
const char *const OB_ALL_SYS_VARIABLE_HISTORY_TNAME = "__all_sys_variable_history";
const char *const OB_ALL_RESTORE_JOB_TNAME = "__all_restore_job";
const char *const OB_ALL_RESTORE_TASK_TNAME = "__all_restore_task";
const char *const OB_ALL_RESTORE_JOB_HISTORY_TNAME = "__all_restore_job_history";
const char *const OB_ALL_TIME_ZONE_TNAME = "__all_time_zone";
const char *const OB_ALL_TIME_ZONE_NAME_TNAME = "__all_time_zone_name";
const char *const OB_ALL_TIME_ZONE_TRANSITION_TNAME = "__all_time_zone_transition";
const char *const OB_ALL_TIME_ZONE_TRANSITION_TYPE_TNAME = "__all_time_zone_transition_type";
const char *const OB_ALL_DDL_ID_TNAME = "__all_ddl_id";
const char *const OB_ALL_FOREIGN_KEY_TNAME = "__all_foreign_key";
const char *const OB_ALL_FOREIGN_KEY_HISTORY_TNAME = "__all_foreign_key_history";
const char *const OB_ALL_FOREIGN_KEY_COLUMN_TNAME = "__all_foreign_key_column";
const char *const OB_ALL_FOREIGN_KEY_COLUMN_HISTORY_TNAME = "__all_foreign_key_column_history";
const char *const OB_ALL_SYNONYM_TNAME = "__all_synonym";
const char *const OB_ALL_SYNONYM_HISTORY_TNAME = "__all_synonym_history";
const char *const OB_ALL_SEQUENCE_V2_TNAME = "__all_sequence_v2";
const char *const OB_ALL_TENANT_META_TABLE_TNAME = "__all_tenant_meta_table";
const char *const OB_ALL_INDEX_WAIT_TRANSACTION_STATUS_TNAME = "__all_index_wait_transaction_status";
const char *const OB_ALL_INDEX_SCHEDULE_TASK_TNAME = "__all_index_schedule_task";
const char *const OB_ALL_INDEX_CHECKSUM_TNAME = "__all_index_checksum";
const char *const OB_ALL_ROUTINE_TNAME = "__all_routine";
const char *const OB_ALL_ROUTINE_HISTORY_TNAME = "__all_routine_history";
const char *const OB_ALL_ROUTINE_PARAM_TNAME = "__all_routine_param";
const char *const OB_ALL_ROUTINE_PARAM_HISTORY_TNAME = "__all_routine_param_history";
const char *const OB_ALL_TABLE_STAT_TNAME = "__all_table_stat";
const char *const OB_ALL_COLUMN_STAT_TNAME = "__all_column_stat";
const char *const OB_ALL_HISTOGRAM_STAT_TNAME = "__all_histogram_stat";
const char *const OB_ALL_PACKAGE_TNAME = "__all_package";
const char *const OB_ALL_PACKAGE_HISTORY_TNAME = "__all_package_history";
const char *const OB_ALL_SQL_EXECUTE_TASK_TNAME = "__all_sql_execute_task";
const char *const OB_ALL_INDEX_BUILD_STAT_TNAME = "__all_index_build_stat";
const char *const OB_ALL_BUILD_INDEX_PARAM_TNAME = "__all_build_index_param";
const char *const OB_ALL_GLOBAL_INDEX_DATA_SRC_TNAME = "__all_global_index_data_src";
const char *const OB_ALL_ACQUIRED_SNAPSHOT_TNAME = "__all_acquired_snapshot";
const char *const OB_ALL_IMMEDIATE_EFFECT_INDEX_SSTABLE_TNAME = "__all_immediate_effect_index_sstable";
const char *const OB_ALL_SSTABLE_CHECKSUM_TNAME = "__all_sstable_checksum";
const char *const OB_ALL_TENANT_GC_PARTITION_INFO_TNAME = "__all_tenant_gc_partition_info";
const char *const OB_ALL_CONSTRAINT_TNAME = "__all_constraint";
const char *const OB_ALL_CONSTRAINT_HISTORY_TNAME = "__all_constraint_history";
const char *const OB_ALL_ORI_SCHEMA_VERSION_TNAME = "__all_ori_schema_version";
const char *const OB_ALL_FUNC_TNAME = "__all_func";
const char *const OB_ALL_FUNC_HISTORY_TNAME = "__all_func_history";
const char *const OB_ALL_TEMP_TABLE_TNAME = "__all_temp_table";
const char *const OB_ALL_SSTABLE_COLUMN_CHECKSUM_TNAME = "__all_sstable_column_checksum";
const char *const OB_ALL_SEQUENCE_OBJECT_TNAME = "__all_sequence_object";
const char *const OB_ALL_SEQUENCE_OBJECT_HISTORY_TNAME = "__all_sequence_object_history";
const char *const OB_ALL_SEQUENCE_VALUE_TNAME = "__all_sequence_value";
const char *const OB_ALL_TENANT_PLAN_BASELINE_TNAME = "__all_tenant_plan_baseline";
const char *const OB_ALL_TENANT_PLAN_BASELINE_HISTORY_TNAME = "__all_tenant_plan_baseline_history";
const char *const OB_ALL_DDL_HELPER_TNAME = "__all_ddl_helper";
const char *const OB_ALL_FREEZE_SCHEMA_VERSION_TNAME = "__all_freeze_schema_version";
const char *const OB_ALL_TYPE_TNAME = "__all_type";
const char *const OB_ALL_TYPE_HISTORY_TNAME = "__all_type_history";
const char *const OB_ALL_TYPE_ATTR_TNAME = "__all_type_attr";
const char *const OB_ALL_TYPE_ATTR_HISTORY_TNAME = "__all_type_attr_history";
const char *const OB_ALL_COLL_TYPE_TNAME = "__all_coll_type";
const char *const OB_ALL_COLL_TYPE_HISTORY_TNAME = "__all_coll_type_history";
const char *const OB_ALL_WEAK_READ_SERVICE_TNAME = "__all_weak_read_service";
const char *const OB_ALL_GTS_TNAME = "__all_gts";
const char *const OB_ALL_TENANT_GTS_TNAME = "__all_tenant_gts";
const char *const OB_ALL_PARTITION_MEMBER_LIST_TNAME = "__all_partition_member_list";
const char *const OB_ALL_DBLINK_TNAME = "__all_dblink";
const char *const OB_ALL_DBLINK_HISTORY_TNAME = "__all_dblink_history";
const char *const OB_ALL_TENANT_PARTITION_META_TABLE_TNAME = "__all_tenant_partition_meta_table";
const char *const OB_ALL_TENANT_ROLE_GRANTEE_MAP_TNAME = "__all_tenant_role_grantee_map";
const char *const OB_ALL_TENANT_ROLE_GRANTEE_MAP_HISTORY_TNAME = "__all_tenant_role_grantee_map_history";
const char *const OB_ALL_TENANT_KEYSTORE_TNAME = "__all_tenant_keystore";
const char *const OB_ALL_TENANT_KEYSTORE_HISTORY_TNAME = "__all_tenant_keystore_history";
const char *const OB_ALL_TENANT_TABLESPACE_TNAME = "__all_tenant_tablespace";
const char *const OB_ALL_TENANT_TABLESPACE_HISTORY_TNAME = "__all_tenant_tablespace_history";
const char *const OB_ALL_TENANT_USER_FAILED_LOGIN_STAT_TNAME = "__all_tenant_user_failed_login_stat";
const char *const OB_ALL_TENANT_PROFILE_TNAME = "__all_tenant_profile";
const char *const OB_ALL_TENANT_PROFILE_HISTORY_TNAME = "__all_tenant_profile_history";
const char *const OB_ALL_TENANT_SECURITY_AUDIT_TNAME = "__all_tenant_security_audit";
const char *const OB_ALL_TENANT_SECURITY_AUDIT_HISTORY_TNAME = "__all_tenant_security_audit_history";
const char *const OB_ALL_TENANT_TRIGGER_TNAME = "__all_tenant_trigger";
const char *const OB_ALL_TENANT_TRIGGER_HISTORY_TNAME = "__all_tenant_trigger_history";
const char *const OB_ALL_SEED_PARAMETER_TNAME = "__all_seed_parameter";
const char *const OB_ALL_TENANT_SSTABLE_COLUMN_CHECKSUM_TNAME = "__all_tenant_sstable_column_checksum";
const char *const OB_ALL_TENANT_SECURITY_AUDIT_RECORD_TNAME = "__all_tenant_security_audit_record";
const char *const OB_ALL_TENANT_SYSAUTH_TNAME = "__all_tenant_sysauth";
const char *const OB_ALL_TENANT_SYSAUTH_HISTORY_TNAME = "__all_tenant_sysauth_history";
const char *const OB_ALL_TENANT_OBJAUTH_TNAME = "__all_tenant_objauth";
const char *const OB_ALL_TENANT_OBJAUTH_HISTORY_TNAME = "__all_tenant_objauth_history";
const char *const OB_ALL_TENANT_BACKUP_INFO_TNAME = "__all_tenant_backup_info";
const char *const OB_ALL_RESTORE_INFO_TNAME = "__all_restore_info";
const char *const OB_ALL_TENANT_BACKUP_LOG_ARCHIVE_STATUS_TNAME = "__all_tenant_backup_log_archive_status";
const char *const OB_ALL_BACKUP_LOG_ARCHIVE_STATUS_HISTORY_TNAME = "__all_backup_log_archive_status_history";
const char *const OB_ALL_TENANT_BACKUP_TASK_TNAME = "__all_tenant_backup_task";
const char *const OB_ALL_BACKUP_TASK_HISTORY_TNAME = "__all_backup_task_history";
const char *const OB_ALL_TENANT_PG_BACKUP_TASK_TNAME = "__all_tenant_pg_backup_task";
const char *const OB_ALL_TENANT_ERROR_TNAME = "__all_tenant_error";
const char *const OB_ALL_SERVER_RECOVERY_STATUS_TNAME = "__all_server_recovery_status";
const char *const OB_ALL_DATAFILE_RECOVERY_STATUS_TNAME = "__all_datafile_recovery_status";
const char *const OB_ALL_TENANT_BACKUP_CLEAN_INFO_TNAME = "__all_tenant_backup_clean_info";
const char *const OB_ALL_BACKUP_CLEAN_INFO_HISTORY_TNAME = "__all_backup_clean_info_history";
const char *const OB_ALL_BACKUP_TASK_CLEAN_HISTORY_TNAME = "__all_backup_task_clean_history";
const char *const OB_ALL_RESTORE_PROGRESS_TNAME = "__all_restore_progress";
const char *const OB_ALL_RESTORE_HISTORY_TNAME = "__all_restore_history";
const char *const OB_ALL_TENANT_RESTORE_PG_INFO_TNAME = "__all_tenant_restore_pg_info";
const char *const OB_ALL_TABLE_V2_HISTORY_TNAME = "__all_table_v2_history";
const char *const OB_ALL_TENANT_OBJECT_TYPE_TNAME = "__all_tenant_object_type";
const char *const OB_ALL_TENANT_OBJECT_TYPE_HISTORY_TNAME = "__all_tenant_object_type_history";
const char *const OB_ALL_BACKUP_VALIDATION_JOB_TNAME = "__all_backup_validation_job";
const char *const OB_ALL_BACKUP_VALIDATION_JOB_HISTORY_TNAME = "__all_backup_validation_job_history";
const char *const OB_ALL_TENANT_BACKUP_VALIDATION_TASK_TNAME = "__all_tenant_backup_validation_task";
const char *const OB_ALL_BACKUP_VALIDATION_TASK_HISTORY_TNAME = "__all_backup_validation_task_history";
const char *const OB_ALL_TENANT_PG_BACKUP_VALIDATION_TASK_TNAME = "__all_tenant_pg_backup_validation_task";
const char *const OB_ALL_TENANT_TIME_ZONE_TNAME = "__all_tenant_time_zone";
const char *const OB_ALL_TENANT_TIME_ZONE_NAME_TNAME = "__all_tenant_time_zone_name";
const char *const OB_ALL_TENANT_TIME_ZONE_TRANSITION_TNAME = "__all_tenant_time_zone_transition";
const char *const OB_ALL_TENANT_TIME_ZONE_TRANSITION_TYPE_TNAME = "__all_tenant_time_zone_transition_type";
const char *const OB_ALL_TENANT_CONSTRAINT_COLUMN_TNAME = "__all_tenant_constraint_column";
const char *const OB_ALL_TENANT_CONSTRAINT_COLUMN_HISTORY_TNAME = "__all_tenant_constraint_column_history";
const char *const OB_ALL_TENANT_GLOBAL_TRANSACTION_TNAME = "__all_tenant_global_transaction";
const char *const OB_ALL_TENANT_DEPENDENCY_TNAME = "__all_tenant_dependency";
const char *const OB_ALL_BACKUP_BACKUPSET_JOB_TNAME = "__all_backup_backupset_job";
const char *const OB_ALL_BACKUP_BACKUPSET_JOB_HISTORY_TNAME = "__all_backup_backupset_job_history";
const char *const OB_ALL_TENANT_BACKUP_BACKUPSET_TASK_TNAME = "__all_tenant_backup_backupset_task";
const char *const OB_ALL_BACKUP_BACKUPSET_TASK_HISTORY_TNAME = "__all_backup_backupset_task_history";
const char *const OB_ALL_TENANT_PG_BACKUP_BACKUPSET_TASK_TNAME = "__all_tenant_pg_backup_backupset_task";
const char *const OB_ALL_TENANT_BACKUP_BACKUP_LOG_ARCHIVE_STATUS_TNAME = "__all_tenant_backup_backup_log_archive_status";
const char *const OB_ALL_BACKUP_BACKUP_LOG_ARCHIVE_STATUS_HISTORY_TNAME = "__all_backup_backup_log_archive_status_history";
const char *const OB_ALL_RES_MGR_PLAN_TNAME = "__all_res_mgr_plan";
const char *const OB_ALL_RES_MGR_DIRECTIVE_TNAME = "__all_res_mgr_directive";
const char *const OB_ALL_RES_MGR_MAPPING_RULE_TNAME = "__all_res_mgr_mapping_rule";
const char *const OB_ALL_RES_MGR_CONSUMER_GROUP_TNAME = "__all_res_mgr_consumer_group";
const char *const OB_TENANT_VIRTUAL_ALL_TABLE_TNAME = "__tenant_virtual_all_table";
const char *const OB_TENANT_VIRTUAL_TABLE_COLUMN_TNAME = "__tenant_virtual_table_column";
const char *const OB_TENANT_VIRTUAL_TABLE_INDEX_TNAME = "__tenant_virtual_table_index";
const char *const OB_TENANT_VIRTUAL_SHOW_CREATE_DATABASE_TNAME = "__tenant_virtual_show_create_database";
const char *const OB_TENANT_VIRTUAL_SHOW_CREATE_TABLE_TNAME = "__tenant_virtual_show_create_table";
const char *const OB_TENANT_VIRTUAL_SESSION_VARIABLE_TNAME = "__tenant_virtual_session_variable";
const char *const OB_TENANT_VIRTUAL_PRIVILEGE_GRANT_TNAME = "__tenant_virtual_privilege_grant";
const char *const OB_ALL_VIRTUAL_PROCESSLIST_TNAME = "__all_virtual_processlist";
const char *const OB_TENANT_VIRTUAL_WARNING_TNAME = "__tenant_virtual_warning";
const char *const OB_TENANT_VIRTUAL_CURRENT_TENANT_TNAME = "__tenant_virtual_current_tenant";
const char *const OB_TENANT_VIRTUAL_DATABASE_STATUS_TNAME = "__tenant_virtual_database_status";
const char *const OB_TENANT_VIRTUAL_TENANT_STATUS_TNAME = "__tenant_virtual_tenant_status";
const char *const OB_TENANT_VIRTUAL_INTERM_RESULT_TNAME = "__tenant_virtual_interm_result";
const char *const OB_TENANT_VIRTUAL_PARTITION_STAT_TNAME = "__tenant_virtual_partition_stat";
const char *const OB_TENANT_VIRTUAL_STATNAME_TNAME = "__tenant_virtual_statname";
const char *const OB_TENANT_VIRTUAL_EVENT_NAME_TNAME = "__tenant_virtual_event_name";
const char *const OB_TENANT_VIRTUAL_GLOBAL_VARIABLE_TNAME = "__tenant_virtual_global_variable";
const char *const OB_TENANT_VIRTUAL_SHOW_TABLES_TNAME = "__tenant_virtual_show_tables";
const char *const OB_TENANT_VIRTUAL_SHOW_CREATE_PROCEDURE_TNAME = "__tenant_virtual_show_create_procedure";
const char *const OB_ALL_VIRTUAL_CORE_META_TABLE_TNAME = "__all_virtual_core_meta_table";
const char *const OB_ALL_VIRTUAL_ZONE_STAT_TNAME = "__all_virtual_zone_stat";
const char *const OB_ALL_VIRTUAL_PLAN_CACHE_STAT_TNAME = "__all_virtual_plan_cache_stat";
const char *const OB_ALL_VIRTUAL_PLAN_STAT_TNAME = "__all_virtual_plan_stat";
const char *const OB_ALL_VIRTUAL_MEM_LEAK_CHECKER_INFO_TNAME = "__all_virtual_mem_leak_checker_info";
const char *const OB_ALL_VIRTUAL_LATCH_TNAME = "__all_virtual_latch";
const char *const OB_ALL_VIRTUAL_KVCACHE_INFO_TNAME = "__all_virtual_kvcache_info";
const char *const OB_ALL_VIRTUAL_DATA_TYPE_CLASS_TNAME = "__all_virtual_data_type_class";
const char *const OB_ALL_VIRTUAL_DATA_TYPE_TNAME = "__all_virtual_data_type";
const char *const OB_ALL_VIRTUAL_SERVER_STAT_TNAME = "__all_virtual_server_stat";
const char *const OB_ALL_VIRTUAL_REBALANCE_TASK_STAT_TNAME = "__all_virtual_rebalance_task_stat";
const char *const OB_ALL_VIRTUAL_SESSION_EVENT_TNAME = "__all_virtual_session_event";
const char *const OB_ALL_VIRTUAL_SESSION_WAIT_TNAME = "__all_virtual_session_wait";
const char *const OB_ALL_VIRTUAL_SESSION_WAIT_HISTORY_TNAME = "__all_virtual_session_wait_history";
const char *const OB_ALL_VIRTUAL_SYSTEM_EVENT_TNAME = "__all_virtual_system_event";
const char *const OB_ALL_VIRTUAL_TENANT_MEMSTORE_INFO_TNAME = "__all_virtual_tenant_memstore_info";
const char *const OB_ALL_VIRTUAL_CONCURRENCY_OBJECT_POOL_TNAME = "__all_virtual_concurrency_object_pool";
const char *const OB_ALL_VIRTUAL_SESSTAT_TNAME = "__all_virtual_sesstat";
const char *const OB_ALL_VIRTUAL_SYSSTAT_TNAME = "__all_virtual_sysstat";
const char *const OB_ALL_VIRTUAL_STORAGE_STAT_TNAME = "__all_virtual_storage_stat";
const char *const OB_ALL_VIRTUAL_DISK_STAT_TNAME = "__all_virtual_disk_stat";
const char *const OB_ALL_VIRTUAL_MEMSTORE_INFO_TNAME = "__all_virtual_memstore_info";
const char *const OB_ALL_VIRTUAL_PARTITION_INFO_TNAME = "__all_virtual_partition_info";
const char *const OB_ALL_VIRTUAL_UPGRADE_INSPECTION_TNAME = "__all_virtual_upgrade_inspection";
const char *const OB_ALL_VIRTUAL_TRANS_STAT_TNAME = "__all_virtual_trans_stat";
const char *const OB_ALL_VIRTUAL_TRANS_MGR_STAT_TNAME = "__all_virtual_trans_mgr_stat";
const char *const OB_ALL_VIRTUAL_ELECTION_INFO_TNAME = "__all_virtual_election_info";
const char *const OB_ALL_VIRTUAL_ELECTION_MEM_STAT_TNAME = "__all_virtual_election_mem_stat";
const char *const OB_ALL_VIRTUAL_SQL_AUDIT_TNAME = "__all_virtual_sql_audit";
const char *const OB_ALL_VIRTUAL_TRANS_MEM_STAT_TNAME = "__all_virtual_trans_mem_stat";
const char *const OB_ALL_VIRTUAL_PARTITION_SSTABLE_IMAGE_INFO_TNAME = "__all_virtual_partition_sstable_image_info";
const char *const OB_ALL_VIRTUAL_CORE_ROOT_TABLE_TNAME = "__all_virtual_core_root_table";
const char *const OB_ALL_VIRTUAL_CORE_ALL_TABLE_TNAME = "__all_virtual_core_all_table";
const char *const OB_ALL_VIRTUAL_CORE_COLUMN_TABLE_TNAME = "__all_virtual_core_column_table";
const char *const OB_ALL_VIRTUAL_MEMORY_INFO_TNAME = "__all_virtual_memory_info";
const char *const OB_ALL_VIRTUAL_TENANT_STAT_TNAME = "__all_virtual_tenant_stat";
const char *const OB_ALL_VIRTUAL_SYS_PARAMETER_STAT_TNAME = "__all_virtual_sys_parameter_stat";
const char *const OB_ALL_VIRTUAL_PARTITION_REPLAY_STATUS_TNAME = "__all_virtual_partition_replay_status";
const char *const OB_ALL_VIRTUAL_CLOG_STAT_TNAME = "__all_virtual_clog_stat";
const char *const OB_ALL_VIRTUAL_TRACE_LOG_TNAME = "__all_virtual_trace_log";
const char *const OB_ALL_VIRTUAL_ENGINE_TNAME = "__all_virtual_engine";
const char *const OB_ALL_VIRTUAL_PROXY_SERVER_STAT_TNAME = "__all_virtual_proxy_server_stat";
const char *const OB_ALL_VIRTUAL_PROXY_SYS_VARIABLE_TNAME = "__all_virtual_proxy_sys_variable";
const char *const OB_ALL_VIRTUAL_PROXY_SCHEMA_TNAME = "__all_virtual_proxy_schema";
const char *const OB_ALL_VIRTUAL_PLAN_CACHE_PLAN_EXPLAIN_TNAME = "__all_virtual_plan_cache_plan_explain";
const char *const OB_ALL_VIRTUAL_OBRPC_STAT_TNAME = "__all_virtual_obrpc_stat";
const char *const OB_ALL_VIRTUAL_PARTITION_SSTABLE_MERGE_INFO_TNAME = "__all_virtual_partition_sstable_merge_info";
const char *const OB_ALL_VIRTUAL_SQL_MONITOR_TNAME = "__all_virtual_sql_monitor";
const char *const OB_TENANT_VIRTUAL_OUTLINE_TNAME = "__tenant_virtual_outline";
const char *const OB_TENANT_VIRTUAL_CONCURRENT_LIMIT_SQL_TNAME = "__tenant_virtual_concurrent_limit_sql";
const char *const OB_ALL_VIRTUAL_SQL_PLAN_STATISTICS_TNAME = "__all_virtual_sql_plan_statistics";
const char *const OB_ALL_VIRTUAL_PARTITION_SSTABLE_MACRO_INFO_TNAME = "__all_virtual_partition_sstable_macro_info";
const char *const OB_ALL_VIRTUAL_PROXY_PARTITION_INFO_TNAME = "__all_virtual_proxy_partition_info";
const char *const OB_ALL_VIRTUAL_PROXY_PARTITION_TNAME = "__all_virtual_proxy_partition";
const char *const OB_ALL_VIRTUAL_PROXY_SUB_PARTITION_TNAME = "__all_virtual_proxy_sub_partition";
const char *const OB_ALL_VIRTUAL_PROXY_ROUTE_TNAME = "__all_virtual_proxy_route";
const char *const OB_ALL_VIRTUAL_REBALANCE_TENANT_STAT_TNAME = "__all_virtual_rebalance_tenant_stat";
const char *const OB_ALL_VIRTUAL_REBALANCE_UNIT_STAT_TNAME = "__all_virtual_rebalance_unit_stat";
const char *const OB_ALL_VIRTUAL_REBALANCE_REPLICA_STAT_TNAME = "__all_virtual_rebalance_replica_stat";
const char *const OB_ALL_VIRTUAL_PARTITION_AMPLIFICATION_STAT_TNAME = "__all_virtual_partition_amplification_stat";
const char *const OB_ALL_VIRTUAL_ELECTION_EVENT_HISTORY_TNAME = "__all_virtual_election_event_history";
const char *const OB_ALL_VIRTUAL_PARTITION_STORE_INFO_TNAME = "__all_virtual_partition_store_info";
const char *const OB_ALL_VIRTUAL_LEADER_STAT_TNAME = "__all_virtual_leader_stat";
const char *const OB_ALL_VIRTUAL_PARTITION_MIGRATION_STATUS_TNAME = "__all_virtual_partition_migration_status";
const char *const OB_ALL_VIRTUAL_SYS_TASK_STATUS_TNAME = "__all_virtual_sys_task_status";
const char *const OB_ALL_VIRTUAL_MACRO_BLOCK_MARKER_STATUS_TNAME = "__all_virtual_macro_block_marker_status";
const char *const OB_ALL_VIRTUAL_SERVER_CLOG_STAT_TNAME = "__all_virtual_server_clog_stat";
const char *const OB_ALL_VIRTUAL_ROOTSERVICE_STAT_TNAME = "__all_virtual_rootservice_stat";
const char *const OB_ALL_VIRTUAL_ELECTION_PRIORITY_TNAME = "__all_virtual_election_priority";
const char *const OB_ALL_VIRTUAL_TENANT_DISK_STAT_TNAME = "__all_virtual_tenant_disk_stat";
const char *const OB_ALL_VIRTUAL_REBALANCE_MAP_STAT_TNAME = "__all_virtual_rebalance_map_stat";
const char *const OB_ALL_VIRTUAL_REBALANCE_MAP_ITEM_STAT_TNAME = "__all_virtual_rebalance_map_item_stat";
const char *const OB_ALL_VIRTUAL_IO_STAT_TNAME = "__all_virtual_io_stat";
const char *const OB_ALL_VIRTUAL_LONG_OPS_STATUS_TNAME = "__all_virtual_long_ops_status";
const char *const OB_ALL_VIRTUAL_REBALANCE_UNIT_MIGRATE_STAT_TNAME = "__all_virtual_rebalance_unit_migrate_stat";
const char *const OB_ALL_VIRTUAL_REBALANCE_UNIT_DISTRIBUTION_STAT_TNAME = "__all_virtual_rebalance_unit_distribution_stat";
const char *const OB_ALL_VIRTUAL_SERVER_OBJECT_POOL_TNAME = "__all_virtual_server_object_pool";
const char *const OB_ALL_VIRTUAL_TRANS_LOCK_STAT_TNAME = "__all_virtual_trans_lock_stat";
const char *const OB_ALL_VIRTUAL_ELECTION_GROUP_INFO_TNAME = "__all_virtual_election_group_info";
const char *const OB_TENANT_VIRTUAL_SHOW_CREATE_TABLEGROUP_TNAME = "__tenant_virtual_show_create_tablegroup";
const char *const OB_ALL_VIRTUAL_SERVER_BLACKLIST_TNAME = "__all_virtual_server_blacklist";
const char *const OB_ALL_VIRTUAL_PARTITION_SPLIT_INFO_TNAME = "__all_virtual_partition_split_info";
const char *const OB_ALL_VIRTUAL_TRANS_RESULT_INFO_STAT_TNAME = "__all_virtual_trans_result_info_stat";
const char *const OB_ALL_VIRTUAL_DUPLICATE_PARTITION_MGR_STAT_TNAME = "__all_virtual_duplicate_partition_mgr_stat";
const char *const OB_ALL_VIRTUAL_TENANT_PARAMETER_STAT_TNAME = "__all_virtual_tenant_parameter_stat";
const char *const OB_ALL_VIRTUAL_SERVER_SCHEMA_INFO_TNAME = "__all_virtual_server_schema_info";
const char *const OB_ALL_VIRTUAL_MEMORY_CONTEXT_STAT_TNAME = "__all_virtual_memory_context_stat";
const char *const OB_ALL_VIRTUAL_DUMP_TENANT_INFO_TNAME = "__all_virtual_dump_tenant_info";
const char *const OB_ALL_VIRTUAL_TENANT_PARAMETER_INFO_TNAME = "__all_virtual_tenant_parameter_info";
const char *const OB_ALL_VIRTUAL_DAG_WARNING_HISTORY_TNAME = "__all_virtual_dag_warning_history";
const char *const OB_SESSION_VARIABLES_TNAME = "SESSION_VARIABLES";
const char *const OB_TABLE_PRIVILEGES_TNAME = "TABLE_PRIVILEGES";
const char *const OB_USER_PRIVILEGES_TNAME = "USER_PRIVILEGES";
const char *const OB_SCHEMA_PRIVILEGES_TNAME = "SCHEMA_PRIVILEGES";
const char *const OB_TABLE_CONSTRAINTS_TNAME = "TABLE_CONSTRAINTS";
const char *const OB_GLOBAL_STATUS_TNAME = "GLOBAL_STATUS";
const char *const OB_PARTITIONS_TNAME = "PARTITIONS";
const char *const OB_SESSION_STATUS_TNAME = "SESSION_STATUS";
const char *const OB_USER_TNAME = "user";
const char *const OB_DB_TNAME = "db";
const char *const OB_ALL_VIRTUAL_SERVER_MEMORY_INFO_TNAME = "__all_virtual_server_memory_info";
const char *const OB_ALL_VIRTUAL_PARTITION_TABLE_TNAME = "__all_virtual_partition_table";
const char *const OB_ALL_VIRTUAL_LOCK_WAIT_STAT_TNAME = "__all_virtual_lock_wait_stat";
const char *const OB_ALL_VIRTUAL_PARTITION_ITEM_TNAME = "__all_virtual_partition_item";
const char *const OB_ALL_VIRTUAL_REPLICA_TASK_TNAME = "__all_virtual_replica_task";
const char *const OB_ALL_VIRTUAL_PARTITION_LOCATION_TNAME = "__all_virtual_partition_location";
const char *const OB_PROC_TNAME = "proc";
const char *const OB_TENANT_VIRTUAL_COLLATION_TNAME = "__tenant_virtual_collation";
const char *const OB_TENANT_VIRTUAL_CHARSET_TNAME = "__tenant_virtual_charset";
const char *const OB_ALL_VIRTUAL_TENANT_MEMSTORE_ALLOCATOR_INFO_TNAME = "__all_virtual_tenant_memstore_allocator_info";
const char *const OB_ALL_VIRTUAL_TABLE_MGR_TNAME = "__all_virtual_table_mgr";
const char *const OB_ALL_VIRTUAL_META_TABLE_TNAME = "__all_virtual_meta_table";
const char *const OB_ALL_VIRTUAL_FREEZE_INFO_TNAME = "__all_virtual_freeze_info";
const char *const OB_PARAMETERS_TNAME = "PARAMETERS";
const char *const OB_ALL_VIRTUAL_BAD_BLOCK_TABLE_TNAME = "__all_virtual_bad_block_table";
const char *const OB_ALL_VIRTUAL_PX_WORKER_STAT_TNAME = "__all_virtual_px_worker_stat";
const char *const OB_ALL_VIRTUAL_TRANS_AUDIT_TNAME = "__all_virtual_trans_audit";
const char *const OB_ALL_VIRTUAL_TRANS_SQL_AUDIT_TNAME = "__all_virtual_trans_sql_audit";
const char *const OB_ALL_VIRTUAL_WEAK_READ_STAT_TNAME = "__all_virtual_weak_read_stat";
const char *const OB_ALL_VIRTUAL_PARTITION_AUDIT_TNAME = "__all_virtual_partition_audit";
const char *const OB_ALL_VIRTUAL_SEQUENCE_V2_TNAME = "__all_virtual_sequence_v2";
const char *const OB_ALL_VIRTUAL_SEQUENCE_VALUE_TNAME = "__all_virtual_sequence_value";
const char *const OB_ALL_VIRTUAL_CLUSTER_TNAME = "__all_virtual_cluster";
const char *const OB_ALL_VIRTUAL_PARTITION_TABLE_STORE_STAT_TNAME = "__all_virtual_partition_table_store_stat";
const char *const OB_ALL_VIRTUAL_DDL_OPERATION_TNAME = "__all_virtual_ddl_operation";
const char *const OB_ALL_VIRTUAL_OUTLINE_TNAME = "__all_virtual_outline";
const char *const OB_ALL_VIRTUAL_OUTLINE_HISTORY_TNAME = "__all_virtual_outline_history";
const char *const OB_ALL_VIRTUAL_SYNONYM_TNAME = "__all_virtual_synonym";
const char *const OB_ALL_VIRTUAL_SYNONYM_HISTORY_TNAME = "__all_virtual_synonym_history";
const char *const OB_ALL_VIRTUAL_DATABASE_PRIVILEGE_TNAME = "__all_virtual_database_privilege";
const char *const OB_ALL_VIRTUAL_DATABASE_PRIVILEGE_HISTORY_TNAME = "__all_virtual_database_privilege_history";
const char *const OB_ALL_VIRTUAL_TABLE_PRIVILEGE_TNAME = "__all_virtual_table_privilege";
const char *const OB_ALL_VIRTUAL_TABLE_PRIVILEGE_HISTORY_TNAME = "__all_virtual_table_privilege_history";
const char *const OB_ALL_VIRTUAL_DATABASE_TNAME = "__all_virtual_database";
const char *const OB_ALL_VIRTUAL_DATABASE_HISTORY_TNAME = "__all_virtual_database_history";
const char *const OB_ALL_VIRTUAL_TABLEGROUP_TNAME = "__all_virtual_tablegroup";
const char *const OB_ALL_VIRTUAL_TABLEGROUP_HISTORY_TNAME = "__all_virtual_tablegroup_history";
const char *const OB_ALL_VIRTUAL_TABLE_TNAME = "__all_virtual_table";
const char *const OB_ALL_VIRTUAL_TABLE_HISTORY_TNAME = "__all_virtual_table_history";
const char *const OB_ALL_VIRTUAL_COLUMN_TNAME = "__all_virtual_column";
const char *const OB_ALL_VIRTUAL_COLUMN_HISTORY_TNAME = "__all_virtual_column_history";
const char *const OB_ALL_VIRTUAL_PART_TNAME = "__all_virtual_part";
const char *const OB_ALL_VIRTUAL_PART_HISTORY_TNAME = "__all_virtual_part_history";
const char *const OB_ALL_VIRTUAL_PART_INFO_TNAME = "__all_virtual_part_info";
const char *const OB_ALL_VIRTUAL_PART_INFO_HISTORY_TNAME = "__all_virtual_part_info_history";
const char *const OB_ALL_VIRTUAL_DEF_SUB_PART_TNAME = "__all_virtual_def_sub_part";
const char *const OB_ALL_VIRTUAL_DEF_SUB_PART_HISTORY_TNAME = "__all_virtual_def_sub_part_history";
const char *const OB_ALL_VIRTUAL_SUB_PART_TNAME = "__all_virtual_sub_part";
const char *const OB_ALL_VIRTUAL_SUB_PART_HISTORY_TNAME = "__all_virtual_sub_part_history";
const char *const OB_ALL_VIRTUAL_CONSTRAINT_TNAME = "__all_virtual_constraint";
const char *const OB_ALL_VIRTUAL_CONSTRAINT_HISTORY_TNAME = "__all_virtual_constraint_history";
const char *const OB_ALL_VIRTUAL_FOREIGN_KEY_TNAME = "__all_virtual_foreign_key";
const char *const OB_ALL_VIRTUAL_FOREIGN_KEY_HISTORY_TNAME = "__all_virtual_foreign_key_history";
const char *const OB_ALL_VIRTUAL_FOREIGN_KEY_COLUMN_TNAME = "__all_virtual_foreign_key_column";
const char *const OB_ALL_VIRTUAL_FOREIGN_KEY_COLUMN_HISTORY_TNAME = "__all_virtual_foreign_key_column_history";
const char *const OB_ALL_VIRTUAL_TEMP_TABLE_TNAME = "__all_virtual_temp_table";
const char *const OB_ALL_VIRTUAL_ORI_SCHEMA_VERSION_TNAME = "__all_virtual_ori_schema_version";
const char *const OB_ALL_VIRTUAL_SYS_STAT_TNAME = "__all_virtual_sys_stat";
const char *const OB_ALL_VIRTUAL_USER_TNAME = "__all_virtual_user";
const char *const OB_ALL_VIRTUAL_USER_HISTORY_TNAME = "__all_virtual_user_history";
const char *const OB_ALL_VIRTUAL_SYS_VARIABLE_TNAME = "__all_virtual_sys_variable";
const char *const OB_ALL_VIRTUAL_SYS_VARIABLE_HISTORY_TNAME = "__all_virtual_sys_variable_history";
const char *const OB_ALL_VIRTUAL_FUNC_TNAME = "__all_virtual_func";
const char *const OB_ALL_VIRTUAL_FUNC_HISTORY_TNAME = "__all_virtual_func_history";
const char *const OB_ALL_VIRTUAL_PACKAGE_TNAME = "__all_virtual_package";
const char *const OB_ALL_VIRTUAL_PACKAGE_HISTORY_TNAME = "__all_virtual_package_history";
const char *const OB_ALL_VIRTUAL_ROUTINE_TNAME = "__all_virtual_routine";
const char *const OB_ALL_VIRTUAL_ROUTINE_HISTORY_TNAME = "__all_virtual_routine_history";
const char *const OB_ALL_VIRTUAL_ROUTINE_PARAM_TNAME = "__all_virtual_routine_param";
const char *const OB_ALL_VIRTUAL_ROUTINE_PARAM_HISTORY_TNAME = "__all_virtual_routine_param_history";
const char *const OB_ALL_VIRTUAL_TYPE_TNAME = "__all_virtual_type";
const char *const OB_ALL_VIRTUAL_TYPE_HISTORY_TNAME = "__all_virtual_type_history";
const char *const OB_ALL_VIRTUAL_TYPE_ATTR_TNAME = "__all_virtual_type_attr";
const char *const OB_ALL_VIRTUAL_TYPE_ATTR_HISTORY_TNAME = "__all_virtual_type_attr_history";
const char *const OB_ALL_VIRTUAL_COLL_TYPE_TNAME = "__all_virtual_coll_type";
const char *const OB_ALL_VIRTUAL_COLL_TYPE_HISTORY_TNAME = "__all_virtual_coll_type_history";
const char *const OB_ALL_VIRTUAL_COLUMN_STAT_TNAME = "__all_virtual_column_stat";
const char *const OB_ALL_VIRTUAL_TABLE_STAT_TNAME = "__all_virtual_table_stat";
const char *const OB_ALL_VIRTUAL_HISTOGRAM_STAT_TNAME = "__all_virtual_histogram_stat";
const char *const OB_ALL_VIRTUAL_COLUMN_STATISTIC_TNAME = "__all_virtual_column_statistic";
const char *const OB_ALL_VIRTUAL_RECYCLEBIN_TNAME = "__all_virtual_recyclebin";
const char *const OB_ALL_VIRTUAL_TENANT_GC_PARTITION_INFO_TNAME = "__all_virtual_tenant_gc_partition_info";
const char *const OB_ALL_VIRTUAL_TENANT_PLAN_BASELINE_TNAME = "__all_virtual_tenant_plan_baseline";
const char *const OB_ALL_VIRTUAL_TENANT_PLAN_BASELINE_HISTORY_TNAME = "__all_virtual_tenant_plan_baseline_history";
const char *const OB_ALL_VIRTUAL_SEQUENCE_OBJECT_TNAME = "__all_virtual_sequence_object";
const char *const OB_ALL_VIRTUAL_SEQUENCE_OBJECT_HISTORY_TNAME = "__all_virtual_sequence_object_history";
const char *const OB_ALL_VIRTUAL_RAID_STAT_TNAME = "__all_virtual_raid_stat";
const char *const OB_ALL_VIRTUAL_SERVER_LOG_META_TNAME = "__all_virtual_server_log_meta";
const char *const OB_ALL_VIRTUAL_DTL_CHANNEL_TNAME = "__all_virtual_dtl_channel";
const char *const OB_ALL_VIRTUAL_DTL_MEMORY_TNAME = "__all_virtual_dtl_memory";
const char *const OB_ALL_VIRTUAL_DTL_FIRST_CACHED_BUFFER_TNAME = "__all_virtual_dtl_first_cached_buffer";
const char *const OB_ALL_VIRTUAL_DBLINK_TNAME = "__all_virtual_dblink";
const char *const OB_ALL_VIRTUAL_DBLINK_HISTORY_TNAME = "__all_virtual_dblink_history";
const char *const OB_ALL_VIRTUAL_TENANT_PARTITION_META_TABLE_TNAME = "__all_virtual_tenant_partition_meta_table";
const char *const OB_ALL_VIRTUAL_TENANT_ROLE_GRANTEE_MAP_TNAME = "__all_virtual_tenant_role_grantee_map";
const char *const OB_ALL_VIRTUAL_TENANT_ROLE_GRANTEE_MAP_HISTORY_TNAME = "__all_virtual_tenant_role_grantee_map_history";
const char *const OB_ALL_VIRTUAL_TENANT_KEYSTORE_TNAME = "__all_virtual_tenant_keystore";
const char *const OB_ALL_VIRTUAL_TENANT_KEYSTORE_HISTORY_TNAME = "__all_virtual_tenant_keystore_history";
const char *const OB_ALL_VIRTUAL_DEADLOCK_STAT_TNAME = "__all_virtual_deadlock_stat";
const char *const OB_ALL_VIRTUAL_TENANT_TABLESPACE_TNAME = "__all_virtual_tenant_tablespace";
const char *const OB_ALL_VIRTUAL_TENANT_TABLESPACE_HISTORY_TNAME = "__all_virtual_tenant_tablespace_history";
const char *const OB_ALL_VIRTUAL_INFORMATION_COLUMNS_TNAME = "__ALL_VIRTUAL_INFORMATION_COLUMNS";
const char *const OB_ALL_VIRTUAL_PG_PARTITION_INFO_TNAME = "__all_virtual_pg_partition_info";
const char *const OB_ALL_VIRTUAL_TENANT_USER_FAILED_LOGIN_STAT_TNAME = "__all_virtual_tenant_user_failed_login_stat";
const char *const OB_ALL_VIRTUAL_TENANT_PROFILE_TNAME = "__all_virtual_tenant_profile";
const char *const OB_ALL_VIRTUAL_TENANT_PROFILE_HISTORY_TNAME = "__all_virtual_tenant_profile_history";
const char *const OB_ALL_VIRTUAL_SECURITY_AUDIT_TNAME = "__all_virtual_security_audit";
const char *const OB_ALL_VIRTUAL_SECURITY_AUDIT_HISTORY_TNAME = "__all_virtual_security_audit_history";
const char *const OB_ALL_VIRTUAL_TRIGGER_TNAME = "__all_virtual_trigger";
const char *const OB_ALL_VIRTUAL_TRIGGER_HISTORY_TNAME = "__all_virtual_trigger_history";
const char *const OB_ALL_VIRTUAL_CLUSTER_STATS_TNAME = "__all_virtual_cluster_stats";
const char *const OB_ALL_VIRTUAL_SSTABLE_COLUMN_CHECKSUM_TNAME = "__all_virtual_sstable_column_checksum";
const char *const OB_ALL_VIRTUAL_PS_STAT_TNAME = "__all_virtual_ps_stat";
const char *const OB_ALL_VIRTUAL_PS_ITEM_INFO_TNAME = "__all_virtual_ps_item_info";
const char *const OB_ALL_VIRTUAL_SQL_WORKAREA_HISTORY_STAT_TNAME = "__all_virtual_sql_workarea_history_stat";
const char *const OB_ALL_VIRTUAL_SQL_WORKAREA_ACTIVE_TNAME = "__all_virtual_sql_workarea_active";
const char *const OB_ALL_VIRTUAL_SQL_WORKAREA_HISTOGRAM_TNAME = "__all_virtual_sql_workarea_histogram";
const char *const OB_ALL_VIRTUAL_SQL_WORKAREA_MEMORY_INFO_TNAME = "__all_virtual_sql_workarea_memory_info";
const char *const OB_ALL_VIRTUAL_SECURITY_AUDIT_RECORD_TNAME = "__all_virtual_security_audit_record";
const char *const OB_ALL_VIRTUAL_SYSAUTH_TNAME = "__all_virtual_sysauth";
const char *const OB_ALL_VIRTUAL_SYSAUTH_HISTORY_TNAME = "__all_virtual_sysauth_history";
const char *const OB_ALL_VIRTUAL_OBJAUTH_TNAME = "__all_virtual_objauth";
const char *const OB_ALL_VIRTUAL_OBJAUTH_HISTORY_TNAME = "__all_virtual_objauth_history";
const char *const OB_ALL_VIRTUAL_BACKUP_INFO_TNAME = "__all_virtual_backup_info";
const char *const OB_ALL_VIRTUAL_BACKUP_LOG_ARCHIVE_STATUS_TNAME = "__all_virtual_backup_log_archive_status";
const char *const OB_ALL_VIRTUAL_BACKUP_TASK_TNAME = "__all_virtual_backup_task";
const char *const OB_ALL_VIRTUAL_PG_BACKUP_TASK_TNAME = "__all_virtual_pg_backup_task";
const char *const OB_ALL_VIRTUAL_PG_BACKUP_LOG_ARCHIVE_STATUS_TNAME = "__all_virtual_pg_backup_log_archive_status";
const char *const OB_ALL_VIRTUAL_SERVER_BACKUP_LOG_ARCHIVE_STATUS_TNAME = "__all_virtual_server_backup_log_archive_status";
const char *const OB_ALL_VIRTUAL_ERROR_TNAME = "__all_virtual_error";
const char *const OB_ALL_VIRTUAL_TIMESTAMP_SERVICE_TNAME = "__all_virtual_timestamp_service";
const char *const OB_REFERENTIAL_CONSTRAINTS_TNAME = "REFERENTIAL_CONSTRAINTS";
const char *const OB_ALL_VIRTUAL_TABLE_MODIFICATIONS_TNAME = "__all_virtual_table_modifications";
const char *const OB_ALL_VIRTUAL_BACKUP_CLEAN_INFO_TNAME = "__all_virtual_backup_clean_info";
const char *const OB_ALL_VIRTUAL_RESTORE_PG_INFO_TNAME = "__all_virtual_restore_pg_info";
const char *const OB_ALL_VIRTUAL_OBJECT_TYPE_TNAME = "__all_virtual_object_type";
const char *const OB_ALL_VIRTUAL_TRANS_TABLE_STATUS_TNAME = "__all_virtual_trans_table_status";
const char *const OB_ALL_VIRTUAL_PG_LOG_ARCHIVE_STAT_TNAME = "__all_virtual_pg_log_archive_stat";
const char *const OB_ALL_VIRTUAL_SQL_PLAN_MONITOR_TNAME = "__all_virtual_sql_plan_monitor";
const char *const OB_ALL_VIRTUAL_SQL_MONITOR_STATNAME_TNAME = "__all_virtual_sql_monitor_statname";
const char *const OB_ALL_VIRTUAL_OPEN_CURSOR_TNAME = "__all_virtual_open_cursor";
const char *const OB_ALL_VIRTUAL_BACKUP_VALIDATION_TASK_TNAME = "__all_virtual_backup_validation_task";
const char *const OB_ALL_VIRTUAL_PG_BACKUP_VALIDATION_TASK_TNAME = "__all_virtual_pg_backup_validation_task";
const char *const OB_ALL_VIRTUAL_TIME_ZONE_TNAME = "__all_virtual_time_zone";
const char *const OB_ALL_VIRTUAL_TIME_ZONE_NAME_TNAME = "__all_virtual_time_zone_name";
const char *const OB_ALL_VIRTUAL_TIME_ZONE_TRANSITION_TNAME = "__all_virtual_time_zone_transition";
const char *const OB_ALL_VIRTUAL_TIME_ZONE_TRANSITION_TYPE_TNAME = "__all_virtual_time_zone_transition_type";
const char *const OB_ALL_VIRTUAL_CONSTRAINT_COLUMN_TNAME = "__all_virtual_constraint_column";
const char *const OB_ALL_VIRTUAL_CONSTRAINT_COLUMN_HISTORY_TNAME = "__all_virtual_constraint_column_history";
const char *const OB_ALL_VIRTUAL_FILES_TNAME = "__all_virtual_files";
const char *const OB_FILES_TNAME = "FILES";
const char *const OB_ALL_VIRTUAL_DEPENDENCY_TNAME = "__all_virtual_dependency";
const char *const OB_TENANT_VIRTUAL_OBJECT_DEFINITION_TNAME = "__tenant_virtual_object_definition";
const char *const OB_ALL_VIRTUAL_RESERVED_TABLE_MGR_TNAME = "__all_virtual_reserved_table_mgr";
const char *const OB_ALL_VIRTUAL_BACKUPSET_HISTORY_MGR_TNAME = "__all_virtual_backupset_history_mgr";
const char *const OB_ALL_VIRTUAL_BACKUP_BACKUPSET_TASK_TNAME = "__all_virtual_backup_backupset_task";
const char *const OB_ALL_VIRTUAL_PG_BACKUP_BACKUPSET_TASK_TNAME = "__all_virtual_pg_backup_backupset_task";
const char *const OB_ALL_VIRTUAL_BACKUP_BACKUP_LOG_ARCHIVE_STATUS_TNAME = "__all_virtual_backup_backup_log_archive_status";
const char *const OB_ALL_VIRTUAL_GLOBAL_TRANSACTION_TNAME = "__all_virtual_global_transaction";
const char *const OB_ALL_VIRTUAL_TABLE_AGENT_TNAME = "ALL_VIRTUAL_TABLE_AGENT";
const char *const OB_ALL_VIRTUAL_COLUMN_AGENT_TNAME = "ALL_VIRTUAL_COLUMN_AGENT";
const char *const OB_ALL_VIRTUAL_DATABASE_AGENT_TNAME = "ALL_VIRTUAL_DATABASE_AGENT";
const char *const OB_ALL_VIRTUAL_SEQUENCE_V2_AGENT_TNAME = "ALL_VIRTUAL_SEQUENCE_V2_AGENT";
const char *const OB_ALL_VIRTUAL_PART_AGENT_TNAME = "ALL_VIRTUAL_PART_AGENT";
const char *const OB_ALL_VIRTUAL_SUB_PART_AGENT_TNAME = "ALL_VIRTUAL_SUB_PART_AGENT";
const char *const OB_ALL_VIRTUAL_PACKAGE_AGENT_TNAME = "ALL_VIRTUAL_PACKAGE_AGENT";
const char *const OB_ALL_VIRTUAL_TENANT_META_TABLE_AGENT_TNAME = "ALL_VIRTUAL_TENANT_META_TABLE_AGENT";
const char *const OB_ALL_VIRTUAL_SQL_AUDIT_ORA_TNAME = "ALL_VIRTUAL_SQL_AUDIT";
const char *const OB_ALL_VIRTUAL_PLAN_STAT_ORA_TNAME = "ALL_VIRTUAL_PLAN_STAT";
const char *const OB_ALL_VIRTUAL_SQL_PLAN_STATISTICS_AGENT_TNAME = "ALL_VIRTUAL_SQL_PLAN_STATISTICS_AGENT";
const char *const OB_ALL_VIRTUAL_PLAN_CACHE_PLAN_EXPLAIN_ORA_TNAME = "ALL_VIRTUAL_PLAN_CACHE_PLAN_EXPLAIN";
const char *const OB_ALL_VIRTUAL_SEQUENCE_VALUE_AGENT_TNAME = "ALL_VIRTUAL_SEQUENCE_VALUE_AGENT";
const char *const OB_ALL_VIRTUAL_SEQUENCE_OBJECT_AGENT_TNAME = "ALL_VIRTUAL_SEQUENCE_OBJECT_AGENT";
const char *const OB_ALL_VIRTUAL_USER_AGENT_TNAME = "ALL_VIRTUAL_USER_AGENT";
const char *const OB_ALL_VIRTUAL_SYNONYM_AGENT_TNAME = "ALL_VIRTUAL_SYNONYM_AGENT";
const char *const OB_ALL_VIRTUAL_FOREIGN_KEY_AGENT_TNAME = "ALL_VIRTUAL_FOREIGN_KEY_AGENT";
const char *const OB_ALL_VIRTUAL_COLUMN_STAT_AGENT_TNAME = "ALL_VIRTUAL_COLUMN_STAT_AGENT";
const char *const OB_ALL_VIRTUAL_COLUMN_STATISTIC_AGENT_TNAME = "ALL_VIRTUAL_COLUMN_STATISTIC_AGENT";
const char *const OB_ALL_VIRTUAL_PARTITION_TABLE_AGENT_TNAME = "ALL_VIRTUAL_PARTITION_TABLE_AGENT";
const char *const OB_ALL_VIRTUAL_TABLE_STAT_AGENT_TNAME = "ALL_VIRTUAL_TABLE_STAT_AGENT";
const char *const OB_ALL_VIRTUAL_RECYCLEBIN_AGENT_TNAME = "ALL_VIRTUAL_RECYCLEBIN_AGENT";
const char *const OB_TENANT_VIRTUAL_OUTLINE_AGENT_TNAME = "TENANT_VIRTUAL_OUTLINE_AGENT";
const char *const OB_ALL_VIRTUAL_ROUTINE_AGENT_TNAME = "ALL_VIRTUAL_ROUTINE_AGENT";
const char *const OB_ALL_VIRTUAL_TABLEGROUP_AGENT_TNAME = "ALL_VIRTUAL_TABLEGROUP_AGENT";
const char *const OB_ALL_VIRTUAL_PRIVILEGE_AGENT_TNAME = "ALL_VIRTUAL_PRIVILEGE_AGENT";
const char *const OB_ALL_VIRTUAL_SYS_PARAMETER_STAT_AGENT_TNAME = "ALL_VIRTUAL_SYS_PARAMETER_STAT_AGENT";
const char *const OB_TENANT_VIRTUAL_TABLE_INDEX_AGENT_TNAME = "TENANT_VIRTUAL_TABLE_INDEX_AGENT";
const char *const OB_TENANT_VIRTUAL_CHARSET_AGENT_TNAME = "TENANT_VIRTUAL_CHARSET_AGENT";
const char *const OB_TENANT_VIRTUAL_ALL_TABLE_AGENT_TNAME = "TENANT_VIRTUAL_ALL_TABLE_AGENT";
const char *const OB_TENANT_VIRTUAL_COLLATION_AGENT_TNAME = "TENANT_VIRTUAL_COLLATION_AGENT";
const char *const OB_ALL_VIRTUAL_FOREIGN_KEY_COLUMN_AGENT_TNAME = "ALL_VIRTUAL_FOREIGN_KEY_COLUMN_AGENT";
const char *const OB_ALL_VIRTUAL_SERVER_AGENT_TNAME = "ALL_VIRTUAL_SERVER_AGENT";
const char *const OB_ALL_VIRTUAL_PLAN_CACHE_STAT_ORA_TNAME = "ALL_VIRTUAL_PLAN_CACHE_STAT";
const char *const OB_ALL_VIRTUAL_PROCESSLIST_ORA_TNAME = "ALL_VIRTUAL_PROCESSLIST";
const char *const OB_ALL_VIRTUAL_SESSION_WAIT_ORA_TNAME = "ALL_VIRTUAL_SESSION_WAIT";
const char *const OB_ALL_VIRTUAL_SESSION_WAIT_HISTORY_ORA_TNAME = "ALL_VIRTUAL_SESSION_WAIT_HISTORY";
const char *const OB_ALL_VIRTUAL_MEMORY_INFO_ORA_TNAME = "ALL_VIRTUAL_MEMORY_INFO";
const char *const OB_ALL_VIRTUAL_TENANT_MEMSTORE_INFO_ORA_TNAME = "ALL_VIRTUAL_TENANT_MEMSTORE_INFO";
const char *const OB_ALL_VIRTUAL_MEMSTORE_INFO_ORA_TNAME = "ALL_VIRTUAL_MEMSTORE_INFO";
const char *const OB_ALL_VIRTUAL_SERVER_MEMORY_INFO_AGENT_TNAME = "ALL_VIRTUAL_SERVER_MEMORY_INFO_AGENT";
const char *const OB_ALL_VIRTUAL_SESSTAT_ORA_TNAME = "ALL_VIRTUAL_SESSTAT";
const char *const OB_ALL_VIRTUAL_SYSSTAT_ORA_TNAME = "ALL_VIRTUAL_SYSSTAT";
const char *const OB_ALL_VIRTUAL_SYSTEM_EVENT_ORA_TNAME = "ALL_VIRTUAL_SYSTEM_EVENT";
const char *const OB_ALL_VIRTUAL_TENANT_MEMSTORE_ALLOCATOR_INFO_AGENT_TNAME = "ALL_VIRTUAL_TENANT_MEMSTORE_ALLOCATOR_INFO_AGENT";
const char *const OB_TENANT_VIRTUAL_SESSION_VARIABLE_ORA_TNAME = "TENANT_VIRTUAL_SESSION_VARIABLE";
const char *const OB_TENANT_VIRTUAL_GLOBAL_VARIABLE_ORA_TNAME = "TENANT_VIRTUAL_GLOBAL_VARIABLE";
const char *const OB_TENANT_VIRTUAL_SHOW_CREATE_TABLE_ORA_TNAME = "TENANT_VIRTUAL_SHOW_CREATE_TABLE";
const char *const OB_TENANT_VIRTUAL_SHOW_CREATE_PROCEDURE_ORA_TNAME = "TENANT_VIRTUAL_SHOW_CREATE_PROCEDURE";
const char *const OB_TENANT_VIRTUAL_SHOW_CREATE_TABLEGROUP_ORA_TNAME = "TENANT_VIRTUAL_SHOW_CREATE_TABLEGROUP";
const char *const OB_TENANT_VIRTUAL_PRIVILEGE_GRANT_ORA_TNAME = "TENANT_VIRTUAL_PRIVILEGE_GRANT";
const char *const OB_TENANT_VIRTUAL_TABLE_COLUMN_ORA_TNAME = "TENANT_VIRTUAL_TABLE_COLUMN";
const char *const OB_ALL_VIRTUAL_TRACE_LOG_ORA_TNAME = "ALL_VIRTUAL_TRACE_LOG";
const char *const OB_TENANT_VIRTUAL_CONCURRENT_LIMIT_SQL_AGENT_TNAME = "TENANT_VIRTUAL_CONCURRENT_LIMIT_SQL_AGENT";
const char *const OB_ALL_VIRTUAL_CONSTRAINT_AGENT_TNAME = "ALL_VIRTUAL_CONSTRAINT_AGENT";
const char *const OB_ALL_VIRTUAL_TYPE_AGENT_TNAME = "ALL_VIRTUAL_TYPE_AGENT";
const char *const OB_ALL_VIRTUAL_TYPE_ATTR_AGENT_TNAME = "ALL_VIRTUAL_TYPE_ATTR_AGENT";
const char *const OB_ALL_VIRTUAL_COLL_TYPE_AGENT_TNAME = "ALL_VIRTUAL_COLL_TYPE_AGENT";
const char *const OB_ALL_VIRTUAL_ROUTINE_PARAM_AGENT_TNAME = "ALL_VIRTUAL_ROUTINE_PARAM_AGENT";
const char *const OB_ALL_VIRTUAL_DATA_TYPE_ORA_TNAME = "ALL_VIRTUAL_DATA_TYPE";
const char *const OB_ALL_VIRTUAL_TABLE_SYS_AGENT_TNAME = "ALL_VIRTUAL_TABLE_SYS_AGENT";
const char *const OB_ALL_VIRTUAL_SSTABLE_CHECKSUM_AGENT_TNAME = "ALL_VIRTUAL_SSTABLE_CHECKSUM_AGENT";
const char *const OB_ALL_VIRTUAL_PARTITION_INFO_AGENT_TNAME = "ALL_VIRTUAL_PARTITION_INFO_AGENT";
const char *const OB_ALL_VIRTUAL_TENANT_PARTITION_META_TABLE_AGENT_TNAME = "ALL_VIRTUAL_TENANT_PARTITION_META_TABLE_AGENT";
const char *const OB_ALL_VIRTUAL_TENANT_KEYSTORE_AGENT_TNAME = "ALL_VIRTUAL_TENANT_KEYSTORE_AGENT";
const char *const OB_ALL_VIRTUAL_TENANT_TABLESPACE_AGENT_TNAME = "ALL_VIRTUAL_TENANT_TABLESPACE_AGENT";
const char *const OB_ALL_VIRTUAL_TENANT_PROFILE_AGENT_TNAME = "ALL_VIRTUAL_TENANT_PROFILE_AGENT";
const char *const OB_ALL_VIRTUAL_TENANT_ROLE_GRANTEE_MAP_AGENT_TNAME = "ALL_VIRTUAL_TENANT_ROLE_GRANTEE_MAP_AGENT";
const char *const OB_ALL_VIRTUAL_TABLE_PRIVILEGE_AGENT_TNAME = "ALL_VIRTUAL_TABLE_PRIVILEGE_AGENT";
const char *const OB_ALL_VIRTUAL_SECURITY_AUDIT_AGENT_TNAME = "ALL_VIRTUAL_SECURITY_AUDIT_AGENT";
const char *const OB_ALL_VIRTUAL_SECURITY_AUDIT_HISTORY_AGENT_TNAME = "ALL_VIRTUAL_SECURITY_AUDIT_HISTORY_AGENT";
const char *const OB_ALL_VIRTUAL_TRIGGER_AGENT_TNAME = "ALL_VIRTUAL_TRIGGER_AGENT";
const char *const OB_ALL_VIRTUAL_PX_WORKER_STAT_ORA_TNAME = "ALL_VIRTUAL_PX_WORKER_STAT";
const char *const OB_ALL_VIRTUAL_PS_STAT_ORA_TNAME = "ALL_VIRTUAL_PS_STAT";
const char *const OB_ALL_VIRTUAL_PS_ITEM_INFO_ORA_TNAME = "ALL_VIRTUAL_PS_ITEM_INFO";
const char *const OB_ALL_VIRTUAL_TENANT_PARAMETER_STAT_ORA_TNAME = "ALL_VIRTUAL_TENANT_PARAMETER_STAT";
const char *const OB_ALL_VIRTUAL_SQL_WORKAREA_HISTORY_STAT_AGENT_TNAME = "ALL_VIRTUAL_SQL_WORKAREA_HISTORY_STAT_AGENT";
const char *const OB_ALL_VIRTUAL_SQL_WORKAREA_ACTIVE_AGENT_TNAME = "ALL_VIRTUAL_SQL_WORKAREA_ACTIVE_AGENT";
const char *const OB_ALL_VIRTUAL_SQL_WORKAREA_HISTOGRAM_AGENT_TNAME = "ALL_VIRTUAL_SQL_WORKAREA_HISTOGRAM_AGENT";
const char *const OB_ALL_VIRTUAL_SQL_WORKAREA_MEMORY_INFO_AGENT_TNAME = "ALL_VIRTUAL_SQL_WORKAREA_MEMORY_INFO_AGENT";
const char *const OB_ALL_VIRTUAL_SECURITY_AUDIT_RECORD_AGENT_TNAME = "ALL_VIRTUAL_SECURITY_AUDIT_RECORD_AGENT";
const char *const OB_ALL_VIRTUAL_SYSAUTH_AGENT_TNAME = "ALL_VIRTUAL_SYSAUTH_AGENT";
const char *const OB_ALL_VIRTUAL_SYSAUTH_HISTORY_AGENT_TNAME = "ALL_VIRTUAL_SYSAUTH_HISTORY_AGENT";
const char *const OB_ALL_VIRTUAL_OBJAUTH_AGENT_TNAME = "ALL_VIRTUAL_OBJAUTH_AGENT";
const char *const OB_ALL_VIRTUAL_OBJAUTH_HISTORY_AGENT_TNAME = "ALL_VIRTUAL_OBJAUTH_HISTORY_AGENT";
const char *const OB_ALL_VIRTUAL_ERROR_AGENT_TNAME = "ALL_VIRTUAL_ERROR_AGENT";
const char *const OB_ALL_VIRTUAL_TABLE_MGR_AGENT_TNAME = "ALL_VIRTUAL_TABLE_MGR_AGENT";
const char *const OB_ALL_VIRTUAL_DEF_SUB_PART_AGENT_TNAME = "ALL_VIRTUAL_DEF_SUB_PART_AGENT";
const char *const OB_ALL_VIRTUAL_OBJECT_TYPE_AGENT_TNAME = "ALL_VIRTUAL_OBJECT_TYPE_AGENT";
const char *const OB_ALL_VIRTUAL_SERVER_SCHEMA_INFO_AGENT_TNAME = "ALL_VIRTUAL_SERVER_SCHEMA_INFO_AGENT";
const char *const OB_ALL_VIRTUAL_DBLINK_AGENT_TNAME = "ALL_VIRTUAL_DBLINK_AGENT";
const char *const OB_ALL_VIRTUAL_DBLINK_HISTORY_AGENT_TNAME = "ALL_VIRTUAL_DBLINK_HISTORY_AGENT";
const char *const OB_ALL_VIRTUAL_SQL_PLAN_MONITOR_ORA_TNAME = "ALL_VIRTUAL_SQL_PLAN_MONITOR";
const char *const OB_ALL_VIRTUAL_SQL_MONITOR_STATNAME_ORA_TNAME = "ALL_VIRTUAL_SQL_MONITOR_STATNAME";
const char *const OB_ALL_VIRTUAL_LOCK_WAIT_STAT_ORA_TNAME = "ALL_VIRTUAL_LOCK_WAIT_STAT";
const char *const OB_ALL_VIRTUAL_OPEN_CURSOR_ORA_TNAME = "ALL_VIRTUAL_OPEN_CURSOR";
const char *const OB_ALL_VIRTUAL_CONSTRAINT_COLUMN_AGENT_TNAME = "ALL_VIRTUAL_CONSTRAINT_COLUMN_AGENT";
const char *const OB_ALL_VIRTUAL_DEPENDENCY_AGENT_TNAME = "ALL_VIRTUAL_DEPENDENCY_AGENT";
const char *const OB_ALL_VIRTUAL_TENANT_TIME_ZONE_AGENT_TNAME = "ALL_VIRTUAL_TENANT_TIME_ZONE_AGENT";
const char *const OB_ALL_VIRTUAL_TENANT_TIME_ZONE_NAME_AGENT_TNAME = "ALL_VIRTUAL_TENANT_TIME_ZONE_NAME_AGENT";
const char *const OB_ALL_VIRTUAL_TENANT_TIME_ZONE_TRANSITION_AGENT_TNAME = "ALL_VIRTUAL_TENANT_TIME_ZONE_TRANSITION_AGENT";
const char *const OB_ALL_VIRTUAL_TENANT_TIME_ZONE_TRANSITION_TYPE_AGENT_TNAME = "ALL_VIRTUAL_TENANT_TIME_ZONE_TRANSITION_TYPE_AGENT";
const char *const OB_TENANT_VIRTUAL_OBJECT_DEFINITION_ORA_TNAME = "TENANT_VIRTUAL_OBJECT_DEFINITION";
const char *const OB_ALL_VIRTUAL_ROUTINE_PARAM_SYS_AGENT_TNAME = "ALL_VIRTUAL_ROUTINE_PARAM_SYS_AGENT";
const char *const OB_ALL_VIRTUAL_TYPE_SYS_AGENT_TNAME = "ALL_VIRTUAL_TYPE_SYS_AGENT";
const char *const OB_ALL_VIRTUAL_TYPE_ATTR_SYS_AGENT_TNAME = "ALL_VIRTUAL_TYPE_ATTR_SYS_AGENT";
const char *const OB_ALL_VIRTUAL_COLL_TYPE_SYS_AGENT_TNAME = "ALL_VIRTUAL_COLL_TYPE_SYS_AGENT";
const char *const OB_ALL_VIRTUAL_PACKAGE_SYS_AGENT_TNAME = "ALL_VIRTUAL_PACKAGE_SYS_AGENT";
const char *const OB_ALL_VIRTUAL_TENANT_TRIGGER_SYS_AGENT_TNAME = "ALL_VIRTUAL_TENANT_TRIGGER_SYS_AGENT";
const char *const OB_ALL_VIRTUAL_ROUTINE_SYS_AGENT_TNAME = "ALL_VIRTUAL_ROUTINE_SYS_AGENT";
const char *const OB_ALL_VIRTUAL_TENANT_GLOBAL_TRANSACTION_AGENT_TNAME = "ALL_VIRTUAL_TENANT_GLOBAL_TRANSACTION_AGENT";
const char *const OB_ALL_VIRTUAL_ACQUIRED_SNAPSHOT_AGENT_TNAME = "ALL_VIRTUAL_ACQUIRED_SNAPSHOT_AGENT";
const char *const OB_ALL_VIRTUAL_TABLE_REAL_AGENT_ORA_TNAME = "ALL_VIRTUAL_TABLE_REAL_AGENT";
const char *const OB_ALL_VIRTUAL_COLUMN_REAL_AGENT_ORA_TNAME = "ALL_VIRTUAL_COLUMN_REAL_AGENT";
const char *const OB_ALL_VIRTUAL_DATABASE_REAL_AGENT_ORA_TNAME = "ALL_VIRTUAL_DATABASE_REAL_AGENT";
const char *const OB_ALL_VIRTUAL_SEQUENCE_V2_REAL_AGENT_ORA_TNAME = "ALL_VIRTUAL_SEQUENCE_V2_REAL_AGENT";
const char *const OB_ALL_VIRTUAL_PART_REAL_AGENT_ORA_TNAME = "ALL_VIRTUAL_PART_REAL_AGENT";
const char *const OB_ALL_VIRTUAL_SUB_PART_REAL_AGENT_ORA_TNAME = "ALL_VIRTUAL_SUB_PART_REAL_AGENT";
const char *const OB_ALL_VIRTUAL_PACKAGE_REAL_AGENT_ORA_TNAME = "ALL_VIRTUAL_PACKAGE_REAL_AGENT";
const char *const OB_ALL_VIRTUAL_SEQUENCE_VALUE_REAL_AGENT_ORA_TNAME = "ALL_VIRTUAL_SEQUENCE_VALUE_REAL_AGENT";
const char *const OB_ALL_VIRTUAL_SEQUENCE_OBJECT_REAL_AGENT_ORA_TNAME = "ALL_VIRTUAL_SEQUENCE_OBJECT_REAL_AGENT";
const char *const OB_ALL_VIRTUAL_USER_REAL_AGENT_ORA_TNAME = "ALL_VIRTUAL_USER_REAL_AGENT";
const char *const OB_ALL_VIRTUAL_SYNONYM_REAL_AGENT_ORA_TNAME = "ALL_VIRTUAL_SYNONYM_REAL_AGENT";
const char *const OB_ALL_VIRTUAL_FOREIGN_KEY_REAL_AGENT_ORA_TNAME = "ALL_VIRTUAL_FOREIGN_KEY_REAL_AGENT";
const char *const OB_ALL_VIRTUAL_COLUMN_STAT_REAL_AGENT_ORA_TNAME = "ALL_VIRTUAL_COLUMN_STAT_REAL_AGENT";
const char *const OB_ALL_VIRTUAL_COLUMN_STATISTIC_REAL_AGENT_ORA_TNAME = "ALL_VIRTUAL_COLUMN_STATISTIC_REAL_AGENT";
const char *const OB_ALL_VIRTUAL_TABLE_STAT_REAL_AGENT_ORA_TNAME = "ALL_VIRTUAL_TABLE_STAT_REAL_AGENT";
const char *const OB_ALL_VIRTUAL_RECYCLEBIN_REAL_AGENT_ORA_TNAME = "ALL_VIRTUAL_RECYCLEBIN_REAL_AGENT";
const char *const OB_ALL_VIRTUAL_ROUTINE_REAL_AGENT_ORA_TNAME = "ALL_VIRTUAL_ROUTINE_REAL_AGENT";
const char *const OB_ALL_VIRTUAL_TABLEGROUP_REAL_AGENT_ORA_TNAME = "ALL_VIRTUAL_TABLEGROUP_REAL_AGENT";
const char *const OB_ALL_VIRTUAL_FOREIGN_KEY_COLUMN_REAL_AGENT_ORA_TNAME = "ALL_VIRTUAL_FOREIGN_KEY_COLUMN_REAL_AGENT";
const char *const OB_ALL_VIRTUAL_CONSTRAINT_REAL_AGENT_ORA_TNAME = "ALL_VIRTUAL_CONSTRAINT_REAL_AGENT";
const char *const OB_ALL_VIRTUAL_TYPE_REAL_AGENT_ORA_TNAME = "ALL_VIRTUAL_TYPE_REAL_AGENT";
const char *const OB_ALL_VIRTUAL_TYPE_ATTR_REAL_AGENT_ORA_TNAME = "ALL_VIRTUAL_TYPE_ATTR_REAL_AGENT";
const char *const OB_ALL_VIRTUAL_COLL_TYPE_REAL_AGENT_ORA_TNAME = "ALL_VIRTUAL_COLL_TYPE_REAL_AGENT";
const char *const OB_ALL_VIRTUAL_ROUTINE_PARAM_REAL_AGENT_ORA_TNAME = "ALL_VIRTUAL_ROUTINE_PARAM_REAL_AGENT";
const char *const OB_ALL_VIRTUAL_TENANT_PARTITION_META_TABLE_REAL_AGENT_ORA_TNAME = "ALL_VIRTUAL_TENANT_PARTITION_META_TABLE_REAL_AGENT";
const char *const OB_ALL_VIRTUAL_TENANT_KEYSTORE_REAL_AGENT_ORA_TNAME = "ALL_VIRTUAL_TENANT_KEYSTORE_REAL_AGENT";
const char *const OB_ALL_VIRTUAL_TENANT_TABLESPACE_REAL_AGENT_ORA_TNAME = "ALL_VIRTUAL_TENANT_TABLESPACE_REAL_AGENT";
const char *const OB_ALL_VIRTUAL_TENANT_PROFILE_REAL_AGENT_ORA_TNAME = "ALL_VIRTUAL_TENANT_PROFILE_REAL_AGENT";
const char *const OB_ALL_VIRTUAL_TENANT_ROLE_GRANTEE_MAP_REAL_AGENT_ORA_TNAME = "ALL_VIRTUAL_TENANT_ROLE_GRANTEE_MAP_REAL_AGENT";
const char *const OB_ALL_VIRTUAL_TABLE_PRIVILEGE_REAL_AGENT_ORA_TNAME = "ALL_VIRTUAL_TABLE_PRIVILEGE_REAL_AGENT";
const char *const OB_ALL_VIRTUAL_TENANT_SECURITY_AUDIT_REAL_AGENT_ORA_TNAME = "ALL_VIRTUAL_TENANT_SECURITY_AUDIT_REAL_AGENT";
const char *const OB_ALL_VIRTUAL_TENANT_SECURITY_AUDIT_HISTORY_REAL_AGENT_ORA_TNAME = "ALL_VIRTUAL_TENANT_SECURITY_AUDIT_HISTORY_REAL_AGENT";
const char *const OB_ALL_VIRTUAL_TENANT_TRIGGER_REAL_AGENT_ORA_TNAME = "ALL_VIRTUAL_TENANT_TRIGGER_REAL_AGENT";
const char *const OB_ALL_VIRTUAL_TENANT_SECURITY_AUDIT_RECORD_REAL_AGENT_ORA_TNAME = "ALL_VIRTUAL_TENANT_SECURITY_AUDIT_RECORD_REAL_AGENT";
const char *const OB_ALL_VIRTUAL_TENANT_SYSAUTH_REAL_AGENT_ORA_TNAME = "ALL_VIRTUAL_TENANT_SYSAUTH_REAL_AGENT";
const char *const OB_ALL_VIRTUAL_TENANT_SYSAUTH_HISTORY_REAL_AGENT_ORA_TNAME = "ALL_VIRTUAL_TENANT_SYSAUTH_HISTORY_REAL_AGENT";
const char *const OB_ALL_VIRTUAL_TENANT_OBJAUTH_REAL_AGENT_ORA_TNAME = "ALL_VIRTUAL_TENANT_OBJAUTH_REAL_AGENT";
const char *const OB_ALL_VIRTUAL_TENANT_OBJAUTH_HISTORY_REAL_AGENT_ORA_TNAME = "ALL_VIRTUAL_TENANT_OBJAUTH_HISTORY_REAL_AGENT";
const char *const OB_ALL_VIRTUAL_TENANT_ERROR_REAL_AGENT_ORA_TNAME = "ALL_VIRTUAL_TENANT_ERROR_REAL_AGENT";
const char *const OB_ALL_VIRTUAL_DEF_SUB_PART_REAL_AGENT_ORA_TNAME = "ALL_VIRTUAL_DEF_SUB_PART_REAL_AGENT";
const char *const OB_ALL_VIRTUAL_TENANT_OBJECT_TYPE_REAL_AGENT_ORA_TNAME = "ALL_VIRTUAL_TENANT_OBJECT_TYPE_REAL_AGENT";
const char *const OB_ALL_VIRTUAL_DBLINK_REAL_AGENT_ORA_TNAME = "ALL_VIRTUAL_DBLINK_REAL_AGENT";
const char *const OB_ALL_VIRTUAL_DBLINK_HISTORY_REAL_AGENT_ORA_TNAME = "ALL_VIRTUAL_DBLINK_HISTORY_REAL_AGENT";
const char *const OB_ALL_VIRTUAL_TENANT_CONSTRAINT_COLUMN_REAL_AGENT_ORA_TNAME = "ALL_VIRTUAL_TENANT_CONSTRAINT_COLUMN_REAL_AGENT";
const char *const OB_ALL_VIRTUAL_TENANT_DEPENDENCY_REAL_AGENT_ORA_TNAME = "ALL_VIRTUAL_TENANT_DEPENDENCY_REAL_AGENT";
const char *const OB_ALL_VIRTUAL_TENANT_META_TABLE_REAL_AGENT_ORA_TNAME = "ALL_VIRTUAL_TENANT_META_TABLE_REAL_AGENT";
const char *const OB_ALL_VIRTUAL_TENANT_TIME_ZONE_REAL_AGENT_ORA_TNAME = "ALL_VIRTUAL_TENANT_TIME_ZONE_REAL_AGENT";
const char *const OB_ALL_VIRTUAL_TENANT_TIME_ZONE_NAME_REAL_AGENT_ORA_TNAME = "ALL_VIRTUAL_TENANT_TIME_ZONE_NAME_REAL_AGENT";
const char *const OB_ALL_VIRTUAL_TENANT_TIME_ZONE_TRANSITION_REAL_AGENT_ORA_TNAME = "ALL_VIRTUAL_TENANT_TIME_ZONE_TRANSITION_REAL_AGENT";
const char *const OB_ALL_VIRTUAL_TENANT_TIME_ZONE_TRANSITION_TYPE_REAL_AGENT_ORA_TNAME = "ALL_VIRTUAL_TENANT_TIME_ZONE_TRANSITION_TYPE_REAL_AGENT";
const char *const OB_ALL_VIRTUAL_RES_MGR_PLAN_REAL_AGENT_ORA_TNAME = "ALL_VIRTUAL_RES_MGR_PLAN_REAL_AGENT";
const char *const OB_ALL_VIRTUAL_RES_MGR_DIRECTIVE_REAL_AGENT_ORA_TNAME = "ALL_VIRTUAL_RES_MGR_DIRECTIVE_REAL_AGENT";
const char *const OB_ALL_VIRTUAL_TRANS_LOCK_STAT_ORA_TNAME = "ALL_VIRTUAL_TRANS_LOCK_STAT";
const char *const OB_ALL_VIRTUAL_RES_MGR_MAPPING_RULE_REAL_AGENT_ORA_TNAME = "ALL_VIRTUAL_RES_MGR_MAPPING_RULE_REAL_AGENT";
const char *const OB_ALL_VIRTUAL_RES_MGR_CONSUMER_GROUP_REAL_AGENT_ORA_TNAME = "ALL_VIRTUAL_RES_MGR_CONSUMER_GROUP_REAL_AGENT";
const char *const OB_GV_PLAN_CACHE_STAT_TNAME = "gv$plan_cache_stat";
const char *const OB_GV_PLAN_CACHE_PLAN_STAT_TNAME = "gv$plan_cache_plan_stat";
const char *const OB_SCHEMATA_TNAME = "SCHEMATA";
const char *const OB_CHARACTER_SETS_TNAME = "CHARACTER_SETS";
const char *const OB_GLOBAL_VARIABLES_TNAME = "GLOBAL_VARIABLES";
const char *const OB_STATISTICS_TNAME = "STATISTICS";
const char *const OB_VIEWS_TNAME = "VIEWS";
const char *const OB_TABLES_TNAME = "TABLES";
const char *const OB_COLLATIONS_TNAME = "COLLATIONS";
const char *const OB_COLLATION_CHARACTER_SET_APPLICABILITY_TNAME = "COLLATION_CHARACTER_SET_APPLICABILITY";
const char *const OB_PROCESSLIST_TNAME = "PROCESSLIST";
const char *const OB_KEY_COLUMN_USAGE_TNAME = "KEY_COLUMN_USAGE";
const char *const OB_DBA_OUTLINES_TNAME = "DBA_OUTLINES";
const char *const OB_ENGINES_TNAME = "ENGINES";
const char *const OB_ROUTINES_TNAME = "ROUTINES";
const char *const OB_GV_SESSION_EVENT_TNAME = "gv$session_event";
const char *const OB_GV_SESSION_WAIT_TNAME = "gv$session_wait";
const char *const OB_GV_SESSION_WAIT_HISTORY_TNAME = "gv$session_wait_history";
const char *const OB_GV_SYSTEM_EVENT_TNAME = "gv$system_event";
const char *const OB_GV_SESSTAT_TNAME = "gv$sesstat";
const char *const OB_GV_SYSSTAT_TNAME = "gv$sysstat";
const char *const OB_V_STATNAME_TNAME = "v$statname";
const char *const OB_V_EVENT_NAME_TNAME = "v$event_name";
const char *const OB_V_SESSION_EVENT_TNAME = "v$session_event";
const char *const OB_V_SESSION_WAIT_TNAME = "v$session_wait";
const char *const OB_V_SESSION_WAIT_HISTORY_TNAME = "v$session_wait_history";
const char *const OB_V_SESSTAT_TNAME = "v$sesstat";
const char *const OB_V_SYSSTAT_TNAME = "v$sysstat";
const char *const OB_V_SYSTEM_EVENT_TNAME = "v$system_event";
const char *const OB_GV_SQL_AUDIT_TNAME = "gv$sql_audit";
const char *const OB_GV_LATCH_TNAME = "gv$latch";
const char *const OB_GV_MEMORY_TNAME = "gv$memory";
const char *const OB_V_MEMORY_TNAME = "v$memory";
const char *const OB_GV_MEMSTORE_TNAME = "gv$memstore";
const char *const OB_V_MEMSTORE_TNAME = "v$memstore";
const char *const OB_GV_MEMSTORE_INFO_TNAME = "gv$memstore_info";
const char *const OB_V_MEMSTORE_INFO_TNAME = "v$memstore_info";
const char *const OB_V_PLAN_CACHE_STAT_TNAME = "v$plan_cache_stat";
const char *const OB_V_PLAN_CACHE_PLAN_STAT_TNAME = "v$plan_cache_plan_stat";
const char *const OB_GV_PLAN_CACHE_PLAN_EXPLAIN_TNAME = "gv$plan_cache_plan_explain";
const char *const OB_V_PLAN_CACHE_PLAN_EXPLAIN_TNAME = "v$plan_cache_plan_explain";
const char *const OB_V_SQL_AUDIT_TNAME = "v$sql_audit";
const char *const OB_V_LATCH_TNAME = "v$latch";
const char *const OB_GV_OBRPC_OUTGOING_TNAME = "gv$obrpc_outgoing";
const char *const OB_V_OBRPC_OUTGOING_TNAME = "v$obrpc_outgoing";
const char *const OB_GV_OBRPC_INCOMING_TNAME = "gv$obrpc_incoming";
const char *const OB_V_OBRPC_INCOMING_TNAME = "v$obrpc_incoming";
const char *const OB_GV_SQL_TNAME = "gv$sql";
const char *const OB_V_SQL_TNAME = "v$sql";
const char *const OB_GV_SQL_MONITOR_TNAME = "gv$sql_monitor";
const char *const OB_V_SQL_MONITOR_TNAME = "v$sql_monitor";
const char *const OB_GV_SQL_PLAN_MONITOR_TNAME = "gv$sql_plan_monitor";
const char *const OB_V_SQL_PLAN_MONITOR_TNAME = "v$sql_plan_monitor";
const char *const OB_USER_RECYCLEBIN_TNAME = "USER_RECYCLEBIN";
const char *const OB_GV_OUTLINE_TNAME = "gv$outline";
const char *const OB_GV_CONCURRENT_LIMIT_SQL_TNAME = "gv$concurrent_limit_sql";
const char *const OB_GV_SQL_PLAN_STATISTICS_TNAME = "gv$sql_plan_statistics";
const char *const OB_V_SQL_PLAN_STATISTICS_TNAME = "v$sql_plan_statistics";
const char *const OB_GV_SERVER_MEMSTORE_TNAME = "gv$server_memstore";
const char *const OB_GV_UNIT_LOAD_BALANCE_EVENT_HISTORY_TNAME = "gv$unit_load_balance_event_history";
const char *const OB_GV_TENANT_TNAME = "gv$tenant";
const char *const OB_GV_DATABASE_TNAME = "gv$database";
const char *const OB_GV_TABLE_TNAME = "gv$table";
const char *const OB_GV_UNIT_TNAME = "gv$unit";
const char *const OB_V_UNIT_TNAME = "v$unit";
const char *const OB_GV_PARTITION_TNAME = "gv$partition";
const char *const OB_V_PARTITION_TNAME = "v$partition";
const char *const OB_GV_LOCK_WAIT_STAT_TNAME = "gv$lock_wait_stat";
const char *const OB_V_LOCK_WAIT_STAT_TNAME = "v$lock_wait_stat";
const char *const OB_TIME_ZONE_TNAME = "time_zone";
const char *const OB_TIME_ZONE_NAME_TNAME = "time_zone_name";
const char *const OB_TIME_ZONE_TRANSITION_TNAME = "time_zone_transition";
const char *const OB_TIME_ZONE_TRANSITION_TYPE_TNAME = "time_zone_transition_type";
const char *const OB_GV_SESSION_LONGOPS_TNAME = "gv$session_longops";
const char *const OB_V_SESSION_LONGOPS_TNAME = "v$session_longops";
const char *const OB_GV_TENANT_MEMSTORE_ALLOCATOR_INFO_TNAME = "gv$tenant_memstore_allocator_info";
const char *const OB_V_TENANT_MEMSTORE_ALLOCATOR_INFO_TNAME = "v$tenant_memstore_allocator_info";
const char *const OB_GV_TENANT_SEQUENCE_OBJECT_TNAME = "gv$tenant_sequence_object";
const char *const OB_COLUMNS_TNAME = "COLUMNS";
const char *const OB_GV_MINOR_MERGE_INFO_TNAME = "gv$minor_merge_info";
const char *const OB_GV_TENANT_PX_WORKER_STAT_TNAME = "gv$tenant_px_worker_stat";
const char *const OB_V_TENANT_PX_WORKER_STAT_TNAME = "v$tenant_px_worker_stat";
const char *const OB_GV_PARTITION_AUDIT_TNAME = "gv$partition_audit";
const char *const OB_V_PARTITION_AUDIT_TNAME = "v$partition_audit";
const char *const OB_V_OB_CLUSTER_TNAME = "v$ob_cluster";
const char *const OB_GV_PS_STAT_TNAME = "gv$ps_stat";
const char *const OB_V_PS_STAT_TNAME = "v$ps_stat";
const char *const OB_GV_PS_ITEM_INFO_TNAME = "gv$ps_item_info";
const char *const OB_V_PS_ITEM_INFO_TNAME = "v$ps_item_info";
const char *const OB_GV_SQL_WORKAREA_TNAME = "gv$sql_workarea";
const char *const OB_V_SQL_WORKAREA_TNAME = "v$sql_workarea";
const char *const OB_GV_SQL_WORKAREA_ACTIVE_TNAME = "gv$sql_workarea_active";
const char *const OB_V_SQL_WORKAREA_ACTIVE_TNAME = "v$sql_workarea_active";
const char *const OB_GV_SQL_WORKAREA_HISTOGRAM_TNAME = "gv$sql_workarea_histogram";
const char *const OB_V_SQL_WORKAREA_HISTOGRAM_TNAME = "v$sql_workarea_histogram";
const char *const OB_GV_OB_SQL_WORKAREA_MEMORY_INFO_TNAME = "gv$ob_sql_workarea_memory_info";
const char *const OB_V_OB_SQL_WORKAREA_MEMORY_INFO_TNAME = "v$ob_sql_workarea_memory_info";
const char *const OB_GV_PLAN_CACHE_REFERENCE_INFO_TNAME = "gv$plan_cache_reference_info";
const char *const OB_V_PLAN_CACHE_REFERENCE_INFO_TNAME = "v$plan_cache_reference_info";
const char *const OB_V_OB_TIMESTAMP_SERVICE_TNAME = "v$ob_timestamp_service";
const char *const OB_GV_SSTABLE_TNAME = "gv$sstable";
const char *const OB_V_SSTABLE_TNAME = "v$sstable";
const char *const OB_CDB_OB_BACKUP_ARCHIVELOG_SUMMARY_TNAME = "CDB_OB_BACKUP_ARCHIVELOG_SUMMARY";
const char *const OB_CDB_OB_BACKUP_JOB_DETAILS_TNAME = "CDB_OB_BACKUP_JOB_DETAILS";
const char *const OB_CDB_OB_BACKUP_SET_DETAILS_TNAME = "CDB_OB_BACKUP_SET_DETAILS";
const char *const OB_CDB_OB_BACKUP_SET_EXPIRED_TNAME = "CDB_OB_BACKUP_SET_EXPIRED";
const char *const OB_CDB_OB_BACKUP_PROGRESS_TNAME = "CDB_OB_BACKUP_PROGRESS";
const char *const OB_CDB_OB_BACKUP_ARCHIVELOG_PROGRESS_TNAME = "CDB_OB_BACKUP_ARCHIVELOG_PROGRESS";
const char *const OB_CDB_OB_BACKUP_CLEAN_HISTORY_TNAME = "CDB_OB_BACKUP_CLEAN_HISTORY";
const char *const OB_CDB_OB_BACKUP_TASK_CLEAN_HISTORY_TNAME = "CDB_OB_BACKUP_TASK_CLEAN_HISTORY";
const char *const OB_CDB_OB_RESTORE_PROGRESS_TNAME = "CDB_OB_RESTORE_PROGRESS";
const char *const OB_CDB_OB_RESTORE_HISTORY_TNAME = "CDB_OB_RESTORE_HISTORY";
const char *const OB_GV_SERVER_SCHEMA_INFO_TNAME = "gv$server_schema_info";
const char *const OB_V_SERVER_SCHEMA_INFO_TNAME = "v$server_schema_info";
const char *const OB_CDB_CKPT_HISTORY_TNAME = "CDB_CKPT_HISTORY";
const char *const OB_GV_OB_TRANS_TABLE_STATUS_TNAME = "gv$ob_trans_table_status";
const char *const OB_V_OB_TRANS_TABLE_STATUS_TNAME = "v$ob_trans_table_status";
const char *const OB_V_SQL_MONITOR_STATNAME_TNAME = "v$sql_monitor_statname";
const char *const OB_GV_MERGE_INFO_TNAME = "gv$merge_info";
const char *const OB_V_MERGE_INFO_TNAME = "v$merge_info";
const char *const OB_GV_LOCK_TNAME = "gv$lock";
const char *const OB_V_LOCK_TNAME = "v$lock";
const char *const OB_CDB_OB_BACKUP_VALIDATION_JOB_TNAME = "CDB_OB_BACKUP_VALIDATION_JOB";
const char *const OB_CDB_OB_BACKUP_VALIDATION_JOB_HISTORY_TNAME = "CDB_OB_BACKUP_VALIDATION_JOB_HISTORY";
const char *const OB_CDB_OB_TENANT_BACKUP_VALIDATION_TASK_TNAME = "CDB_OB_TENANT_BACKUP_VALIDATION_TASK";
const char *const OB_CDB_OB_BACKUP_VALIDATION_TASK_HISTORY_TNAME = "CDB_OB_BACKUP_VALIDATION_TASK_HISTORY";
const char *const OB_V_RESTORE_POINT_TNAME = "v$restore_point";
const char *const OB_CDB_OB_BACKUP_SET_OBSOLETE_TNAME = "CDB_OB_BACKUP_SET_OBSOLETE";
const char *const OB_CDB_OB_BACKUP_BACKUPSET_JOB_TNAME = "CDB_OB_BACKUP_BACKUPSET_JOB";
const char *const OB_CDB_OB_BACKUP_BACKUPSET_JOB_HISTORY_TNAME = "CDB_OB_BACKUP_BACKUPSET_JOB_HISTORY";
const char *const OB_CDB_OB_BACKUP_BACKUPSET_TASK_TNAME = "CDB_OB_BACKUP_BACKUPSET_TASK";
const char *const OB_CDB_OB_BACKUP_BACKUPSET_TASK_HISTORY_TNAME = "CDB_OB_BACKUP_BACKUPSET_TASK_HISTORY";
const char *const OB_CDB_OB_BACKUP_BACKUP_ARCHIVELOG_SUMMARY_TNAME = "CDB_OB_BACKUP_BACKUP_ARCHIVELOG_SUMMARY";
const char *const OB_DBA_SYNONYMS_TNAME = "DBA_SYNONYMS";
const char *const OB_DBA_OBJECTS_TNAME = "DBA_OBJECTS";
const char *const OB_ALL_OBJECTS_TNAME = "ALL_OBJECTS";
const char *const OB_USER_OBJECTS_TNAME = "USER_OBJECTS";
const char *const OB_DBA_SEQUENCES_TNAME = "DBA_SEQUENCES";
const char *const OB_ALL_SEQUENCES_TNAME = "ALL_SEQUENCES";
const char *const OB_USER_SEQUENCES_TNAME = "USER_SEQUENCES";
const char *const OB_DBA_USERS_TNAME = "DBA_USERS";
const char *const OB_ALL_USERS_TNAME = "ALL_USERS";
const char *const OB_ALL_SYNONYMS_TNAME = "ALL_SYNONYMS";
const char *const OB_USER_SYNONYMS_TNAME = "USER_SYNONYMS";
const char *const OB_DBA_IND_COLUMNS_TNAME = "DBA_IND_COLUMNS";
const char *const OB_ALL_IND_COLUMNS_TNAME = "ALL_IND_COLUMNS";
const char *const OB_USER_IND_COLUMNS_TNAME = "USER_IND_COLUMNS";
const char *const OB_DBA_CONSTRAINTS_TNAME = "DBA_CONSTRAINTS";
const char *const OB_ALL_CONSTRAINTS_TNAME = "ALL_CONSTRAINTS";
const char *const OB_USER_CONSTRAINTS_TNAME = "USER_CONSTRAINTS";
const char *const OB_ALL_TAB_COLS_V_TNAME = "ALL_TAB_COLS_V$";
const char *const OB_DBA_TAB_COLS_V_TNAME = "DBA_TAB_COLS_V$";
const char *const OB_USER_TAB_COLS_V_TNAME = "USER_TAB_COLS_V$";
const char *const OB_ALL_TAB_COLS_TNAME = "ALL_TAB_COLS";
const char *const OB_DBA_TAB_COLS_TNAME = "DBA_TAB_COLS";
const char *const OB_USER_TAB_COLS_TNAME = "USER_TAB_COLS";
const char *const OB_ALL_TAB_COLUMNS_TNAME = "ALL_TAB_COLUMNS";
const char *const OB_DBA_TAB_COLUMNS_TNAME = "DBA_TAB_COLUMNS";
const char *const OB_USER_TAB_COLUMNS_TNAME = "USER_TAB_COLUMNS";
const char *const OB_ALL_TABLES_TNAME = "ALL_TABLES";
const char *const OB_DBA_TABLES_TNAME = "DBA_TABLES";
const char *const OB_USER_TABLES_TNAME = "USER_TABLES";
const char *const OB_DBA_TAB_COMMENTS_TNAME = "DBA_TAB_COMMENTS";
const char *const OB_ALL_TAB_COMMENTS_TNAME = "ALL_TAB_COMMENTS";
const char *const OB_USER_TAB_COMMENTS_TNAME = "USER_TAB_COMMENTS";
const char *const OB_DBA_COL_COMMENTS_TNAME = "DBA_COL_COMMENTS";
const char *const OB_ALL_COL_COMMENTS_TNAME = "ALL_COL_COMMENTS";
const char *const OB_USER_COL_COMMENTS_TNAME = "USER_COL_COMMENTS";
const char *const OB_DBA_INDEXES_TNAME = "DBA_INDEXES";
const char *const OB_ALL_INDEXES_TNAME = "ALL_INDEXES";
const char *const OB_USER_INDEXES_TNAME = "USER_INDEXES";
const char *const OB_DBA_CONS_COLUMNS_TNAME = "DBA_CONS_COLUMNS";
const char *const OB_ALL_CONS_COLUMNS_TNAME = "ALL_CONS_COLUMNS";
const char *const OB_USER_CONS_COLUMNS_TNAME = "USER_CONS_COLUMNS";
const char *const OB_USER_SEGMENTS_TNAME = "USER_SEGMENTS";
const char *const OB_DBA_SEGMENTS_TNAME = "DBA_SEGMENTS";
const char *const OB_DBA_TYPES_TNAME = "DBA_TYPES";
const char *const OB_ALL_TYPES_TNAME = "ALL_TYPES";
const char *const OB_USER_TYPES_TNAME = "USER_TYPES";
const char *const OB_DBA_TYPE_ATTRS_TNAME = "DBA_TYPE_ATTRS";
const char *const OB_ALL_TYPE_ATTRS_TNAME = "ALL_TYPE_ATTRS";
const char *const OB_USER_TYPE_ATTRS_TNAME = "USER_TYPE_ATTRS";
const char *const OB_DBA_COLL_TYPES_TNAME = "DBA_COLL_TYPES";
const char *const OB_ALL_COLL_TYPES_TNAME = "ALL_COLL_TYPES";
const char *const OB_USER_COLL_TYPES_TNAME = "USER_COLL_TYPES";
const char *const OB_DBA_PROCEDURES_TNAME = "DBA_PROCEDURES";
const char *const OB_DBA_ARGUMENTS_TNAME = "DBA_ARGUMENTS";
const char *const OB_DBA_SOURCE_TNAME = "DBA_SOURCE";
const char *const OB_ALL_PROCEDURES_TNAME = "ALL_PROCEDURES";
const char *const OB_ALL_ARGUMENTS_TNAME = "ALL_ARGUMENTS";
const char *const OB_ALL_SOURCE_TNAME = "ALL_SOURCE";
const char *const OB_USER_PROCEDURES_TNAME = "USER_PROCEDURES";
const char *const OB_USER_ARGUMENTS_TNAME = "USER_ARGUMENTS";
const char *const OB_USER_SOURCE_TNAME = "USER_SOURCE";
const char *const OB_DBA_PART_KEY_COLUMNS_TNAME = "DBA_PART_KEY_COLUMNS";
const char *const OB_ALL_PART_KEY_COLUMNS_TNAME = "ALL_PART_KEY_COLUMNS";
const char *const OB_USER_PART_KEY_COLUMNS_TNAME = "USER_PART_KEY_COLUMNS";
const char *const OB_DBA_SUBPART_KEY_COLUMNS_TNAME = "DBA_SUBPART_KEY_COLUMNS";
const char *const OB_ALL_SUBPART_KEY_COLUMNS_TNAME = "ALL_SUBPART_KEY_COLUMNS";
const char *const OB_USER_SUBPART_KEY_COLUMNS_TNAME = "USER_SUBPART_KEY_COLUMNS";
const char *const OB_DBA_VIEWS_TNAME = "DBA_VIEWS";
const char *const OB_ALL_VIEWS_TNAME = "ALL_VIEWS";
const char *const OB_USER_VIEWS_TNAME = "USER_VIEWS";
const char *const OB_ALL_TAB_PARTITIONS_ORA_TNAME = "ALL_TAB_PARTITIONS";
const char *const OB_ALL_TAB_SUBPARTITIONS_ORA_TNAME = "ALL_TAB_SUBPARTITIONS";
const char *const OB_ALL_PART_TABLES_ORA_TNAME = "ALL_PART_TABLES";
const char *const OB_DBA_PART_TABLES_ORA_TNAME = "DBA_PART_TABLES";
const char *const OB_USER_PART_TABLES_ORA_TNAME = "USER_PART_TABLES";
const char *const OB_DBA_TAB_PARTITIONS_ORA_TNAME = "DBA_TAB_PARTITIONS";
const char *const OB_USER_TAB_PARTITIONS_ORA_TNAME = "USER_TAB_PARTITIONS";
const char *const OB_DBA_TAB_SUBPARTITIONS_ORA_TNAME = "DBA_TAB_SUBPARTITIONS";
const char *const OB_USER_TAB_SUBPARTITIONS_ORA_TNAME = "USER_TAB_SUBPARTITIONS";
const char *const OB_DBA_SUBPARTITION_TEMPLATES_ORA_TNAME = "DBA_SUBPARTITION_TEMPLATES";
const char *const OB_ALL_SUBPARTITION_TEMPLATES_ORA_TNAME = "ALL_SUBPARTITION_TEMPLATES";
const char *const OB_USER_SUBPARTITION_TEMPLATES_ORA_TNAME = "USER_SUBPARTITION_TEMPLATES";
const char *const OB_DBA_PART_INDEXES_TNAME = "DBA_PART_INDEXES";
const char *const OB_ALL_PART_INDEXES_TNAME = "ALL_PART_INDEXES";
const char *const OB_USER_PART_INDEXES_TNAME = "USER_PART_INDEXES";
const char *const OB_ALL_ALL_TABLES_ORA_TNAME = "ALL_ALL_TABLES";
const char *const OB_DBA_ALL_TABLES_ORA_TNAME = "DBA_ALL_TABLES";
const char *const OB_USER_ALL_TABLES_ORA_TNAME = "USER_ALL_TABLES";
const char *const OB_DBA_PROFILES_ORA_TNAME = "DBA_PROFILES";
const char *const OB_USER_PROFILES_ORA_TNAME = "USER_PROFILES";
const char *const OB_ALL_PROFILES_ORA_TNAME = "ALL_PROFILES";
const char *const OB_ALL_MVIEW_COMMENTS_ORA_TNAME = "ALL_MVIEW_COMMENTS";
const char *const OB_USER_MVIEW_COMMENTS_ORA_TNAME = "USER_MVIEW_COMMENTS";
const char *const OB_DBA_MVIEW_COMMENTS_ORA_TNAME = "DBA_MVIEW_COMMENTS";
const char *const OB_ALL_SCHEDULER_PROGRAM_ARGS_ORA_TNAME = "ALL_SCHEDULER_PROGRAM_ARGS";
const char *const OB_DBA_SCHEDULER_PROGRAM_ARGS_ORA_TNAME = "DBA_SCHEDULER_PROGRAM_ARGS";
const char *const OB_USER_SCHEDULER_PROGRAM_ARGS_ORA_TNAME = "USER_SCHEDULER_PROGRAM_ARGS";
const char *const OB_ALL_SCHEDULER_JOB_ARGS_ORA_TNAME = "ALL_SCHEDULER_JOB_ARGS";
const char *const OB_DBA_SCHEDULER_JOB_ARGS_ORA_TNAME = "DBA_SCHEDULER_JOB_ARGS";
const char *const OB_USER_SCHEDULER_JOB_ARGS_ORA_TNAME = "USER_SCHEDULER_JOB_ARGS";
const char *const OB_ALL_ERRORS_ORA_TNAME = "ALL_ERRORS";
const char *const OB_DBA_ERRORS_ORA_TNAME = "DBA_ERRORS";
const char *const OB_USER_ERRORS_ORA_TNAME = "USER_ERRORS";
const char *const OB_ALL_TYPE_METHODS_ORA_TNAME = "ALL_TYPE_METHODS";
const char *const OB_DBA_TYPE_METHODS_ORA_TNAME = "DBA_TYPE_METHODS";
const char *const OB_USER_TYPE_METHODS_ORA_TNAME = "USER_TYPE_METHODS";
const char *const OB_ALL_METHOD_PARAMS_ORA_TNAME = "ALL_METHOD_PARAMS";
const char *const OB_DBA_METHOD_PARAMS_ORA_TNAME = "DBA_METHOD_PARAMS";
const char *const OB_USER_METHOD_PARAMS_ORA_TNAME = "USER_METHOD_PARAMS";
const char *const OB_DBA_TABLESPACES_ORA_TNAME = "DBA_TABLESPACES";
const char *const OB_USER_TABLESPACES_ORA_TNAME = "USER_TABLESPACES";
const char *const OB_DBA_IND_EXPRESSIONS_TNAME = "DBA_IND_EXPRESSIONS";
const char *const OB_USER_IND_EXPRESSIONS_TNAME = "USER_IND_EXPRESSIONS";
const char *const OB_ALL_IND_EXPRESSIONS_TNAME = "ALL_IND_EXPRESSIONS";
const char *const OB_ALL_IND_PARTITIONS_TNAME = "ALL_IND_PARTITIONS";
const char *const OB_USER_IND_PARTITIONS_TNAME = "USER_IND_PARTITIONS";
const char *const OB_DBA_IND_PARTITIONS_TNAME = "DBA_IND_PARTITIONS";
const char *const OB_DBA_IND_SUBPARTITIONS_TNAME = "DBA_IND_SUBPARTITIONS";
const char *const OB_ALL_IND_SUBPARTITIONS_TNAME = "ALL_IND_SUBPARTITIONS";
const char *const OB_USER_IND_SUBPARTITIONS_TNAME = "USER_IND_SUBPARTITIONS";
const char *const OB_DBA_ROLES_TNAME = "DBA_ROLES";
const char *const OB_DBA_ROLE_PRIVS_TNAME = "DBA_ROLE_PRIVS";
const char *const OB_USER_ROLE_PRIVS_TNAME = "USER_ROLE_PRIVS";
const char *const OB_DBA_TAB_PRIVS_TNAME = "DBA_TAB_PRIVS";
const char *const OB_ALL_TAB_PRIVS_TNAME = "ALL_TAB_PRIVS";
const char *const OB_USER_TAB_PRIVS_TNAME = "USER_TAB_PRIVS";
const char *const OB_DBA_SYS_PRIVS_TNAME = "DBA_SYS_PRIVS";
const char *const OB_USER_SYS_PRIVS_TNAME = "USER_SYS_PRIVS";
const char *const OB_DBA_COL_PRIVS_ORA_TNAME = "DBA_COL_PRIVS";
const char *const OB_USER_COL_PRIVS_ORA_TNAME = "USER_COL_PRIVS";
const char *const OB_ALL_COL_PRIVS_ORA_TNAME = "ALL_COL_PRIVS";
const char *const OB_ROLE_TAB_PRIVS_ORA_TNAME = "ROLE_TAB_PRIVS";
const char *const OB_ROLE_SYS_PRIVS_ORA_TNAME = "ROLE_SYS_PRIVS";
const char *const OB_ROLE_ROLE_PRIVS_ORA_TNAME = "ROLE_ROLE_PRIVS";
const char *const OB_DICTIONARY_ORA_TNAME = "DICTIONARY";
const char *const OB_DICT_ORA_TNAME = "DICT";
const char *const OB_ALL_TRIGGERS_TNAME = "ALL_TRIGGERS";
const char *const OB_DBA_TRIGGERS_TNAME = "DBA_TRIGGERS";
const char *const OB_USER_TRIGGERS_TNAME = "USER_TRIGGERS";
const char *const OB_ALL_DEPENDENCIES_ORA_TNAME = "ALL_DEPENDENCIES";
const char *const OB_DBA_DEPENDENCIES_ORA_TNAME = "DBA_DEPENDENCIES";
const char *const OB_USER_DEPENDENCIES_ORA_TNAME = "USER_DEPENDENCIES";
const char *const OB_DBA_RSRC_PLANS_TNAME = "DBA_RSRC_PLANS";
const char *const OB_DBA_RSRC_PLAN_DIRECTIVES_TNAME = "DBA_RSRC_PLAN_DIRECTIVES";
const char *const OB_DBA_RSRC_GROUP_MAPPINGS_TNAME = "DBA_RSRC_GROUP_MAPPINGS";
const char *const OB_DBA_RECYCLEBIN_ORA_TNAME = "DBA_RECYCLEBIN";
const char *const OB_USER_RECYCLEBIN_ORA_TNAME = "USER_RECYCLEBIN";
const char *const OB_DBA_RSRC_CONSUMER_GROUPS_TNAME = "DBA_RSRC_CONSUMER_GROUPS";
const char *const OB_GV_OUTLINE_ORA_TNAME = "GV$OUTLINE";
const char *const OB_GV_SQL_AUDIT_ORA_TNAME = "GV$SQL_AUDIT";
const char *const OB_V_SQL_AUDIT_ORA_TNAME = "V$SQL_AUDIT";
const char *const OB_GV_INSTANCE_TNAME = "GV$INSTANCE";
const char *const OB_V_INSTANCE_TNAME = "V$INSTANCE";
const char *const OB_GV_PLAN_CACHE_PLAN_STAT_ORA_TNAME = "GV$PLAN_CACHE_PLAN_STAT";
const char *const OB_V_PLAN_CACHE_PLAN_STAT_ORA_TNAME = "V$PLAN_CACHE_PLAN_STAT";
const char *const OB_GV_PLAN_CACHE_PLAN_EXPLAIN_ORA_TNAME = "GV$PLAN_CACHE_PLAN_EXPLAIN";
const char *const OB_V_PLAN_CACHE_PLAN_EXPLAIN_ORA_TNAME = "V$PLAN_CACHE_PLAN_EXPLAIN";
const char *const OB_GV_SESSION_WAIT_ORA_TNAME = "GV$SESSION_WAIT";
const char *const OB_V_SESSION_WAIT_ORA_TNAME = "V$SESSION_WAIT";
const char *const OB_GV_SESSION_WAIT_HISTORY_ORA_TNAME = "GV$SESSION_WAIT_HISTORY";
const char *const OB_V_SESSION_WAIT_HISTORY_ORA_TNAME = "V$SESSION_WAIT_HISTORY";
const char *const OB_GV_MEMORY_ORA_TNAME = "GV$MEMORY";
const char *const OB_V_MEMORY_ORA_TNAME = "V$MEMORY";
const char *const OB_GV_MEMSTORE_ORA_TNAME = "GV$MEMSTORE";
const char *const OB_V_MEMSTORE_ORA_TNAME = "V$MEMSTORE";
const char *const OB_GV_MEMSTORE_INFO_ORA_TNAME = "GV$MEMSTORE_INFO";
const char *const OB_V_MEMSTORE_INFO_ORA_TNAME = "V$MEMSTORE_INFO";
const char *const OB_GV_SERVER_MEMSTORE_ORA_TNAME = "GV$SERVER_MEMSTORE";
const char *const OB_GV_SESSTAT_ORA_TNAME = "GV$SESSTAT";
const char *const OB_V_SESSTAT_ORA_TNAME = "V$SESSTAT";
const char *const OB_GV_SYSSTAT_ORA_TNAME = "GV$SYSSTAT";
const char *const OB_V_SYSSTAT_ORA_TNAME = "V$SYSSTAT";
const char *const OB_GV_SYSTEM_EVENT_ORA_TNAME = "GV$SYSTEM_EVENT";
const char *const OB_V_SYSTEM_EVENT_ORA_TNAME = "V$SYSTEM_EVENT";
const char *const OB_GV_TENANT_MEMSTORE_ALLOCATOR_INFO_ORA_TNAME = "GV$TENANT_MEMSTORE_ALLOCATOR_INFO";
const char *const OB_V_TENANT_MEMSTORE_ALLOCATOR_INFO_ORA_TNAME = "V$TENANT_MEMSTORE_ALLOCATOR_INFO";
const char *const OB_GV_PLAN_CACHE_STAT_ORA_TNAME = "GV$PLAN_CACHE_STAT";
const char *const OB_V_PLAN_CACHE_STAT_ORA_TNAME = "V$PLAN_CACHE_STAT";
const char *const OB_GV_CONCURRENT_LIMIT_SQL_ORA_TNAME = "GV$CONCURRENT_LIMIT_SQL";
const char *const OB_NLS_SESSION_PARAMETERS_ORA_TNAME = "NLS_SESSION_PARAMETERS";
const char *const OB_NLS_INSTANCE_PARAMETERS_ORA_TNAME = "NLS_INSTANCE_PARAMETERS";
const char *const OB_NLS_DATABASE_PARAMETERS_ORA_TNAME = "NLS_DATABASE_PARAMETERS";
const char *const OB_V_NLS_PARAMETERS_ORA_TNAME = "V$NLS_PARAMETERS";
const char *const OB_V_VERSION_ORA_TNAME = "V$VERSION";
const char *const OB_GV_TENANT_PX_WORKER_STAT_ORA_TNAME = "GV$TENANT_PX_WORKER_STAT";
const char *const OB_V_TENANT_PX_WORKER_STAT_ORA_TNAME = "V$TENANT_PX_WORKER_STAT";
const char *const OB_GV_PS_STAT_ORA_TNAME = "GV$PS_STAT";
const char *const OB_V_PS_STAT_ORA_TNAME = "V$PS_STAT";
const char *const OB_GV_PS_ITEM_INFO_ORA_TNAME = "GV$PS_ITEM_INFO";
const char *const OB_V_PS_ITEM_INFO_ORA_TNAME = "V$PS_ITEM_INFO";
const char *const OB_GV_SQL_WORKAREA_ACTIVE_ORA_TNAME = "GV$SQL_WORKAREA_ACTIVE";
const char *const OB_V_SQL_WORKAREA_ACTIVE_ORA_TNAME = "V$SQL_WORKAREA_ACTIVE";
const char *const OB_GV_SQL_WORKAREA_HISTOGRAM_ORA_TNAME = "GV$SQL_WORKAREA_HISTOGRAM";
const char *const OB_V_SQL_WORKAREA_HISTOGRAM_ORA_TNAME = "V$SQL_WORKAREA_HISTOGRAM";
const char *const OB_GV_OB_SQL_WORKAREA_MEMORY_INFO_ORA_TNAME = "GV$OB_SQL_WORKAREA_MEMORY_INFO";
const char *const OB_V_OB_SQL_WORKAREA_MEMORY_INFO_ORA_TNAME = "V$OB_SQL_WORKAREA_MEMORY_INFO";
const char *const OB_GV_PLAN_CACHE_REFERENCE_INFO_ORA_TNAME = "GV$PLAN_CACHE_REFERENCE_INFO";
const char *const OB_V_PLAN_CACHE_REFERENCE_INFO_ORA_TNAME = "V$PLAN_CACHE_REFERENCE_INFO";
const char *const OB_GV_SQL_WORKAREA_ORA_TNAME = "GV$SQL_WORKAREA";
const char *const OB_V_SQL_WORKAREA_ORA_TNAME = "V$SQL_WORKAREA";
const char *const OB_GV_SSTABLE_ORA_TNAME = "GV$SSTABLE";
const char *const OB_V_SSTABLE_ORA_TNAME = "V$SSTABLE";
const char *const OB_GV_SERVER_SCHEMA_INFO_ORA_TNAME = "GV$SERVER_SCHEMA_INFO";
const char *const OB_V_SERVER_SCHEMA_INFO_ORA_TNAME = "V$SERVER_SCHEMA_INFO";
const char *const OB_GV_SQL_PLAN_MONITOR_ORA_TNAME = "GV$SQL_PLAN_MONITOR";
const char *const OB_V_SQL_PLAN_MONITOR_ORA_TNAME = "V$SQL_PLAN_MONITOR";
const char *const OB_V_SQL_MONITOR_STATNAME_ORA_TNAME = "V$SQL_MONITOR_STATNAME";
const char *const OB_GV_LOCK_ORA_TNAME = "GV$LOCK";
const char *const OB_V_LOCK_ORA_TNAME = "V$LOCK";
const char *const OB_GV_OPEN_CURSOR_ORA_TNAME = "GV$OPEN_CURSOR";
const char *const OB_V_OPEN_CURSOR_ORA_TNAME = "V$OPEN_CURSOR";
const char *const OB_V_TIMEZONE_NAMES_ORA_TNAME = "V$TIMEZONE_NAMES";
const char *const OB_GV_GLOBAL_TRANSACTION_ORA_TNAME = "GV$GLOBAL_TRANSACTION";
const char *const OB_V_GLOBAL_TRANSACTION_ORA_TNAME = "V$GLOBAL_TRANSACTION";
const char *const OB_V_RESTORE_POINT_ORA_TNAME = "V$RESTORE_POINT";
const char *const OB_V_RSRC_PLAN_ORA_TNAME = "V$RSRC_PLAN";
const char *const OB_TRIGGERS_TNAME = "TRIGGERS";
const char *const OB_ALL_TABLE_V2_HISTORY_IDX_DATA_TABLE_ID_TNAME = "__idx_1099511628058_idx_data_table_id";
const char *const OB_ALL_TABLE_HISTORY_IDX_DATA_TABLE_ID_TNAME = "__idx_1099511627890_idx_data_table_id";
const char *const OB_ALL_VIRTUAL_PLAN_CACHE_STAT_ALL_VIRTUAL_PLAN_CACHE_STAT_I1_TNAME = "__idx_1099511638779_all_virtual_plan_cache_stat_i1";
const char *const OB_ALL_VIRTUAL_SESSION_EVENT_ALL_VIRTUAL_SESSION_EVENT_I1_TNAME = "__idx_1099511638789_all_virtual_session_event_i1";
const char *const OB_ALL_VIRTUAL_SESSION_WAIT_ALL_VIRTUAL_SESSION_WAIT_I1_TNAME = "__idx_1099511638790_all_virtual_session_wait_i1";
const char *const OB_ALL_VIRTUAL_SESSION_WAIT_HISTORY_ALL_VIRTUAL_SESSION_WAIT_HISTORY_I1_TNAME = "__idx_1099511638791_all_virtual_session_wait_history_i1";
const char *const OB_ALL_VIRTUAL_SYSTEM_EVENT_ALL_VIRTUAL_SYSTEM_EVENT_I1_TNAME = "__idx_1099511638793_all_virtual_system_event_i1";
const char *const OB_ALL_VIRTUAL_SESSTAT_ALL_VIRTUAL_SESSTAT_I1_TNAME = "__idx_1099511638796_all_virtual_sesstat_i1";
const char *const OB_ALL_VIRTUAL_SYSSTAT_ALL_VIRTUAL_SYSSTAT_I1_TNAME = "__idx_1099511638797_all_virtual_sysstat_i1";
const char *const OB_ALL_VIRTUAL_SQL_AUDIT_ALL_VIRTUAL_SQL_AUDIT_I1_TNAME = "__idx_1099511638807_all_virtual_sql_audit_i1";
const char *const OB_ALL_VIRTUAL_REPLICA_TASK_ALL_VIRTUAL_REPLICA_TASK_I1_TNAME = "__idx_1099511639791_all_virtual_replica_task_i1";
const char *const OB_ALL_VIRTUAL_SQL_PLAN_MONITOR_ALL_VIRTUAL_SQL_PLAN_MONITOR_I1_TNAME = "__idx_1099511639961_all_virtual_sql_plan_monitor_i1";
const char *const OB_ALL_VIRTUAL_SQL_AUDIT_ORA_ALL_VIRTUAL_SQL_AUDIT_I1_TNAME = "__idx_1099511642785_all_virtual_sql_audit_i1";
const char *const OB_ALL_VIRTUAL_PLAN_CACHE_STAT_ORA_ALL_VIRTUAL_PLAN_CACHE_STAT_I1_TNAME = "__idx_1099511642810_all_virtual_plan_cache_stat_i1";
const char *const OB_ALL_VIRTUAL_SESSION_WAIT_ORA_ALL_VIRTUAL_SESSION_WAIT_I1_TNAME = "__idx_1099511642812_all_virtual_session_wait_i1";
const char *const OB_ALL_VIRTUAL_SESSION_WAIT_HISTORY_ORA_ALL_VIRTUAL_SESSION_WAIT_HISTORY_I1_TNAME = "__idx_1099511642813_all_virtual_session_wait_history_i1";
const char *const OB_ALL_VIRTUAL_SESSTAT_ORA_ALL_VIRTUAL_SESSTAT_I1_TNAME = "__idx_1099511642818_all_virtual_sesstat_i1";
const char *const OB_ALL_VIRTUAL_SYSSTAT_ORA_ALL_VIRTUAL_SYSSTAT_I1_TNAME = "__idx_1099511642819_all_virtual_sysstat_i1";
const char *const OB_ALL_VIRTUAL_SYSTEM_EVENT_ORA_ALL_VIRTUAL_SYSTEM_EVENT_I1_TNAME = "__idx_1099511642820_all_virtual_system_event_i1";
const char *const OB_ALL_VIRTUAL_SQL_PLAN_MONITOR_ORA_ALL_VIRTUAL_SQL_PLAN_MONITOR_I1_TNAME = "__idx_1099511642876_all_virtual_sql_plan_monitor_i1";

// initial data for __all_privilege
struct PrivilegeRow {
  const char *privilege_;
  const char *context_;
  const char *comment_;
};

  const char* const ALTER_TB_MSG = "To alter the table";
  const char* const CREATE_DB_TB_MSG = "To create new databases and tables";
  const char* const CREATE_VIEW_MSG = "To create new views";
  const char* const CREATE_USER_MSG = "To create new users";
  const char* const DELETE_ROWS_MSG = "To delete existing rows";
  const char* const DROP_DB_TB_VIEWS_MSG = "To drop databases, tables, and views";
  const char* const GRANT_OPTION_MSG = "To give to other users those privileges you possess";
  const char* const INDEX_MSG = "To create or drop indexes";
  const char* const INSERT_MSG = "To insert data into tables";
  const char* const PROCESS_MSG = "To view the plain text of currently executing queries";
  const char* const SELECT_MSG = "To retrieve rows from table";
  const char* const SHOW_DB_MSG = "To see all databases with SHOW DATABASES";
  const char* const SHOW_VIEW_MSG = "To see views with SHOW CREATE VIEW";
  const char* const SUPER_MSG = "To use KILL thread, SET GLOBAL, CHANGE MASTER, etc.";
  const char* const UPDATE_MSG = "To update existing rows";
  const char* const USAGE_MSG = "No privileges - allow connect only";
static const PrivilegeRow all_privileges[] =
{
  {"Alter", "Tables",  ALTER_TB_MSG},
  {"Create", "Databases,Tables,Indexes",  CREATE_DB_TB_MSG},
  {"Create view", "Tables",  CREATE_VIEW_MSG},
  {"Create user", "Server Admin",  CREATE_USER_MSG},
  {"Delete", "Tables",  DELETE_ROWS_MSG},
  {"Drop", "Databases,Tables", DROP_DB_TB_VIEWS_MSG},
  {"Grant option",  "Databases,Tables,Functions,Procedures", GRANT_OPTION_MSG},
  {"Index", "Tables",  INDEX_MSG},
  {"Insert", "Tables",  INSERT_MSG},
  {"Process", "Server Admin", PROCESS_MSG},
  {"Select", "Tables",  SELECT_MSG},
  {"Show databases","Server Admin", SHOW_DB_MSG},
  {"Show view","Tables", SHOW_VIEW_MSG},
  {"Super","Server Admin", SUPER_MSG},
  {"Update", "Tables",  UPDATE_MSG},
  {"Usage","Server Admin",USAGE_MSG},
  {NULL, NULL, NULL},
};

} // end namespace share
} // end namespace oceanbase
#endif /* _OB_INNER_TABLE_SCHEMA_CONSTANTS_H_ */
